
#ifndef __DEBUG_PLUGINS_COMPLETION_COMPLETION_H__
#define __DEBUG_PLUGINS_COMPLETION_COMPLETION_H__

#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <valide-0.0.h>
#include <gee.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixdata.h>

G_BEGIN_DECLS


#define TYPE_POPUP (popup_get_type ())
#define POPUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_POPUP, Popup))
#define POPUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_POPUP, PopupClass))
#define IS_POPUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_POPUP))
#define IS_POPUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_POPUP))
#define POPUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_POPUP, PopupClass))

typedef struct _Popup Popup;
typedef struct _PopupClass PopupClass;
typedef struct _PopupPrivate PopupPrivate;

#define TYPE_PROPOSAL (proposal_get_type ())
#define PROPOSAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPOSAL, Proposal))
#define PROPOSAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPOSAL, ProposalClass))
#define IS_PROPOSAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPOSAL))
#define IS_PROPOSAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPOSAL))
#define PROPOSAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPOSAL, ProposalClass))

typedef struct _Proposal Proposal;
typedef struct _ProposalClass ProposalClass;

#define TYPE_CALLTIPS (calltips_get_type ())
#define CALLTIPS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CALLTIPS, Calltips))
#define CALLTIPS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CALLTIPS, CalltipsClass))
#define IS_CALLTIPS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CALLTIPS))
#define IS_CALLTIPS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CALLTIPS))
#define CALLTIPS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CALLTIPS, CalltipsClass))

typedef struct _Calltips Calltips;
typedef struct _CalltipsClass CalltipsClass;
typedef struct _CalltipsPrivate CalltipsPrivate;

#define TYPE_COMPLETION (completion_get_type ())
#define COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPLETION, Completion))
#define COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPLETION, CompletionClass))
#define IS_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPLETION))
#define IS_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPLETION))
#define COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPLETION, CompletionClass))

typedef struct _Completion Completion;
typedef struct _CompletionClass CompletionClass;
typedef struct _CompletionPrivate CompletionPrivate;

#define TYPE_TREE (tree_get_type ())
#define TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TREE, Tree))
#define TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TREE, TreeClass))
#define IS_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TREE))
#define IS_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TREE))
#define TREE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TREE, TreeClass))

typedef struct _Tree Tree;
typedef struct _TreeClass TreeClass;
typedef struct _TreePrivate TreePrivate;

#define VALENCIA_TYPE_SYMBOL_SET (valencia_symbol_set_get_type ())
#define VALENCIA_SYMBOL_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSet))
#define VALENCIA_SYMBOL_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSetClass))
#define VALENCIA_IS_SYMBOL_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SYMBOL_SET))
#define VALENCIA_IS_SYMBOL_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SYMBOL_SET))
#define VALENCIA_SYMBOL_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSetClass))

typedef struct _ValenciaSymbolSet ValenciaSymbolSet;
typedef struct _ValenciaSymbolSetClass ValenciaSymbolSetClass;
typedef struct _ValenciaSymbolSetPrivate ValenciaSymbolSetPrivate;

#define VALENCIA_TYPE_NODE (valencia_node_get_type ())
#define VALENCIA_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_NODE, ValenciaNode))
#define VALENCIA_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_NODE, ValenciaNodeClass))
#define VALENCIA_IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_NODE))
#define VALENCIA_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_NODE))
#define VALENCIA_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_NODE, ValenciaNodeClass))

typedef struct _ValenciaNode ValenciaNode;
typedef struct _ValenciaNodeClass ValenciaNodeClass;

#define VALENCIA_TYPE_SYMBOL (valencia_symbol_get_type ())
#define VALENCIA_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SYMBOL, ValenciaSymbol))
#define VALENCIA_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SYMBOL, ValenciaSymbolClass))
#define VALENCIA_IS_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SYMBOL))
#define VALENCIA_IS_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SYMBOL))
#define VALENCIA_SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SYMBOL, ValenciaSymbolClass))

typedef struct _ValenciaSymbol ValenciaSymbol;
typedef struct _ValenciaSymbolClass ValenciaSymbolClass;
typedef struct _ValenciaNodePrivate ValenciaNodePrivate;

#define VALENCIA_TYPE_CHAIN (valencia_chain_get_type ())
#define VALENCIA_CHAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CHAIN, ValenciaChain))
#define VALENCIA_CHAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CHAIN, ValenciaChainClass))
#define VALENCIA_IS_CHAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CHAIN))
#define VALENCIA_IS_CHAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CHAIN))
#define VALENCIA_CHAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CHAIN, ValenciaChainClass))

typedef struct _ValenciaChain ValenciaChain;
typedef struct _ValenciaChainClass ValenciaChainClass;
typedef struct _ValenciaSymbolPrivate ValenciaSymbolPrivate;

#define VALENCIA_TYPE_SOURCE_FILE (valencia_source_file_get_type ())
#define VALENCIA_SOURCE_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFile))
#define VALENCIA_SOURCE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFileClass))
#define VALENCIA_IS_SOURCE_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SOURCE_FILE))
#define VALENCIA_IS_SOURCE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SOURCE_FILE))
#define VALENCIA_SOURCE_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFileClass))

typedef struct _ValenciaSourceFile ValenciaSourceFile;
typedef struct _ValenciaSourceFileClass ValenciaSourceFileClass;

#define VALENCIA_TYPE_SCOPE (valencia_scope_get_type ())
#define VALENCIA_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SCOPE, ValenciaScope))
#define VALENCIA_IS_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SCOPE))
#define VALENCIA_SCOPE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALENCIA_TYPE_SCOPE, ValenciaScopeIface))

typedef struct _ValenciaScope ValenciaScope;
typedef struct _ValenciaScopeIface ValenciaScopeIface;

#define VALENCIA_TYPE_TYPESYMBOL (valencia_typesymbol_get_type ())
#define VALENCIA_TYPESYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbol))
#define VALENCIA_TYPESYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbolClass))
#define VALENCIA_IS_TYPESYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_TYPESYMBOL))
#define VALENCIA_IS_TYPESYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_TYPESYMBOL))
#define VALENCIA_TYPESYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbolClass))

typedef struct _ValenciaTypeSymbol ValenciaTypeSymbol;
typedef struct _ValenciaTypeSymbolClass ValenciaTypeSymbolClass;
typedef struct _ValenciaTypeSymbolPrivate ValenciaTypeSymbolPrivate;

#define VALENCIA_TYPE_STATEMENT (valencia_statement_get_type ())
#define VALENCIA_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_STATEMENT, ValenciaStatement))
#define VALENCIA_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_STATEMENT, ValenciaStatementClass))
#define VALENCIA_IS_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_STATEMENT))
#define VALENCIA_IS_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_STATEMENT))
#define VALENCIA_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_STATEMENT, ValenciaStatementClass))

typedef struct _ValenciaStatement ValenciaStatement;
typedef struct _ValenciaStatementClass ValenciaStatementClass;
typedef struct _ValenciaStatementPrivate ValenciaStatementPrivate;

#define VALENCIA_TYPE_VARIABLE (valencia_variable_get_type ())
#define VALENCIA_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_VARIABLE, ValenciaVariable))
#define VALENCIA_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_VARIABLE, ValenciaVariableClass))
#define VALENCIA_IS_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_VARIABLE))
#define VALENCIA_IS_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_VARIABLE))
#define VALENCIA_VARIABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_VARIABLE, ValenciaVariableClass))

typedef struct _ValenciaVariable ValenciaVariable;
typedef struct _ValenciaVariableClass ValenciaVariableClass;
typedef struct _ValenciaVariablePrivate ValenciaVariablePrivate;

#define VALENCIA_TYPE_EXPRESSION (valencia_expression_get_type ())
#define VALENCIA_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_EXPRESSION, ValenciaExpression))
#define VALENCIA_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_EXPRESSION, ValenciaExpressionClass))
#define VALENCIA_IS_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_EXPRESSION))
#define VALENCIA_IS_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_EXPRESSION))
#define VALENCIA_EXPRESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_EXPRESSION, ValenciaExpressionClass))

typedef struct _ValenciaExpression ValenciaExpression;
typedef struct _ValenciaExpressionClass ValenciaExpressionClass;

#define VALENCIA_TYPE_LOCAL_VARIABLE (valencia_local_variable_get_type ())
#define VALENCIA_LOCAL_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_LOCAL_VARIABLE, ValenciaLocalVariable))
#define VALENCIA_LOCAL_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_LOCAL_VARIABLE, ValenciaLocalVariableClass))
#define VALENCIA_IS_LOCAL_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_LOCAL_VARIABLE))
#define VALENCIA_IS_LOCAL_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_LOCAL_VARIABLE))
#define VALENCIA_LOCAL_VARIABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_LOCAL_VARIABLE, ValenciaLocalVariableClass))

typedef struct _ValenciaLocalVariable ValenciaLocalVariable;
typedef struct _ValenciaLocalVariableClass ValenciaLocalVariableClass;
typedef struct _ValenciaLocalVariablePrivate ValenciaLocalVariablePrivate;

#define VALENCIA_TYPE_DECLARATION_STATEMENT (valencia_declaration_statement_get_type ())
#define VALENCIA_DECLARATION_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_DECLARATION_STATEMENT, ValenciaDeclarationStatement))
#define VALENCIA_DECLARATION_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_DECLARATION_STATEMENT, ValenciaDeclarationStatementClass))
#define VALENCIA_IS_DECLARATION_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_DECLARATION_STATEMENT))
#define VALENCIA_IS_DECLARATION_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_DECLARATION_STATEMENT))
#define VALENCIA_DECLARATION_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_DECLARATION_STATEMENT, ValenciaDeclarationStatementClass))

typedef struct _ValenciaDeclarationStatement ValenciaDeclarationStatement;
typedef struct _ValenciaDeclarationStatementClass ValenciaDeclarationStatementClass;
typedef struct _ValenciaDeclarationStatementPrivate ValenciaDeclarationStatementPrivate;
typedef struct _ValenciaChainPrivate ValenciaChainPrivate;

#define VALENCIA_TYPE_BLOCK (valencia_block_get_type ())
#define VALENCIA_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_BLOCK, ValenciaBlock))
#define VALENCIA_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_BLOCK, ValenciaBlockClass))
#define VALENCIA_IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_BLOCK))
#define VALENCIA_IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_BLOCK))
#define VALENCIA_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_BLOCK, ValenciaBlockClass))

typedef struct _ValenciaBlock ValenciaBlock;
typedef struct _ValenciaBlockClass ValenciaBlockClass;
typedef struct _ValenciaBlockPrivate ValenciaBlockPrivate;

#define VALENCIA_TYPE_PARAMETER (valencia_parameter_get_type ())
#define VALENCIA_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PARAMETER, ValenciaParameter))
#define VALENCIA_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PARAMETER, ValenciaParameterClass))
#define VALENCIA_IS_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PARAMETER))
#define VALENCIA_IS_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PARAMETER))
#define VALENCIA_PARAMETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PARAMETER, ValenciaParameterClass))

typedef struct _ValenciaParameter ValenciaParameter;
typedef struct _ValenciaParameterClass ValenciaParameterClass;
typedef struct _ValenciaParameterPrivate ValenciaParameterPrivate;

#define VALENCIA_TYPE_CONSTRUCT (valencia_construct_get_type ())
#define VALENCIA_CONSTRUCT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CONSTRUCT, ValenciaConstruct))
#define VALENCIA_CONSTRUCT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CONSTRUCT, ValenciaConstructClass))
#define VALENCIA_IS_CONSTRUCT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CONSTRUCT))
#define VALENCIA_IS_CONSTRUCT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CONSTRUCT))
#define VALENCIA_CONSTRUCT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CONSTRUCT, ValenciaConstructClass))

typedef struct _ValenciaConstruct ValenciaConstruct;
typedef struct _ValenciaConstructClass ValenciaConstructClass;
typedef struct _ValenciaConstructPrivate ValenciaConstructPrivate;

#define VALENCIA_TYPE_METHOD (valencia_method_get_type ())
#define VALENCIA_METHOD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_METHOD, ValenciaMethod))
#define VALENCIA_METHOD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_METHOD, ValenciaMethodClass))
#define VALENCIA_IS_METHOD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_METHOD))
#define VALENCIA_IS_METHOD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_METHOD))
#define VALENCIA_METHOD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_METHOD, ValenciaMethodClass))

typedef struct _ValenciaMethod ValenciaMethod;
typedef struct _ValenciaMethodClass ValenciaMethodClass;
typedef struct _ValenciaMethodPrivate ValenciaMethodPrivate;

#define VALENCIA_TYPE_VSIGNAL (valencia_vsignal_get_type ())
#define VALENCIA_VSIGNAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_VSIGNAL, ValenciaVSignal))
#define VALENCIA_VSIGNAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_VSIGNAL, ValenciaVSignalClass))
#define VALENCIA_IS_VSIGNAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_VSIGNAL))
#define VALENCIA_IS_VSIGNAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_VSIGNAL))
#define VALENCIA_VSIGNAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_VSIGNAL, ValenciaVSignalClass))

typedef struct _ValenciaVSignal ValenciaVSignal;
typedef struct _ValenciaVSignalClass ValenciaVSignalClass;
typedef struct _ValenciaVSignalPrivate ValenciaVSignalPrivate;

#define VALENCIA_TYPE_DELEGATE (valencia_delegate_get_type ())
#define VALENCIA_DELEGATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_DELEGATE, ValenciaDelegate))
#define VALENCIA_DELEGATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_DELEGATE, ValenciaDelegateClass))
#define VALENCIA_IS_DELEGATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_DELEGATE))
#define VALENCIA_IS_DELEGATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_DELEGATE))
#define VALENCIA_DELEGATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_DELEGATE, ValenciaDelegateClass))

typedef struct _ValenciaDelegate ValenciaDelegate;
typedef struct _ValenciaDelegateClass ValenciaDelegateClass;
typedef struct _ValenciaDelegatePrivate ValenciaDelegatePrivate;

#define VALENCIA_TYPE_CONSTRUCTOR (valencia_constructor_get_type ())
#define VALENCIA_CONSTRUCTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CONSTRUCTOR, ValenciaConstructor))
#define VALENCIA_CONSTRUCTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CONSTRUCTOR, ValenciaConstructorClass))
#define VALENCIA_IS_CONSTRUCTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CONSTRUCTOR))
#define VALENCIA_IS_CONSTRUCTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CONSTRUCTOR))
#define VALENCIA_CONSTRUCTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CONSTRUCTOR, ValenciaConstructorClass))

typedef struct _ValenciaConstructor ValenciaConstructor;
typedef struct _ValenciaConstructorClass ValenciaConstructorClass;
typedef struct _ValenciaConstructorPrivate ValenciaConstructorPrivate;

#define VALENCIA_TYPE_CLASS (valencia_class_get_type ())
#define VALENCIA_CLASS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CLASS, ValenciaClass))
#define VALENCIA_CLASS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CLASS, ValenciaClassClass))
#define VALENCIA_IS_CLASS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CLASS))
#define VALENCIA_IS_CLASS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CLASS))
#define VALENCIA_CLASS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CLASS, ValenciaClassClass))

typedef struct _ValenciaClass ValenciaClass;
typedef struct _ValenciaClassClass ValenciaClassClass;

#define VALENCIA_TYPE_FIELD (valencia_field_get_type ())
#define VALENCIA_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_FIELD, ValenciaField))
#define VALENCIA_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_FIELD, ValenciaFieldClass))
#define VALENCIA_IS_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_FIELD))
#define VALENCIA_IS_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_FIELD))
#define VALENCIA_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_FIELD, ValenciaFieldClass))

typedef struct _ValenciaField ValenciaField;
typedef struct _ValenciaFieldClass ValenciaFieldClass;
typedef struct _ValenciaFieldPrivate ValenciaFieldPrivate;

#define VALENCIA_TYPE_PROPERTY (valencia_property_get_type ())
#define VALENCIA_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PROPERTY, ValenciaProperty))
#define VALENCIA_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PROPERTY, ValenciaPropertyClass))
#define VALENCIA_IS_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PROPERTY))
#define VALENCIA_IS_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PROPERTY))
#define VALENCIA_PROPERTY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PROPERTY, ValenciaPropertyClass))

typedef struct _ValenciaProperty ValenciaProperty;
typedef struct _ValenciaPropertyClass ValenciaPropertyClass;
typedef struct _ValenciaPropertyPrivate ValenciaPropertyPrivate;
typedef struct _ValenciaClassPrivate ValenciaClassPrivate;

#define VALENCIA_TYPE_INTERFACE (valencia_interface_get_type ())
#define VALENCIA_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_INTERFACE, ValenciaInterface))
#define VALENCIA_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_INTERFACE, ValenciaInterfaceClass))
#define VALENCIA_IS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_INTERFACE))
#define VALENCIA_IS_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_INTERFACE))
#define VALENCIA_INTERFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_INTERFACE, ValenciaInterfaceClass))

typedef struct _ValenciaInterface ValenciaInterface;
typedef struct _ValenciaInterfaceClass ValenciaInterfaceClass;
typedef struct _ValenciaInterfacePrivate ValenciaInterfacePrivate;

#define VALENCIA_TYPE_NAMESPACE (valencia_namespace_get_type ())
#define VALENCIA_NAMESPACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_NAMESPACE, ValenciaNamespace))
#define VALENCIA_NAMESPACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_NAMESPACE, ValenciaNamespaceClass))
#define VALENCIA_IS_NAMESPACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_NAMESPACE))
#define VALENCIA_IS_NAMESPACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_NAMESPACE))
#define VALENCIA_NAMESPACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_NAMESPACE, ValenciaNamespaceClass))

typedef struct _ValenciaNamespace ValenciaNamespace;
typedef struct _ValenciaNamespaceClass ValenciaNamespaceClass;
typedef struct _ValenciaNamespacePrivate ValenciaNamespacePrivate;
typedef struct _ValenciaSourceFilePrivate ValenciaSourceFilePrivate;

#define VALENCIA_TYPE_PROGRAM (valencia_program_get_type ())
#define VALENCIA_PROGRAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PROGRAM, ValenciaProgram))
#define VALENCIA_PROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PROGRAM, ValenciaProgramClass))
#define VALENCIA_IS_PROGRAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PROGRAM))
#define VALENCIA_IS_PROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PROGRAM))
#define VALENCIA_PROGRAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PROGRAM, ValenciaProgramClass))

typedef struct _ValenciaProgram ValenciaProgram;
typedef struct _ValenciaProgramClass ValenciaProgramClass;

#define VALENCIA_TYPE_ERROR_INFO (valencia_error_info_get_type ())
#define VALENCIA_ERROR_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_ERROR_INFO, ValenciaErrorInfo))
#define VALENCIA_ERROR_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_ERROR_INFO, ValenciaErrorInfoClass))
#define VALENCIA_IS_ERROR_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_ERROR_INFO))
#define VALENCIA_IS_ERROR_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_ERROR_INFO))
#define VALENCIA_ERROR_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_ERROR_INFO, ValenciaErrorInfoClass))

typedef struct _ValenciaErrorInfo ValenciaErrorInfo;
typedef struct _ValenciaErrorInfoClass ValenciaErrorInfoClass;
typedef struct _ValenciaErrorInfoPrivate ValenciaErrorInfoPrivate;

#define VALENCIA_TYPE_ERROR_PAIR (valencia_error_pair_get_type ())
#define VALENCIA_ERROR_PAIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_ERROR_PAIR, ValenciaErrorPair))
#define VALENCIA_ERROR_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_ERROR_PAIR, ValenciaErrorPairClass))
#define VALENCIA_IS_ERROR_PAIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_ERROR_PAIR))
#define VALENCIA_IS_ERROR_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_ERROR_PAIR))
#define VALENCIA_ERROR_PAIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_ERROR_PAIR, ValenciaErrorPairClass))

typedef struct _ValenciaErrorPair ValenciaErrorPair;
typedef struct _ValenciaErrorPairClass ValenciaErrorPairClass;
typedef struct _ValenciaErrorPairPrivate ValenciaErrorPairPrivate;

#define VALENCIA_TYPE_ERROR_LIST (valencia_error_list_get_type ())
#define VALENCIA_ERROR_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_ERROR_LIST, ValenciaErrorList))
#define VALENCIA_ERROR_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_ERROR_LIST, ValenciaErrorListClass))
#define VALENCIA_IS_ERROR_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_ERROR_LIST))
#define VALENCIA_IS_ERROR_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_ERROR_LIST))
#define VALENCIA_ERROR_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_ERROR_LIST, ValenciaErrorListClass))

typedef struct _ValenciaErrorList ValenciaErrorList;
typedef struct _ValenciaErrorListClass ValenciaErrorListClass;
typedef struct _ValenciaErrorListPrivate ValenciaErrorListPrivate;

#define VALENCIA_TYPE_MAKEFILE (valencia_makefile_get_type ())
#define VALENCIA_MAKEFILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_MAKEFILE, ValenciaMakefile))
#define VALENCIA_MAKEFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_MAKEFILE, ValenciaMakefileClass))
#define VALENCIA_IS_MAKEFILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_MAKEFILE))
#define VALENCIA_IS_MAKEFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_MAKEFILE))
#define VALENCIA_MAKEFILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_MAKEFILE, ValenciaMakefileClass))

typedef struct _ValenciaMakefile ValenciaMakefile;
typedef struct _ValenciaMakefileClass ValenciaMakefileClass;
typedef struct _ValenciaMakefilePrivate ValenciaMakefilePrivate;

#define VALENCIA_TYPE_CONFIGURATION_FILE (valencia_configuration_file_get_type ())
#define VALENCIA_CONFIGURATION_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CONFIGURATION_FILE, ValenciaConfigurationFile))
#define VALENCIA_CONFIGURATION_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CONFIGURATION_FILE, ValenciaConfigurationFileClass))
#define VALENCIA_IS_CONFIGURATION_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CONFIGURATION_FILE))
#define VALENCIA_IS_CONFIGURATION_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CONFIGURATION_FILE))
#define VALENCIA_CONFIGURATION_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CONFIGURATION_FILE, ValenciaConfigurationFileClass))

typedef struct _ValenciaConfigurationFile ValenciaConfigurationFile;
typedef struct _ValenciaConfigurationFileClass ValenciaConfigurationFileClass;
typedef struct _ValenciaConfigurationFilePrivate ValenciaConfigurationFilePrivate;
typedef struct _ValenciaProgramPrivate ValenciaProgramPrivate;

#define VALENCIA_TYPE_SCAN_SCOPE (valencia_scan_scope_get_type ())
#define VALENCIA_SCAN_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SCAN_SCOPE, ValenciaScanScope))
#define VALENCIA_SCAN_SCOPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SCAN_SCOPE, ValenciaScanScopeClass))
#define VALENCIA_IS_SCAN_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SCAN_SCOPE))
#define VALENCIA_IS_SCAN_SCOPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SCAN_SCOPE))
#define VALENCIA_SCAN_SCOPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SCAN_SCOPE, ValenciaScanScopeClass))

typedef struct _ValenciaScanScope ValenciaScanScope;
typedef struct _ValenciaScanScopeClass ValenciaScanScopeClass;
typedef struct _ValenciaScanScopePrivate ValenciaScanScopePrivate;

#define VALENCIA_TYPE_PARSE_INFO (valencia_parse_info_get_type ())
#define VALENCIA_PARSE_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfo))
#define VALENCIA_PARSE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfoClass))
#define VALENCIA_IS_PARSE_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PARSE_INFO))
#define VALENCIA_IS_PARSE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PARSE_INFO))
#define VALENCIA_PARSE_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfoClass))

typedef struct _ValenciaParseInfo ValenciaParseInfo;
typedef struct _ValenciaParseInfoClass ValenciaParseInfoClass;
typedef struct _ValenciaParseInfoPrivate ValenciaParseInfoPrivate;

#define VALENCIA_TYPE_PARSER (valencia_parser_get_type ())
#define VALENCIA_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PARSER, ValenciaParser))
#define VALENCIA_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PARSER, ValenciaParserClass))
#define VALENCIA_IS_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PARSER))
#define VALENCIA_IS_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PARSER))
#define VALENCIA_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PARSER, ValenciaParserClass))

typedef struct _ValenciaParser ValenciaParser;
typedef struct _ValenciaParserClass ValenciaParserClass;
typedef struct _ValenciaParserPrivate ValenciaParserPrivate;
typedef struct _ValenciaExpressionPrivate ValenciaExpressionPrivate;

#define VALENCIA_TYPE_ID (valencia_id_get_type ())
#define VALENCIA_ID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_ID, ValenciaId))
#define VALENCIA_ID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_ID, ValenciaIdClass))
#define VALENCIA_IS_ID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_ID))
#define VALENCIA_IS_ID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_ID))
#define VALENCIA_ID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_ID, ValenciaIdClass))

typedef struct _ValenciaId ValenciaId;
typedef struct _ValenciaIdClass ValenciaIdClass;
typedef struct _ValenciaIdPrivate ValenciaIdPrivate;

#define VALENCIA_TYPE_THIS (valencia_this_get_type ())
#define VALENCIA_THIS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_THIS, ValenciaThis))
#define VALENCIA_THIS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_THIS, ValenciaThisClass))
#define VALENCIA_IS_THIS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_THIS))
#define VALENCIA_IS_THIS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_THIS))
#define VALENCIA_THIS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_THIS, ValenciaThisClass))

typedef struct _ValenciaThis ValenciaThis;
typedef struct _ValenciaThisClass ValenciaThisClass;
typedef struct _ValenciaThisPrivate ValenciaThisPrivate;

#define VALENCIA_TYPE_BASE (valencia_base_get_type ())
#define VALENCIA_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_BASE, ValenciaBase))
#define VALENCIA_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_BASE, ValenciaBaseClass))
#define VALENCIA_IS_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_BASE))
#define VALENCIA_IS_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_BASE))
#define VALENCIA_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_BASE, ValenciaBaseClass))

typedef struct _ValenciaBase ValenciaBase;
typedef struct _ValenciaBaseClass ValenciaBaseClass;
typedef struct _ValenciaBasePrivate ValenciaBasePrivate;

#define VALENCIA_TYPE_NEW (valencia_new_get_type ())
#define VALENCIA_NEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_NEW, ValenciaNew))
#define VALENCIA_NEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_NEW, ValenciaNewClass))
#define VALENCIA_IS_NEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_NEW))
#define VALENCIA_IS_NEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_NEW))
#define VALENCIA_NEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_NEW, ValenciaNewClass))

typedef struct _ValenciaNew ValenciaNew;
typedef struct _ValenciaNewClass ValenciaNewClass;
typedef struct _ValenciaNewPrivate ValenciaNewPrivate;

#define VALENCIA_TYPE_METHOD_CALL (valencia_method_call_get_type ())
#define VALENCIA_METHOD_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_METHOD_CALL, ValenciaMethodCall))
#define VALENCIA_METHOD_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_METHOD_CALL, ValenciaMethodCallClass))
#define VALENCIA_IS_METHOD_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_METHOD_CALL))
#define VALENCIA_IS_METHOD_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_METHOD_CALL))
#define VALENCIA_METHOD_CALL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_METHOD_CALL, ValenciaMethodCallClass))

typedef struct _ValenciaMethodCall ValenciaMethodCall;
typedef struct _ValenciaMethodCallClass ValenciaMethodCallClass;
typedef struct _ValenciaMethodCallPrivate ValenciaMethodCallPrivate;

#define VALENCIA_TYPE_COMPOUND_EXPRESSION (valencia_compound_expression_get_type ())
#define VALENCIA_COMPOUND_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpression))
#define VALENCIA_COMPOUND_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpressionClass))
#define VALENCIA_IS_COMPOUND_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION))
#define VALENCIA_IS_COMPOUND_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_COMPOUND_EXPRESSION))
#define VALENCIA_COMPOUND_EXPRESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpressionClass))

typedef struct _ValenciaCompoundExpression ValenciaCompoundExpression;
typedef struct _ValenciaCompoundExpressionClass ValenciaCompoundExpressionClass;
typedef struct _ValenciaCompoundExpressionPrivate ValenciaCompoundExpressionPrivate;
typedef struct _ProposalPrivate ProposalPrivate;

/**
 * The completion popup
 */
struct _Popup {
	GtkWindow parent_instance;
	PopupPrivate * priv;
};

struct _PopupClass {
	GtkWindowClass parent_class;
};

/**
 * The completion calltips
 */
struct _Calltips {
	GtkWindow parent_instance;
	CalltipsPrivate * priv;
};

struct _CalltipsClass {
	GtkWindowClass parent_class;
};

struct _Completion {
	GObject parent_instance;
	CompletionPrivate * priv;
};

struct _CompletionClass {
	GObjectClass parent_class;
};

/**
 * The tree view widget for the popup completion
 */
struct _Tree {
	GtkScrolledWindow parent_instance;
	TreePrivate * priv;
};

struct _TreeClass {
	GtkScrolledWindowClass parent_class;
};

struct _ValenciaSymbolSet {
	GObject parent_instance;
	ValenciaSymbolSetPrivate * priv;
};

struct _ValenciaSymbolSetClass {
	GObjectClass parent_class;
};

struct _ValenciaNode {
	GObject parent_instance;
	ValenciaNodePrivate * priv;
	gint start;
	gint end;
};

struct _ValenciaNodeClass {
	GObjectClass parent_class;
	GeeArrayList* (*children) (ValenciaNode* self);
	void (*print) (ValenciaNode* self, gint level);
};

struct _ValenciaSymbol {
	ValenciaNode parent_instance;
	ValenciaSymbolPrivate * priv;
	ValenciaSourceFile* source;
	char* name;
};

struct _ValenciaSymbolClass {
	ValenciaNodeClass parent_class;
};

struct _ValenciaScopeIface {
	GTypeInterface parent_iface;
	gboolean (*lookup) (ValenciaScope* self, ValenciaSymbolSet* symbols, gint pos);
};

struct _ValenciaTypeSymbol {
	ValenciaSymbol parent_instance;
	ValenciaTypeSymbolPrivate * priv;
};

struct _ValenciaTypeSymbolClass {
	ValenciaSymbolClass parent_class;
};

struct _ValenciaStatement {
	ValenciaNode parent_instance;
	ValenciaStatementPrivate * priv;
};

struct _ValenciaStatementClass {
	ValenciaNodeClass parent_class;
	gboolean (*defines_symbol) (ValenciaStatement* self, ValenciaSymbolSet* symbols);
};

struct _ValenciaVariable {
	ValenciaSymbol parent_instance;
	ValenciaVariablePrivate * priv;
	ValenciaExpression* type;
};

struct _ValenciaVariableClass {
	ValenciaSymbolClass parent_class;
	char* (*kind) (ValenciaVariable* self);
};

struct _ValenciaLocalVariable {
	ValenciaVariable parent_instance;
	ValenciaLocalVariablePrivate * priv;
};

struct _ValenciaLocalVariableClass {
	ValenciaVariableClass parent_class;
};

struct _ValenciaDeclarationStatement {
	ValenciaStatement parent_instance;
	ValenciaDeclarationStatementPrivate * priv;
	GeeArrayList* variables;
};

struct _ValenciaDeclarationStatementClass {
	ValenciaStatementClass parent_class;
};

struct _ValenciaChain {
	GObject parent_instance;
	ValenciaChainPrivate * priv;
};

struct _ValenciaChainClass {
	GObjectClass parent_class;
};

struct _ValenciaBlock {
	ValenciaStatement parent_instance;
	ValenciaBlockPrivate * priv;
	GeeArrayList* statements;
};

struct _ValenciaBlockClass {
	ValenciaStatementClass parent_class;
};

struct _ValenciaParameter {
	ValenciaVariable parent_instance;
	ValenciaParameterPrivate * priv;
};

struct _ValenciaParameterClass {
	ValenciaVariableClass parent_class;
};

/* a construct block*/
struct _ValenciaConstruct {
	ValenciaNode parent_instance;
	ValenciaConstructPrivate * priv;
	ValenciaBlock* body;
};

struct _ValenciaConstructClass {
	ValenciaNodeClass parent_class;
};

struct _ValenciaMethod {
	ValenciaSymbol parent_instance;
	ValenciaMethodPrivate * priv;
	GeeArrayList* parameters;
	ValenciaExpression* return_type;
	ValenciaBlock* body;
};

struct _ValenciaMethodClass {
	ValenciaSymbolClass parent_class;
	void (*print_type) (ValenciaMethod* self, gint level);
};

/* We use the name "VSignal" to avoid a name conflict with GLib.Signal.*/
struct _ValenciaVSignal {
	ValenciaMethod parent_instance;
	ValenciaVSignalPrivate * priv;
};

struct _ValenciaVSignalClass {
	ValenciaMethodClass parent_class;
};

struct _ValenciaDelegate {
	ValenciaMethod parent_instance;
	ValenciaDelegatePrivate * priv;
};

struct _ValenciaDelegateClass {
	ValenciaMethodClass parent_class;
};

struct _ValenciaConstructor {
	ValenciaMethod parent_instance;
	ValenciaConstructorPrivate * priv;
	ValenciaClass* parent;
};

struct _ValenciaConstructorClass {
	ValenciaMethodClass parent_class;
};

struct _ValenciaField {
	ValenciaVariable parent_instance;
	ValenciaFieldPrivate * priv;
};

struct _ValenciaFieldClass {
	ValenciaVariableClass parent_class;
};

struct _ValenciaProperty {
	ValenciaVariable parent_instance;
	ValenciaPropertyPrivate * priv;
	ValenciaBlock* body;
};

struct _ValenciaPropertyClass {
	ValenciaVariableClass parent_class;
};

/* a class, struct, interface or enum*/
struct _ValenciaClass {
	ValenciaTypeSymbol parent_instance;
	ValenciaClassPrivate * priv;
	GeeArrayList* super;
	GeeArrayList* members;
};

struct _ValenciaClassClass {
	ValenciaTypeSymbolClass parent_class;
};

struct _ValenciaInterface {
	ValenciaClass parent_instance;
	ValenciaInterfacePrivate * priv;
};

struct _ValenciaInterfaceClass {
	ValenciaClassClass parent_class;
};

/* A Namespace is a TypeSymbol since namespaces can be used in type names.*/
struct _ValenciaNamespace {
	ValenciaTypeSymbol parent_instance;
	ValenciaNamespacePrivate * priv;
	char* full_name;
	GeeArrayList* symbols;
};

struct _ValenciaNamespaceClass {
	ValenciaTypeSymbolClass parent_class;
};

struct _ValenciaSourceFile {
	ValenciaNode parent_instance;
	ValenciaSourceFilePrivate * priv;
	ValenciaProgram* program;
	char* filename;
	GeeArrayList* namespaces;
	ValenciaNamespace* top;
};

struct _ValenciaSourceFileClass {
	ValenciaNodeClass parent_class;
};

struct _ValenciaErrorInfo {
	GObject parent_instance;
	ValenciaErrorInfoPrivate * priv;
	char* filename;
	char* start_line;
	char* start_char;
	char* end_line;
	char* end_char;
};

struct _ValenciaErrorInfoClass {
	GObjectClass parent_class;
};

struct _ValenciaErrorPair {
	GObject parent_instance;
	ValenciaErrorPairPrivate * priv;
	GtkTextMark* document_pane_error;
	GtkTextMark* build_pane_error;
	ValenciaErrorInfo* error_info;
};

struct _ValenciaErrorPairClass {
	GObjectClass parent_class;
};

struct _ValenciaErrorList {
	GObject parent_instance;
	ValenciaErrorListPrivate * priv;
	GeeArrayList* errors;
	gint error_index;
};

struct _ValenciaErrorListClass {
	GObjectClass parent_class;
};

struct _ValenciaMakefile {
	GObject parent_instance;
	ValenciaMakefilePrivate * priv;
	char* path;
	char* relative_binary_run_path;
};

struct _ValenciaMakefileClass {
	GObjectClass parent_class;
};

struct _ValenciaConfigurationFile {
	GObject parent_instance;
	ValenciaConfigurationFilePrivate * priv;
};

struct _ValenciaConfigurationFileClass {
	GObjectClass parent_class;
};

struct _ValenciaProgram {
	GObject parent_instance;
	ValenciaProgramPrivate * priv;
	ValenciaErrorList* error_list;
	ValenciaConfigurationFile* config_file;
};

struct _ValenciaProgramClass {
	GObjectClass parent_class;
};

struct _ValenciaScanScope {
	GObject parent_instance;
	ValenciaScanScopePrivate * priv;
	gint depth;
	gint start_pos;
	gint end_pos;
};

struct _ValenciaScanScopeClass {
	GObjectClass parent_class;
};

struct _ValenciaParseInfo {
	GObject parent_instance;
	ValenciaParseInfoPrivate * priv;
	ValenciaExpression* inner;
	ValenciaExpression* outer;
	gint outer_pos;
};

struct _ValenciaParseInfoClass {
	GObjectClass parent_class;
};

struct _ValenciaParser {
	GObject parent_instance;
	ValenciaParserPrivate * priv;
};

struct _ValenciaParserClass {
	GObjectClass parent_class;
};

struct _ValenciaExpression {
	GObject parent_instance;
	ValenciaExpressionPrivate * priv;
};

struct _ValenciaExpressionClass {
	GObjectClass parent_class;
	char* (*to_string) (ValenciaExpression* self);
};

struct _ValenciaId {
	ValenciaExpression parent_instance;
	ValenciaIdPrivate * priv;
	char* name;
};

struct _ValenciaIdClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaThis {
	ValenciaExpression parent_instance;
	ValenciaThisPrivate * priv;
};

struct _ValenciaThisClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaBase {
	ValenciaExpression parent_instance;
	ValenciaBasePrivate * priv;
};

struct _ValenciaBaseClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaNew {
	ValenciaExpression parent_instance;
	ValenciaNewPrivate * priv;
	ValenciaExpression* class_name;
};

struct _ValenciaNewClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaMethodCall {
	ValenciaExpression parent_instance;
	ValenciaMethodCallPrivate * priv;
	ValenciaExpression* method;
};

struct _ValenciaMethodCallClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaCompoundExpression {
	ValenciaExpression parent_instance;
	ValenciaCompoundExpressionPrivate * priv;
	ValenciaExpression* left;
	char* right;
};

struct _ValenciaCompoundExpressionClass {
	ValenciaExpressionClass parent_class;
};

/**
 * A completion proposal
 */
struct _Proposal {
	GObject parent_instance;
	ProposalPrivate * priv;
};

struct _ProposalClass {
	GObjectClass parent_class;
};


GType popup_get_type (void);
Popup* popup_new (void);
Popup* popup_construct (GType object_type);
void popup_show (Popup* self);
void popup_hide (Popup* self);
void popup_select_first (Popup* self);
void popup_select_last (Popup* self);
void popup_select_previous (Popup* self, gint rows);
void popup_select_next (Popup* self, gint rows);
GType proposal_get_type (void);
gboolean popup_get_selected_proposal (Popup* self, Proposal** proposal);
gint popup_get_num_proposals (Popup* self);
gboolean popup_has_proposals (Popup* self);
void popup_filter (Popup* self, const char* filter);
void popup_clear (Popup* self);
void popup_set_proposals (Popup* self, GList* value);
GType calltips_get_type (void);
Calltips* calltips_new (void);
Calltips* calltips_construct (GType object_type);
const char* calltips_get_text (Calltips* self);
void calltips_set_text (Calltips* self, const char* value);
GType completion_get_type (void);
Completion* completion_new (void);
Completion* completion_construct (GType object_type);
GType register_plugin (void);
GType tree_get_type (void);
gboolean tree_get_selected_proposal (Tree* self, Proposal** proposal);
void tree_add_data (Tree* self, Proposal* data);
void tree_clear (Tree* self);
void tree_select_first (Tree* self);
void tree_select_last (Tree* self);
void tree_select_previous (Tree* self, gint rows);
void tree_select_next (Tree* self, gint rows);
gint tree_get_num_proposals (Tree* self);
void tree_filter (Tree* self, const char* filter);
Tree* tree_new (void);
Tree* tree_construct (GType object_type);
GType valencia_symbol_set_get_type (void);
ValenciaSymbolSet* valencia_symbol_set_new (const char* name, gboolean type, gboolean exact, gboolean constructor, gboolean local_symbols);
ValenciaSymbolSet* valencia_symbol_set_construct (GType object_type, const char* name, gboolean type, gboolean exact, gboolean constructor, gboolean local_symbols);
ValenciaSymbolSet* valencia_symbol_set_new_empty (void);
ValenciaSymbolSet* valencia_symbol_set_construct_empty (GType object_type);
GType valencia_node_get_type (void);
GType valencia_symbol_get_type (void);
gboolean valencia_symbol_set_add (ValenciaSymbolSet* self, ValenciaSymbol* sym);
ValenciaSymbol* valencia_symbol_set_first (ValenciaSymbolSet* self);
GeeHashSet* valencia_symbol_set_get_symbols (ValenciaSymbolSet* self);
char* valencia_symbol_set_get_name (ValenciaSymbolSet* self);
ValenciaSymbol* valencia_symbol_set_get_symbol (ValenciaSymbolSet* self, const char* name);
gboolean valencia_symbol_set_local_symbols_only (ValenciaSymbolSet* self);
GeeArrayList* valencia_node_children (ValenciaNode* self);
GeeArrayList* valencia_node_single_node (ValenciaNode* n);
GType valencia_chain_get_type (void);
ValenciaChain* valencia_node_find (ValenciaNode* self, ValenciaChain* parent, gint pos);
gboolean valencia_node_lookup_in_array (GeeArrayList* a, ValenciaSymbolSet* symbols);
void valencia_node_print (ValenciaNode* self, gint level);
void valencia_node_do_print (ValenciaNode* self, gint level, const char* s);
GType valencia_source_file_get_type (void);
ValenciaSymbol* valencia_symbol_new (const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaSymbol* valencia_symbol_construct (GType object_type, const char* name, ValenciaSourceFile* source, gint start, gint end);
void valencia_symbol_print_name (ValenciaSymbol* self, gint level, const char* s);
gint valencia_symbol_name_length (ValenciaSymbol* self);
guint valencia_symbol_hash (void* item);
gboolean valencia_symbol_equal (void* a, void* b);
GType valencia_scope_get_type (void);
gboolean valencia_scope_lookup (ValenciaScope* self, ValenciaSymbolSet* symbols, gint pos);
GType valencia_typesymbol_get_type (void);
ValenciaTypeSymbol* valencia_typesymbol_new (const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaTypeSymbol* valencia_typesymbol_construct (GType object_type, const char* name, ValenciaSourceFile* source, gint start, gint end);
GType valencia_statement_get_type (void);
ValenciaStatement* valencia_statement_new (gint start, gint end);
ValenciaStatement* valencia_statement_construct (GType object_type, gint start, gint end);
gboolean valencia_statement_defines_symbol (ValenciaStatement* self, ValenciaSymbolSet* symbols);
GType valencia_variable_get_type (void);
GType valencia_expression_get_type (void);
ValenciaVariable* valencia_variable_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaVariable* valencia_variable_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
char* valencia_variable_kind (ValenciaVariable* self);
GType valencia_local_variable_get_type (void);
ValenciaLocalVariable* valencia_local_variable_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaLocalVariable* valencia_local_variable_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
GType valencia_declaration_statement_get_type (void);
ValenciaDeclarationStatement* valencia_declaration_statement_new (GeeArrayList* variables, gint start, gint end);
ValenciaDeclarationStatement* valencia_declaration_statement_construct (GType object_type, GeeArrayList* variables, gint start, gint end);
ValenciaChain* valencia_chain_new (ValenciaScope* scope, ValenciaChain* parent);
ValenciaChain* valencia_chain_construct (GType object_type, ValenciaScope* scope, ValenciaChain* parent);
void valencia_chain_lookup (ValenciaChain* self, ValenciaSymbolSet* symbols, gint pos);
ValenciaSymbol* valencia_chain_lookup_this (ValenciaChain* self);
ValenciaSymbol* valencia_chain_lookup_base (ValenciaChain* self, ValenciaSourceFile* sf);
GType valencia_block_get_type (void);
ValenciaBlock* valencia_block_new (void);
ValenciaBlock* valencia_block_construct (GType object_type);
GType valencia_parameter_get_type (void);
ValenciaParameter* valencia_parameter_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaParameter* valencia_parameter_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
GType valencia_construct_get_type (void);
ValenciaConstruct* valencia_construct_new (ValenciaBlock* body, gint start, gint end);
ValenciaConstruct* valencia_construct_construct (GType object_type, ValenciaBlock* body, gint start, gint end);
GType valencia_method_get_type (void);
ValenciaMethod* valencia_method_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
ValenciaMethod* valencia_method_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
void valencia_method_print_type (ValenciaMethod* self, gint level);
void valencia_method_update_prototype (ValenciaMethod* self, const char* proto);
char* valencia_method_to_string (ValenciaMethod* self);
GType valencia_vsignal_get_type (void);
ValenciaVSignal* valencia_vsignal_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
ValenciaVSignal* valencia_vsignal_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
GType valencia_delegate_get_type (void);
ValenciaDelegate* valencia_delegate_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
ValenciaDelegate* valencia_delegate_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
GType valencia_constructor_get_type (void);
GType valencia_class_get_type (void);
ValenciaConstructor* valencia_constructor_new (const char* unqualified_name, ValenciaClass* parent, ValenciaSourceFile* source);
ValenciaConstructor* valencia_constructor_construct (GType object_type, const char* unqualified_name, ValenciaClass* parent, ValenciaSourceFile* source);
GType valencia_field_get_type (void);
ValenciaField* valencia_field_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaField* valencia_field_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
GType valencia_property_get_type (void);
ValenciaProperty* valencia_property_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaProperty* valencia_property_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaClass* valencia_class_new (const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
ValenciaClass* valencia_class_construct (GType object_type, const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
ValenciaSymbol* valencia_class_lookup_constructor (ValenciaClass* self);
char* valencia_class_to_string (ValenciaClass* self);
GType valencia_interface_get_type (void);
ValenciaInterface* valencia_interface_new (const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
ValenciaInterface* valencia_interface_construct (GType object_type, const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
GType valencia_namespace_get_type (void);
ValenciaNamespace* valencia_namespace_new (const char* name, const char* full_name, ValenciaSourceFile* source);
ValenciaNamespace* valencia_namespace_construct (GType object_type, const char* name, const char* full_name, ValenciaSourceFile* source);
gboolean valencia_namespace_lookup1 (ValenciaNamespace* self, ValenciaSymbolSet* symbols);
void valencia_namespace_lookup_all_toplevel_symbols (ValenciaNamespace* self, ValenciaSymbolSet* symbols);
GType valencia_program_get_type (void);
ValenciaSourceFile* valencia_source_file_new (ValenciaProgram* program, const char* filename);
ValenciaSourceFile* valencia_source_file_construct (GType object_type, ValenciaProgram* program, const char* filename);
void valencia_source_file_clear (ValenciaSourceFile* self);
void valencia_source_file_add_using_namespace (ValenciaSourceFile* self, const char* name);
gboolean valencia_source_file_lookup_in_namespace (ValenciaSourceFile* self, const char* namespace_name, ValenciaSymbolSet* symbols);
ValenciaSymbolSet* valencia_source_file_resolve_non_compound (ValenciaSourceFile* self, ValenciaExpression* name, ValenciaChain* chain, gint pos, gboolean find_type, gboolean exact, gboolean constructor, gboolean local_symbols);
ValenciaSymbolSet* valencia_source_file_resolve1 (ValenciaSourceFile* self, ValenciaExpression* name, ValenciaChain* chain, gint pos, gboolean find_type, gboolean exact, gboolean constructor, gboolean local_symbols);
ValenciaSymbol* valencia_source_file_resolve (ValenciaSourceFile* self, ValenciaExpression* name, gint pos, gboolean constructor);
ValenciaSymbol* valencia_source_file_resolve_type (ValenciaSourceFile* self, ValenciaExpression* type, gint pos);
ValenciaSymbolSet* valencia_source_file_resolve_prefix (ValenciaSourceFile* self, ValenciaExpression* prefix, gint pos, gboolean constructor);
ValenciaSymbolSet* valencia_source_file_resolve_all_locals (ValenciaSourceFile* self, ValenciaExpression* prefix, gint pos);
ValenciaSymbol* valencia_source_file_resolve_local (ValenciaSourceFile* self, ValenciaExpression* name, gint pos);
GType valencia_error_info_get_type (void);
ValenciaErrorInfo* valencia_error_info_new (void);
ValenciaErrorInfo* valencia_error_info_construct (GType object_type);
GType valencia_error_pair_get_type (void);
ValenciaErrorPair* valencia_error_pair_new (GtkTextMark* document_err, GtkTextMark* build_err, ValenciaErrorInfo* err_info);
ValenciaErrorPair* valencia_error_pair_construct (GType object_type, GtkTextMark* document_err, GtkTextMark* build_err, ValenciaErrorInfo* err_info);
GType valencia_error_list_get_type (void);
ValenciaErrorList* valencia_error_list_new (void);
ValenciaErrorList* valencia_error_list_construct (GType object_type);
GType valencia_makefile_get_type (void);
gboolean valencia_makefile_parse (ValenciaMakefile* self, GFile* makefile);
void valencia_makefile_reparse (ValenciaMakefile* self);
void valencia_makefile_reset_paths (ValenciaMakefile* self);
ValenciaMakefile* valencia_makefile_new (void);
ValenciaMakefile* valencia_makefile_construct (GType object_type);
GType valencia_configuration_file_get_type (void);
ValenciaConfigurationFile* valencia_configuration_file_new (ValenciaProgram* parent_program);
ValenciaConfigurationFile* valencia_configuration_file_construct (GType object_type, ValenciaProgram* parent_program);
char* valencia_configuration_file_get_build_command (ValenciaConfigurationFile* self);
char* valencia_configuration_file_get_clean_command (ValenciaConfigurationFile* self);
void valencia_configuration_file_update (ValenciaConfigurationFile* self, const char* new_build_command, const char* new_clean_command);
void valencia_configuration_file_update_location (ValenciaConfigurationFile* self, const char* old_directory);
gboolean valencia_program_is_vala (const char* filename);
gboolean valencia_program_lookup_in_namespace1 (ValenciaProgram* self, GeeArrayList* source_list, const char* namespace_name, ValenciaSymbolSet* symbols, gboolean vapi);
gboolean valencia_program_lookup_in_namespace (ValenciaProgram* self, const char* namespace_name, ValenciaSymbolSet* symbols);
ValenciaSourceFile* valencia_program_find_source (ValenciaProgram* self, const char* path);
void valencia_program_update (ValenciaProgram* self, const char* path, const char* contents);
ValenciaProgram* valencia_program_find_containing (const char* path, gboolean parse_system_vapi);
ValenciaProgram* valencia_program_null_find_containing (const char* path);
void valencia_program_update_any (const char* path, const char* contents);
void valencia_program_rescan_build_root (const char* sourcefile_path);
char* valencia_program_get_top_directory (ValenciaProgram* self);
char* valencia_program_get_binary_run_path (ValenciaProgram* self);
gboolean valencia_program_get_binary_is_executable (ValenciaProgram* self);
void valencia_program_reparse_makefile (ValenciaProgram* self);
char* valencia_program_get_path_for_filename (ValenciaProgram* self, const char* filename);
gboolean valencia_program_is_parsing (ValenciaProgram* self);
GType valencia_scan_scope_get_type (void);
ValenciaScanScope* valencia_scan_scope_new (gint depth, gint start_pos, gint end_pos);
ValenciaScanScope* valencia_scan_scope_construct (GType object_type, gint depth, gint start_pos, gint end_pos);
GType valencia_parse_info_get_type (void);
ValenciaParseInfo* valencia_parse_info_new (ValenciaExpression* inner);
ValenciaParseInfo* valencia_parse_info_construct (GType object_type, ValenciaExpression* inner);
GType valencia_parser_get_type (void);
void valencia_parser_parse (ValenciaParser* self, ValenciaSourceFile* source, const char* input);
ValenciaScanScope* valencia_parser_find_enclosing_scope (ValenciaParser* self, const char* input, gint pos, gboolean classes_only);
ValenciaParser* valencia_parser_new (void);
ValenciaParser* valencia_parser_construct (GType object_type);
char* valencia_expression_to_string (ValenciaExpression* self);
GType valencia_id_get_type (void);
ValenciaId* valencia_id_new (const char* name);
ValenciaId* valencia_id_construct (GType object_type, const char* name);
GType valencia_this_get_type (void);
ValenciaThis* valencia_this_new (void);
ValenciaThis* valencia_this_construct (GType object_type);
GType valencia_base_get_type (void);
ValenciaBase* valencia_base_new (void);
ValenciaBase* valencia_base_construct (GType object_type);
GType valencia_new_get_type (void);
ValenciaNew* valencia_new_new (ValenciaExpression* class_name);
ValenciaNew* valencia_new_construct (GType object_type, ValenciaExpression* class_name);
GType valencia_method_call_get_type (void);
ValenciaMethodCall* valencia_method_call_new (ValenciaExpression* method);
ValenciaMethodCall* valencia_method_call_construct (GType object_type, ValenciaExpression* method);
GType valencia_compound_expression_get_type (void);
ValenciaCompoundExpression* valencia_compound_expression_new (ValenciaExpression* left, const char* right);
ValenciaCompoundExpression* valencia_compound_expression_construct (GType object_type, ValenciaExpression* left, const char* right);
Proposal* proposal_new (const char* label, GdkPixbuf* icon);
Proposal* proposal_construct (GType object_type, const char* label, GdkPixbuf* icon);
const char* proposal_get_label (Proposal* self);
void proposal_set_label (Proposal* self, const char* value);
GdkPixbuf* proposal_get_icon (Proposal* self);
void proposal_set_icon (Proposal* self, GdkPixbuf* value);


G_END_DECLS

#endif
