
#ifndef __DEBUG_PLUGINS_FILE_BROWSER_FILE_BROWSER_H__
#define __DEBUG_PLUGINS_FILE_BROWSER_FILE_BROWSER_H__

#include <glib.h>
#include <glib-object.h>
#include <valide-0.0.h>

G_BEGIN_DECLS


#define TYPE_FILE_BROWSER (file_browser_get_type ())
#define FILE_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_BROWSER, FileBrowser))
#define FILE_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_BROWSER, FileBrowserClass))
#define IS_FILE_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_BROWSER))
#define IS_FILE_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_BROWSER))
#define FILE_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_BROWSER, FileBrowserClass))

typedef struct _FileBrowser FileBrowser;
typedef struct _FileBrowserClass FileBrowserClass;
typedef struct _FileBrowserPrivate FileBrowserPrivate;

struct _FileBrowser {
	GObject parent_instance;
	FileBrowserPrivate * priv;
};

struct _FileBrowserClass {
	GObjectClass parent_class;
};


GType file_browser_get_type (void);
FileBrowser* file_browser_new (void);
FileBrowser* file_browser_construct (GType object_type);
GType register_plugin (void);


G_END_DECLS

#endif
