
#ifndef __DEBUG_PLUGINS_SYMBOL_SYMBOL_H__
#define __DEBUG_PLUGINS_SYMBOL_SYMBOL_H__

#include <glib.h>
#include <glib-object.h>
#include <valide-0.0.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

G_BEGIN_DECLS


#define TYPE_SYMBOL_BROWSER (symbol_browser_get_type ())
#define SYMBOL_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYMBOL_BROWSER, SymbolBrowser))
#define SYMBOL_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYMBOL_BROWSER, SymbolBrowserClass))
#define IS_SYMBOL_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYMBOL_BROWSER))
#define IS_SYMBOL_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYMBOL_BROWSER))
#define SYMBOL_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYMBOL_BROWSER, SymbolBrowserClass))

typedef struct _SymbolBrowser SymbolBrowser;
typedef struct _SymbolBrowserClass SymbolBrowserClass;
typedef struct _SymbolBrowserPrivate SymbolBrowserPrivate;

struct _SymbolBrowser {
	GObject parent_instance;
	SymbolBrowserPrivate * priv;
};

struct _SymbolBrowserClass {
	GObjectClass parent_class;
};


GType symbol_browser_get_type (void);
SymbolBrowser* symbol_browser_new (const char* path);
SymbolBrowser* symbol_browser_construct (GType object_type, const char* path);
GtkWidget* symbol_browser_create_configure_dialog (SymbolBrowser* self);
GType register_plugin (void);
GtkWidget* create_configure_dialog (SymbolBrowser* _self_);


G_END_DECLS

#endif
