
#ifndef __DEBUG_LIBVALIDE_VALIDE_0_0_H__
#define __DEBUG_LIBVALIDE_VALIDE_0_0_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gdk/gdk.h>
#include <gtksourceview/gtksourceview.h>
#include <gio/gio.h>
#include <yaml.h>
#include <stdio.h>
#include <float.h>
#include <math.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_POSITION (valide_position_get_type ())
typedef struct _ValidePosition ValidePosition;

#define VALIDE_TYPE_UTILS (valide_utils_get_type ())
#define VALIDE_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_UTILS, ValideUtils))
#define VALIDE_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_UTILS, ValideUtilsClass))
#define VALIDE_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_UTILS))
#define VALIDE_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_UTILS))
#define VALIDE_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_UTILS, ValideUtilsClass))

typedef struct _ValideUtils ValideUtils;
typedef struct _ValideUtilsClass ValideUtilsClass;
typedef struct _ValideUtilsPrivate ValideUtilsPrivate;

#define VALIDE_UTILS_TYPE_COLOR (valide_utils_color_get_type ())
#define VALIDE_UTILS_COLOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_UTILS_TYPE_COLOR, ValideUtilsColor))
#define VALIDE_UTILS_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_UTILS_TYPE_COLOR, ValideUtilsColorClass))
#define VALIDE_UTILS_IS_COLOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_UTILS_TYPE_COLOR))
#define VALIDE_UTILS_IS_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_UTILS_TYPE_COLOR))
#define VALIDE_UTILS_COLOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_UTILS_TYPE_COLOR, ValideUtilsColorClass))

typedef struct _ValideUtilsColor ValideUtilsColor;
typedef struct _ValideUtilsColorClass ValideUtilsColorClass;
typedef struct _ValideUtilsColorPrivate ValideUtilsColorPrivate;

#define VALIDE_TYPE_ENCODING (valide_encoding_get_type ())
#define VALIDE_ENCODING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ENCODING, ValideEncoding))
#define VALIDE_ENCODING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ENCODING, ValideEncodingClass))
#define VALIDE_IS_ENCODING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ENCODING))
#define VALIDE_IS_ENCODING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ENCODING))
#define VALIDE_ENCODING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ENCODING, ValideEncodingClass))

typedef struct _ValideEncoding ValideEncoding;
typedef struct _ValideEncodingClass ValideEncodingClass;
typedef struct _ValideEncodingPrivate ValideEncodingPrivate;

#define VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG (valide_abstract_close_dialog_get_type ())
#define VALIDE_ABSTRACT_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG, ValideAbstractCloseDialog))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG, ValideAbstractCloseDialogClass))
#define VALIDE_IS_ABSTRACT_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG))
#define VALIDE_IS_ABSTRACT_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG, ValideAbstractCloseDialogClass))

typedef struct _ValideAbstractCloseDialog ValideAbstractCloseDialog;
typedef struct _ValideAbstractCloseDialogClass ValideAbstractCloseDialogClass;
typedef struct _ValideAbstractCloseDialogPrivate ValideAbstractCloseDialogPrivate;

#define VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS (valide_abstract_close_dialog_window_widgets_get_type ())
#define VALIDE_ABSTRACT_CLOSE_DIALOG_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractCloseDialogwindow_widgets))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractCloseDialogwindow_widgetsClass))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_IS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_IS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_WINDOW_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractCloseDialogwindow_widgetsClass))

typedef struct _ValideAbstractCloseDialogwindow_widgets ValideAbstractCloseDialogwindow_widgets;
typedef struct _ValideAbstractCloseDialogwindow_widgetsClass ValideAbstractCloseDialogwindow_widgetsClass;

#define VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG (valide_document_close_dialog_get_type ())
#define VALIDE_DOCUMENT_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG, ValideDocumentCloseDialog))
#define VALIDE_DOCUMENT_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG, ValideDocumentCloseDialogClass))
#define VALIDE_IS_DOCUMENT_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG))
#define VALIDE_IS_DOCUMENT_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG))
#define VALIDE_DOCUMENT_CLOSE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG, ValideDocumentCloseDialogClass))

typedef struct _ValideDocumentCloseDialog ValideDocumentCloseDialog;
typedef struct _ValideDocumentCloseDialogClass ValideDocumentCloseDialogClass;
typedef struct _ValideDocumentCloseDialogPrivate ValideDocumentCloseDialogPrivate;

#define VALIDE_TYPE_IDOCUMENT (valide_idocument_get_type ())
#define VALIDE_IDOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_IDOCUMENT, ValideiDocument))
#define VALIDE_IS_IDOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_IDOCUMENT))
#define VALIDE_IDOCUMENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_IDOCUMENT, ValideiDocumentIface))

typedef struct _ValideiDocument ValideiDocument;
typedef struct _ValideiDocumentIface ValideiDocumentIface;

#define VALIDE_TYPE_UI_MANAGER (valide_ui_manager_get_type ())
#define VALIDE_UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_UI_MANAGER, ValideUIManager))
#define VALIDE_UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_UI_MANAGER, ValideUIManagerClass))
#define VALIDE_IS_UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_UI_MANAGER))
#define VALIDE_IS_UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_UI_MANAGER))
#define VALIDE_UI_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_UI_MANAGER, ValideUIManagerClass))

typedef struct _ValideUIManager ValideUIManager;
typedef struct _ValideUIManagerClass ValideUIManagerClass;

#define VALIDE_TYPE_DOCUMENT_STATE (valide_document_state_get_type ())

#define VALIDE_TYPE_EXECUTABLE (valide_executable_get_type ())
#define VALIDE_EXECUTABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_EXECUTABLE, ValideExecutable))
#define VALIDE_EXECUTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_EXECUTABLE, ValideExecutableClass))
#define VALIDE_IS_EXECUTABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_EXECUTABLE))
#define VALIDE_IS_EXECUTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_EXECUTABLE))
#define VALIDE_EXECUTABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_EXECUTABLE, ValideExecutableClass))

typedef struct _ValideExecutable ValideExecutable;
typedef struct _ValideExecutableClass ValideExecutableClass;
typedef struct _ValideExecutablePrivate ValideExecutablePrivate;

#define VALIDE_TYPE_COMPILER (valide_compiler_get_type ())
#define VALIDE_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_COMPILER, ValideCompiler))
#define VALIDE_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_COMPILER, ValideCompilerClass))
#define VALIDE_IS_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_COMPILER))
#define VALIDE_IS_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_COMPILER))
#define VALIDE_COMPILER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_COMPILER, ValideCompilerClass))

typedef struct _ValideCompiler ValideCompiler;
typedef struct _ValideCompilerClass ValideCompilerClass;
typedef struct _ValideCompilerPrivate ValideCompilerPrivate;

#define VALIDE_TYPE_PROJECT (valide_project_get_type ())
#define VALIDE_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT, ValideProject))
#define VALIDE_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT, ValideProjectClass))
#define VALIDE_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT))
#define VALIDE_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT))
#define VALIDE_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT, ValideProjectClass))

typedef struct _ValideProject ValideProject;
typedef struct _ValideProjectClass ValideProjectClass;

#define G_YAML_TYPE_BUILDABLE (g_yaml_buildable_get_type ())
#define G_YAML_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildable))
#define G_YAML_IS_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDABLE))
#define G_YAML_BUILDABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildableIface))

typedef struct _GYAMLBuildable GYAMLBuildable;
typedef struct _GYAMLBuildableIface GYAMLBuildableIface;

#define G_YAML_TYPE_BUILDER (g_yaml_builder_get_type ())
#define G_YAML_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilder))
#define G_YAML_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))
#define G_YAML_IS_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDER))
#define G_YAML_IS_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_BUILDER))
#define G_YAML_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))

typedef struct _GYAMLBuilder GYAMLBuilder;
typedef struct _GYAMLBuilderClass GYAMLBuilderClass;

#define G_YAML_TYPE_NODE (g_yaml_node_get_type ())
#define G_YAML_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_NODE, GYAMLNode))
#define G_YAML_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_NODE, GYAMLNodeClass))
#define G_YAML_IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_NODE))
#define G_YAML_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_NODE))
#define G_YAML_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_NODE, GYAMLNodeClass))

typedef struct _GYAMLNode GYAMLNode;
typedef struct _GYAMLNodeClass GYAMLNodeClass;

#define VALIDE_TYPE_SOURCE (valide_source_get_type ())
#define VALIDE_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SOURCE, ValideSource))
#define VALIDE_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SOURCE, ValideSourceClass))
#define VALIDE_IS_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SOURCE))
#define VALIDE_IS_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SOURCE))
#define VALIDE_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SOURCE, ValideSourceClass))

typedef struct _ValideSource ValideSource;
typedef struct _ValideSourceClass ValideSourceClass;
typedef struct _ValideSourcePrivate ValideSourcePrivate;

#define VALIDE_TYPE_VAPI_DIR (valide_vapi_dir_get_type ())
#define VALIDE_VAPI_DIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_VAPI_DIR, ValideVapiDir))
#define VALIDE_VAPI_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_VAPI_DIR, ValideVapiDirClass))
#define VALIDE_IS_VAPI_DIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_VAPI_DIR))
#define VALIDE_IS_VAPI_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_VAPI_DIR))
#define VALIDE_VAPI_DIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_VAPI_DIR, ValideVapiDirClass))

typedef struct _ValideVapiDir ValideVapiDir;
typedef struct _ValideVapiDirClass ValideVapiDirClass;
typedef struct _ValideVapiDirPrivate ValideVapiDirPrivate;

#define VALIDE_TYPE_PACKAGE (valide_package_get_type ())
#define VALIDE_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PACKAGE, ValidePackage))
#define VALIDE_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PACKAGE, ValidePackageClass))
#define VALIDE_IS_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PACKAGE))
#define VALIDE_IS_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PACKAGE))
#define VALIDE_PACKAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PACKAGE, ValidePackageClass))

typedef struct _ValidePackage ValidePackage;
typedef struct _ValidePackageClass ValidePackageClass;
typedef struct _ValidePackagePrivate ValidePackagePrivate;
typedef struct _ValideProjectPrivate ValideProjectPrivate;

#define VALIDE_TYPE_BUILDER_MANAGER (valide_builder_manager_get_type ())
#define VALIDE_BUILDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManager))
#define VALIDE_BUILDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManagerClass))
#define VALIDE_IS_BUILDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER_MANAGER))
#define VALIDE_IS_BUILDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_BUILDER_MANAGER))
#define VALIDE_BUILDER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManagerClass))

typedef struct _ValideBuilderManager ValideBuilderManager;
typedef struct _ValideBuilderManagerClass ValideBuilderManagerClass;

#define VALIDE_TYPE_DOCUMENT_MANAGER (valide_document_manager_get_type ())
#define VALIDE_DOCUMENT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_DOCUMENT_MANAGER, ValideDocumentManager))
#define VALIDE_DOCUMENT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_DOCUMENT_MANAGER, ValideDocumentManagerClass))
#define VALIDE_IS_DOCUMENT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_DOCUMENT_MANAGER))
#define VALIDE_IS_DOCUMENT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_DOCUMENT_MANAGER))
#define VALIDE_DOCUMENT_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_DOCUMENT_MANAGER, ValideDocumentManagerClass))

typedef struct _ValideDocumentManager ValideDocumentManager;
typedef struct _ValideDocumentManagerClass ValideDocumentManagerClass;

#define VALIDE_TYPE_BUILDER_OPTIONS (valide_builder_options_get_type ())
#define VALIDE_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER_OPTIONS, ValideBuilderOptions))
#define VALIDE_IS_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER_OPTIONS))
#define VALIDE_BUILDER_OPTIONS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_BUILDER_OPTIONS, ValideBuilderOptionsIface))

typedef struct _ValideBuilderOptions ValideBuilderOptions;
typedef struct _ValideBuilderOptionsIface ValideBuilderOptionsIface;

#define VALIDE_TYPE_EXECUTABLE_OPTIONS (valide_executable_options_get_type ())
#define VALIDE_EXECUTABLE_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_EXECUTABLE_OPTIONS, ValideExecutableOptions))
#define VALIDE_EXECUTABLE_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_EXECUTABLE_OPTIONS, ValideExecutableOptionsClass))
#define VALIDE_IS_EXECUTABLE_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_EXECUTABLE_OPTIONS))
#define VALIDE_IS_EXECUTABLE_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_EXECUTABLE_OPTIONS))
#define VALIDE_EXECUTABLE_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_EXECUTABLE_OPTIONS, ValideExecutableOptionsClass))

typedef struct _ValideExecutableOptions ValideExecutableOptions;
typedef struct _ValideExecutableOptionsClass ValideExecutableOptionsClass;

#define VALIDE_TYPE_RECENT_MANAGER_UI (valide_recent_manager_ui_get_type ())
#define VALIDE_RECENT_MANAGER_UI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_RECENT_MANAGER_UI, ValideRecentManagerUI))
#define VALIDE_RECENT_MANAGER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_RECENT_MANAGER_UI, ValideRecentManagerUIClass))
#define VALIDE_IS_RECENT_MANAGER_UI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_RECENT_MANAGER_UI))
#define VALIDE_IS_RECENT_MANAGER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_RECENT_MANAGER_UI))
#define VALIDE_RECENT_MANAGER_UI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_RECENT_MANAGER_UI, ValideRecentManagerUIClass))

typedef struct _ValideRecentManagerUI ValideRecentManagerUI;
typedef struct _ValideRecentManagerUIClass ValideRecentManagerUIClass;
typedef struct _ValideRecentManagerUIPrivate ValideRecentManagerUIPrivate;

#define VALIDE_TYPE_PROJECT_MANAGER (valide_project_manager_get_type ())
#define VALIDE_PROJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_MANAGER, ValideProjectManager))
#define VALIDE_PROJECT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_MANAGER, ValideProjectManagerClass))
#define VALIDE_IS_PROJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_MANAGER))
#define VALIDE_IS_PROJECT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_MANAGER))
#define VALIDE_PROJECT_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_MANAGER, ValideProjectManagerClass))

typedef struct _ValideProjectManager ValideProjectManager;
typedef struct _ValideProjectManagerClass ValideProjectManagerClass;

#define VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER (valide_abstract_config_manager_get_type ())
#define VALIDE_ABSTRACT_CONFIG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER, ValideAbstractConfigManager))
#define VALIDE_ABSTRACT_CONFIG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER, ValideAbstractConfigManagerClass))
#define VALIDE_IS_ABSTRACT_CONFIG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER))
#define VALIDE_IS_ABSTRACT_CONFIG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER))
#define VALIDE_ABSTRACT_CONFIG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER, ValideAbstractConfigManagerClass))

typedef struct _ValideAbstractConfigManager ValideAbstractConfigManager;
typedef struct _ValideAbstractConfigManagerClass ValideAbstractConfigManagerClass;
typedef struct _ValideAbstractConfigManagerPrivate ValideAbstractConfigManagerPrivate;

#define VALIDE_TYPE_WINDOW (valide_window_get_type ())
#define VALIDE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_WINDOW, ValideWindow))
#define VALIDE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_WINDOW, ValideWindowClass))
#define VALIDE_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_WINDOW))
#define VALIDE_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_WINDOW))
#define VALIDE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_WINDOW, ValideWindowClass))

typedef struct _ValideWindow ValideWindow;
typedef struct _ValideWindowClass ValideWindowClass;

#define VALIDE_TYPE_CONFIG_MANAGER (valide_config_manager_get_type ())
#define VALIDE_CONFIG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_CONFIG_MANAGER, ValideConfigManager))
#define VALIDE_CONFIG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_CONFIG_MANAGER, ValideConfigManagerClass))
#define VALIDE_IS_CONFIG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_CONFIG_MANAGER))
#define VALIDE_IS_CONFIG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_CONFIG_MANAGER))
#define VALIDE_CONFIG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_CONFIG_MANAGER, ValideConfigManagerClass))

typedef struct _ValideConfigManager ValideConfigManager;
typedef struct _ValideConfigManagerClass ValideConfigManagerClass;
typedef struct _ValideConfigManagerPrivate ValideConfigManagerPrivate;
typedef struct _ValideDocumentManagerPrivate ValideDocumentManagerPrivate;

#define VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT (valide_abstract_text_document_get_type ())
#define VALIDE_ABSTRACT_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT, ValideAbstractTextDocument))
#define VALIDE_ABSTRACT_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT, ValideAbstractTextDocumentClass))
#define VALIDE_IS_ABSTRACT_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT))
#define VALIDE_IS_ABSTRACT_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT))
#define VALIDE_ABSTRACT_TEXT_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT, ValideAbstractTextDocumentClass))

typedef struct _ValideAbstractTextDocument ValideAbstractTextDocument;
typedef struct _ValideAbstractTextDocumentClass ValideAbstractTextDocumentClass;
typedef struct _ValideBuilderManagerPrivate ValideBuilderManagerPrivate;

#define VALIDE_TYPE_BUILDER (valide_builder_get_type ())
#define VALIDE_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER, ValideBuilder))
#define VALIDE_IS_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER))
#define VALIDE_BUILDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_BUILDER, ValideBuilderIface))

typedef struct _ValideBuilder ValideBuilder;
typedef struct _ValideBuilderIface ValideBuilderIface;

#define VALIDE_TYPE_EXECUTABLE_MANAGER (valide_executable_manager_get_type ())
#define VALIDE_EXECUTABLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManager))
#define VALIDE_EXECUTABLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManagerClass))
#define VALIDE_IS_EXECUTABLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER))
#define VALIDE_IS_EXECUTABLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_EXECUTABLE_MANAGER))
#define VALIDE_EXECUTABLE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManagerClass))

typedef struct _ValideExecutableManager ValideExecutableManager;
typedef struct _ValideExecutableManagerClass ValideExecutableManagerClass;

#define VALIDE_TYPE_SPLIT_SOURCE_VIEW (valide_split_source_view_get_type ())
#define VALIDE_SPLIT_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SPLIT_SOURCE_VIEW, ValideSplitSourceView))
#define VALIDE_SPLIT_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SPLIT_SOURCE_VIEW, ValideSplitSourceViewClass))
#define VALIDE_IS_SPLIT_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SPLIT_SOURCE_VIEW))
#define VALIDE_IS_SPLIT_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SPLIT_SOURCE_VIEW))
#define VALIDE_SPLIT_SOURCE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SPLIT_SOURCE_VIEW, ValideSplitSourceViewClass))

typedef struct _ValideSplitSourceView ValideSplitSourceView;
typedef struct _ValideSplitSourceViewClass ValideSplitSourceViewClass;
typedef struct _ValideSplitSourceViewPrivate ValideSplitSourceViewPrivate;

#define VALIDE_TYPE_SOURCE_VIEW (valide_source_view_get_type ())
#define VALIDE_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SOURCE_VIEW, ValideSourceView))
#define VALIDE_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SOURCE_VIEW, ValideSourceViewClass))
#define VALIDE_IS_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SOURCE_VIEW))
#define VALIDE_IS_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SOURCE_VIEW))
#define VALIDE_SOURCE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SOURCE_VIEW, ValideSourceViewClass))

typedef struct _ValideSourceView ValideSourceView;
typedef struct _ValideSourceViewClass ValideSourceViewClass;

#define VALIDE_TYPE_TEMPLATE (valide_template_get_type ())
#define VALIDE_TEMPLATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_TEMPLATE, ValideTemplate))
#define VALIDE_TEMPLATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_TEMPLATE, ValideTemplateClass))
#define VALIDE_IS_TEMPLATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_TEMPLATE))
#define VALIDE_IS_TEMPLATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_TEMPLATE))
#define VALIDE_TEMPLATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_TEMPLATE, ValideTemplateClass))

typedef struct _ValideTemplate ValideTemplate;
typedef struct _ValideTemplateClass ValideTemplateClass;
typedef struct _ValideTemplatePrivate ValideTemplatePrivate;

#define VALIDE_TYPE_STATUSBAR (valide_statusbar_get_type ())
#define VALIDE_STATUSBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_STATUSBAR, ValideStatusbar))
#define VALIDE_STATUSBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_STATUSBAR, ValideStatusbarClass))
#define VALIDE_IS_STATUSBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_STATUSBAR))
#define VALIDE_IS_STATUSBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_STATUSBAR))
#define VALIDE_STATUSBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_STATUSBAR, ValideStatusbarClass))

typedef struct _ValideStatusbar ValideStatusbar;
typedef struct _ValideStatusbarClass ValideStatusbarClass;
typedef struct _ValideStatusbarPrivate ValideStatusbarPrivate;

#define VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG (valide_abstract_project_dialog_get_type ())
#define VALIDE_ABSTRACT_PROJECT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG, ValideAbstractProjectDialog))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG, ValideAbstractProjectDialogClass))
#define VALIDE_IS_ABSTRACT_PROJECT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG))
#define VALIDE_IS_ABSTRACT_PROJECT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG, ValideAbstractProjectDialogClass))

typedef struct _ValideAbstractProjectDialog ValideAbstractProjectDialog;
typedef struct _ValideAbstractProjectDialogClass ValideAbstractProjectDialogClass;
typedef struct _ValideAbstractProjectDialogPrivate ValideAbstractProjectDialogPrivate;

#define VALIDE_ABSTRACT_PROJECT_DIALOG_TYPE_WINDOW_WIDGETS (valide_abstract_project_dialog_window_widgets_get_type ())
#define VALIDE_ABSTRACT_PROJECT_DIALOG_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogwindow_widgets))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_ABSTRACT_PROJECT_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogwindow_widgetsClass))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_IS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_IS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_ABSTRACT_PROJECT_DIALOG_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_WINDOW_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogwindow_widgetsClass))

typedef struct _ValideAbstractProjectDialogwindow_widgets ValideAbstractProjectDialogwindow_widgets;
typedef struct _ValideAbstractProjectDialogwindow_widgetsClass ValideAbstractProjectDialogwindow_widgetsClass;

#define VALIDE_TYPE_PROJECT_DIALOG (valide_project_dialog_get_type ())
#define VALIDE_PROJECT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_DIALOG, ValideProjectDialog))
#define VALIDE_PROJECT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_DIALOG, ValideProjectDialogClass))
#define VALIDE_IS_PROJECT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_DIALOG))
#define VALIDE_IS_PROJECT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_DIALOG))
#define VALIDE_PROJECT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_DIALOG, ValideProjectDialogClass))

typedef struct _ValideProjectDialog ValideProjectDialog;
typedef struct _ValideProjectDialogClass ValideProjectDialogClass;
typedef struct _ValideProjectDialogPrivate ValideProjectDialogPrivate;

#define VALIDE_TYPE_PLUGIN (valide_plugin_get_type ())
#define VALIDE_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PLUGIN, ValidePlugin))
#define VALIDE_IS_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PLUGIN))
#define VALIDE_PLUGIN_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_PLUGIN, ValidePluginIface))

typedef struct _ValidePlugin ValidePlugin;
typedef struct _ValidePluginIface ValidePluginIface;

#define G_YAML_TYPE_WRITER (g_yaml_writer_get_type ())
#define G_YAML_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_WRITER, GYAMLWriter))
#define G_YAML_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_WRITER, GYAMLWriterClass))
#define G_YAML_IS_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_WRITER))
#define G_YAML_IS_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_WRITER))
#define G_YAML_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_WRITER, GYAMLWriterClass))

typedef struct _GYAMLWriter GYAMLWriter;
typedef struct _GYAMLWriterClass GYAMLWriterClass;
typedef struct _GYAMLWriterPrivate GYAMLWriterPrivate;
typedef struct _GYAMLNodePrivate GYAMLNodePrivate;

#define G_YAML_NODE_TYPE_ALIAS (g_yaml_node_alias_get_type ())
#define G_YAML_NODE_ALIAS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_NODE_TYPE_ALIAS, GYAMLNodeAlias))
#define G_YAML_NODE_ALIAS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_NODE_TYPE_ALIAS, GYAMLNodeAliasClass))
#define G_YAML_NODE_IS_ALIAS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_NODE_TYPE_ALIAS))
#define G_YAML_NODE_IS_ALIAS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_NODE_TYPE_ALIAS))
#define G_YAML_NODE_ALIAS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_NODE_TYPE_ALIAS, GYAMLNodeAliasClass))

typedef struct _GYAMLNodeAlias GYAMLNodeAlias;
typedef struct _GYAMLNodeAliasClass GYAMLNodeAliasClass;
typedef struct _GYAMLNodeAliasPrivate GYAMLNodeAliasPrivate;

#define G_YAML_NODE_TYPE_SCALAR (g_yaml_node_scalar_get_type ())
#define G_YAML_NODE_SCALAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_NODE_TYPE_SCALAR, GYAMLNodeScalar))
#define G_YAML_NODE_SCALAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_NODE_TYPE_SCALAR, GYAMLNodeScalarClass))
#define G_YAML_NODE_IS_SCALAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_NODE_TYPE_SCALAR))
#define G_YAML_NODE_IS_SCALAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_NODE_TYPE_SCALAR))
#define G_YAML_NODE_SCALAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_NODE_TYPE_SCALAR, GYAMLNodeScalarClass))

typedef struct _GYAMLNodeScalar GYAMLNodeScalar;
typedef struct _GYAMLNodeScalarClass GYAMLNodeScalarClass;
typedef struct _GYAMLNodeScalarPrivate GYAMLNodeScalarPrivate;

#define G_YAML_NODE_TYPE_SEQUENCE (g_yaml_node_sequence_get_type ())
#define G_YAML_NODE_SEQUENCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_NODE_TYPE_SEQUENCE, GYAMLNodeSequence))
#define G_YAML_NODE_SEQUENCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_NODE_TYPE_SEQUENCE, GYAMLNodeSequenceClass))
#define G_YAML_NODE_IS_SEQUENCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_NODE_TYPE_SEQUENCE))
#define G_YAML_NODE_IS_SEQUENCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_NODE_TYPE_SEQUENCE))
#define G_YAML_NODE_SEQUENCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_NODE_TYPE_SEQUENCE, GYAMLNodeSequenceClass))

typedef struct _GYAMLNodeSequence GYAMLNodeSequence;
typedef struct _GYAMLNodeSequenceClass GYAMLNodeSequenceClass;
typedef struct _GYAMLNodeSequencePrivate GYAMLNodeSequencePrivate;

#define G_YAML_NODE_TYPE_MAPPING (g_yaml_node_mapping_get_type ())
#define G_YAML_NODE_MAPPING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_NODE_TYPE_MAPPING, GYAMLNodeMapping))
#define G_YAML_NODE_MAPPING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_NODE_TYPE_MAPPING, GYAMLNodeMappingClass))
#define G_YAML_NODE_IS_MAPPING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_NODE_TYPE_MAPPING))
#define G_YAML_NODE_IS_MAPPING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_NODE_TYPE_MAPPING))
#define G_YAML_NODE_MAPPING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_NODE_TYPE_MAPPING, GYAMLNodeMappingClass))

typedef struct _GYAMLNodeMapping GYAMLNodeMapping;
typedef struct _GYAMLNodeMappingClass GYAMLNodeMappingClass;
typedef struct _GYAMLNodeMappingPrivate GYAMLNodeMappingPrivate;

#define G_YAML_TYPE_DOCUMENT (g_yaml_document_get_type ())
#define G_YAML_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_DOCUMENT, GYAMLDocument))
#define G_YAML_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_DOCUMENT, GYAMLDocumentClass))
#define G_YAML_IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_DOCUMENT))
#define G_YAML_IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_DOCUMENT))
#define G_YAML_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_DOCUMENT, GYAMLDocumentClass))

typedef struct _GYAMLDocument GYAMLDocument;
typedef struct _GYAMLDocumentClass GYAMLDocumentClass;
typedef struct _GYAMLDocumentPrivate GYAMLDocumentPrivate;
typedef struct _GYAMLBuilderPrivate GYAMLBuilderPrivate;

#define VALIDE_TYPE_SEARCHING (valide_searching_get_type ())
#define VALIDE_SEARCHING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SEARCHING, ValideSearching))
#define VALIDE_SEARCHING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SEARCHING, ValideSearchingClass))
#define VALIDE_IS_SEARCHING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SEARCHING))
#define VALIDE_IS_SEARCHING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SEARCHING))
#define VALIDE_SEARCHING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SEARCHING, ValideSearchingClass))

typedef struct _ValideSearching ValideSearching;
typedef struct _ValideSearchingClass ValideSearchingClass;
typedef struct _ValideSearchingPrivate ValideSearchingPrivate;

#define VALIDE_TYPE_ABSTRACT_PREFERENCES_DIALOG (valide_abstract_preferences_dialog_get_type ())
#define VALIDE_ABSTRACT_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_PREFERENCES_DIALOG, ValideAbstractPreferencesDialog))
#define VALIDE_ABSTRACT_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_PREFERENCES_DIALOG, ValideAbstractPreferencesDialogClass))
#define VALIDE_IS_ABSTRACT_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_PREFERENCES_DIALOG))
#define VALIDE_IS_ABSTRACT_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_PREFERENCES_DIALOG))
#define VALIDE_ABSTRACT_PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_PREFERENCES_DIALOG, ValideAbstractPreferencesDialogClass))

typedef struct _ValideAbstractPreferencesDialog ValideAbstractPreferencesDialog;
typedef struct _ValideAbstractPreferencesDialogClass ValideAbstractPreferencesDialogClass;
typedef struct _ValideAbstractPreferencesDialogPrivate ValideAbstractPreferencesDialogPrivate;

#define VALIDE_ABSTRACT_PREFERENCES_DIALOG_TYPE_WINDOW_WIDGETS (valide_abstract_preferences_dialog_window_widgets_get_type ())
#define VALIDE_ABSTRACT_PREFERENCES_DIALOG_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_ABSTRACT_PREFERENCES_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractPreferencesDialogwindow_widgets))
#define VALIDE_ABSTRACT_PREFERENCES_DIALOG_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_ABSTRACT_PREFERENCES_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractPreferencesDialogwindow_widgetsClass))
#define VALIDE_ABSTRACT_PREFERENCES_DIALOG_IS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_ABSTRACT_PREFERENCES_DIALOG_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PREFERENCES_DIALOG_IS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_ABSTRACT_PREFERENCES_DIALOG_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PREFERENCES_DIALOG_WINDOW_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_ABSTRACT_PREFERENCES_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractPreferencesDialogwindow_widgetsClass))

typedef struct _ValideAbstractPreferencesDialogwindow_widgets ValideAbstractPreferencesDialogwindow_widgets;
typedef struct _ValideAbstractPreferencesDialogwindow_widgetsClass ValideAbstractPreferencesDialogwindow_widgetsClass;

#define VALIDE_TYPE_PREFERENCES_DIALOG (valide_preferences_dialog_get_type ())
#define VALIDE_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PREFERENCES_DIALOG, ValidePreferencesDialog))
#define VALIDE_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PREFERENCES_DIALOG, ValidePreferencesDialogClass))
#define VALIDE_IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PREFERENCES_DIALOG))
#define VALIDE_IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PREFERENCES_DIALOG))
#define VALIDE_PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PREFERENCES_DIALOG, ValidePreferencesDialogClass))

typedef struct _ValidePreferencesDialog ValidePreferencesDialog;
typedef struct _ValidePreferencesDialogClass ValidePreferencesDialogClass;
typedef struct _ValidePreferencesDialogPrivate ValidePreferencesDialogPrivate;

#define VALIDE_TYPE_START_PAGE (valide_start_page_get_type ())
#define VALIDE_START_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_START_PAGE, ValideStartPage))
#define VALIDE_START_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_START_PAGE, ValideStartPageClass))
#define VALIDE_IS_START_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_START_PAGE))
#define VALIDE_IS_START_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_START_PAGE))
#define VALIDE_START_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_START_PAGE, ValideStartPageClass))

typedef struct _ValideStartPage ValideStartPage;
typedef struct _ValideStartPageClass ValideStartPageClass;
typedef struct _ValideStartPagePrivate ValideStartPagePrivate;

#define VALIDE_TYPE_PLUGIN_REGISTRAR (valide_plugin_registrar_get_type ())
#define VALIDE_PLUGIN_REGISTRAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PLUGIN_REGISTRAR, ValidePluginRegistrar))
#define VALIDE_PLUGIN_REGISTRAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PLUGIN_REGISTRAR, ValidePluginRegistrarClass))
#define VALIDE_IS_PLUGIN_REGISTRAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PLUGIN_REGISTRAR))
#define VALIDE_IS_PLUGIN_REGISTRAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PLUGIN_REGISTRAR))
#define VALIDE_PLUGIN_REGISTRAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PLUGIN_REGISTRAR, ValidePluginRegistrarClass))

typedef struct _ValidePluginRegistrar ValidePluginRegistrar;
typedef struct _ValidePluginRegistrarClass ValidePluginRegistrarClass;
typedef struct _ValidePluginRegistrarPrivate ValidePluginRegistrarPrivate;

#define VALIDE_TYPE_DOCUMENT_MESSAGE (valide_document_message_get_type ())
#define VALIDE_DOCUMENT_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessage))
#define VALIDE_DOCUMENT_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessageClass))
#define VALIDE_IS_DOCUMENT_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE))
#define VALIDE_IS_DOCUMENT_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_DOCUMENT_MESSAGE))
#define VALIDE_DOCUMENT_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessageClass))

typedef struct _ValideDocumentMessage ValideDocumentMessage;
typedef struct _ValideDocumentMessageClass ValideDocumentMessageClass;
typedef struct _ValideDocumentMessagePrivate ValideDocumentMessagePrivate;

#define VALIDE_TYPE_PLUGIN_MANAGER (valide_plugin_manager_get_type ())
#define VALIDE_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PLUGIN_MANAGER, ValidePluginManager))
#define VALIDE_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PLUGIN_MANAGER, ValidePluginManagerClass))
#define VALIDE_IS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PLUGIN_MANAGER))
#define VALIDE_IS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PLUGIN_MANAGER))
#define VALIDE_PLUGIN_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PLUGIN_MANAGER, ValidePluginManagerClass))

typedef struct _ValidePluginManager ValidePluginManager;
typedef struct _ValidePluginManagerClass ValidePluginManagerClass;
typedef struct _ValidePluginManagerPrivate ValidePluginManagerPrivate;

#define VALIDE_TYPE_PLUGIN_PREFERENCES (valide_plugin_preferences_get_type ())
#define VALIDE_PLUGIN_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PLUGIN_PREFERENCES, ValidePluginPreferences))
#define VALIDE_PLUGIN_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PLUGIN_PREFERENCES, ValidePluginPreferencesClass))
#define VALIDE_IS_PLUGIN_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PLUGIN_PREFERENCES))
#define VALIDE_IS_PLUGIN_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PLUGIN_PREFERENCES))
#define VALIDE_PLUGIN_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PLUGIN_PREFERENCES, ValidePluginPreferencesClass))

typedef struct _ValidePluginPreferences ValidePluginPreferences;
typedef struct _ValidePluginPreferencesClass ValidePluginPreferencesClass;
typedef struct _ValidePluginPreferencesPrivate ValidePluginPreferencesPrivate;

#define VALIDE_TYPE_TEMPLATE_MANAGER (valide_template_manager_get_type ())
#define VALIDE_TEMPLATE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_TEMPLATE_MANAGER, ValideTemplateManager))
#define VALIDE_TEMPLATE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_TEMPLATE_MANAGER, ValideTemplateManagerClass))
#define VALIDE_IS_TEMPLATE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_TEMPLATE_MANAGER))
#define VALIDE_IS_TEMPLATE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_TEMPLATE_MANAGER))
#define VALIDE_TEMPLATE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_TEMPLATE_MANAGER, ValideTemplateManagerClass))

typedef struct _ValideTemplateManager ValideTemplateManager;
typedef struct _ValideTemplateManagerClass ValideTemplateManagerClass;
typedef struct _ValideTemplateManagerPrivate ValideTemplateManagerPrivate;
typedef struct _ValideAbstractTextDocumentPrivate ValideAbstractTextDocumentPrivate;

#define VALIDE_TYPE_TXT_DOCUMENT (valide_txt_document_get_type ())
#define VALIDE_TXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_TXT_DOCUMENT, ValideTxtDocument))
#define VALIDE_TXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_TXT_DOCUMENT, ValideTxtDocumentClass))
#define VALIDE_IS_TXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_TXT_DOCUMENT))
#define VALIDE_IS_TXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_TXT_DOCUMENT))
#define VALIDE_TXT_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_TXT_DOCUMENT, ValideTxtDocumentClass))

typedef struct _ValideTxtDocument ValideTxtDocument;
typedef struct _ValideTxtDocumentClass ValideTxtDocumentClass;
typedef struct _ValideTxtDocumentPrivate ValideTxtDocumentPrivate;

#define VALIDE_TYPE_GS_DOCUMENT (valide_gs_document_get_type ())
#define VALIDE_GS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_GS_DOCUMENT, ValideGsDocument))
#define VALIDE_GS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_GS_DOCUMENT, ValideGsDocumentClass))
#define VALIDE_IS_GS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_GS_DOCUMENT))
#define VALIDE_IS_GS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_GS_DOCUMENT))
#define VALIDE_GS_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_GS_DOCUMENT, ValideGsDocumentClass))

typedef struct _ValideGsDocument ValideGsDocument;
typedef struct _ValideGsDocumentClass ValideGsDocumentClass;
typedef struct _ValideGsDocumentPrivate ValideGsDocumentPrivate;

#define VALIDE_TYPE_VALA_DOCUMENT (valide_vala_document_get_type ())
#define VALIDE_VALA_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_VALA_DOCUMENT, ValideValaDocument))
#define VALIDE_VALA_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_VALA_DOCUMENT, ValideValaDocumentClass))
#define VALIDE_IS_VALA_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_VALA_DOCUMENT))
#define VALIDE_IS_VALA_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_VALA_DOCUMENT))
#define VALIDE_VALA_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_VALA_DOCUMENT, ValideValaDocumentClass))

typedef struct _ValideValaDocument ValideValaDocument;
typedef struct _ValideValaDocumentClass ValideValaDocumentClass;
typedef struct _ValideValaDocumentPrivate ValideValaDocumentPrivate;

#define VALIDE_TYPE_VAPI_DOCUMENT (valide_vapi_document_get_type ())
#define VALIDE_VAPI_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_VAPI_DOCUMENT, ValideVapiDocument))
#define VALIDE_VAPI_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_VAPI_DOCUMENT, ValideVapiDocumentClass))
#define VALIDE_IS_VAPI_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_VAPI_DOCUMENT))
#define VALIDE_IS_VAPI_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_VAPI_DOCUMENT))
#define VALIDE_VAPI_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_VAPI_DOCUMENT, ValideVapiDocumentClass))

typedef struct _ValideVapiDocument ValideVapiDocument;
typedef struct _ValideVapiDocumentClass ValideVapiDocumentClass;
typedef struct _ValideVapiDocumentPrivate ValideVapiDocumentPrivate;

#define VALIDE_TYPE_XML_DOCUMENT (valide_xml_document_get_type ())
#define VALIDE_XML_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_XML_DOCUMENT, ValideXmlDocument))
#define VALIDE_XML_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_XML_DOCUMENT, ValideXmlDocumentClass))
#define VALIDE_IS_XML_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_XML_DOCUMENT))
#define VALIDE_IS_XML_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_XML_DOCUMENT))
#define VALIDE_XML_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_XML_DOCUMENT, ValideXmlDocumentClass))

typedef struct _ValideXmlDocument ValideXmlDocument;
typedef struct _ValideXmlDocumentClass ValideXmlDocumentClass;
typedef struct _ValideXmlDocumentPrivate ValideXmlDocumentPrivate;

#define VALIDE_TYPE_GLADE_DOCUMENT (valide_glade_document_get_type ())
#define VALIDE_GLADE_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_GLADE_DOCUMENT, ValideGladeDocument))
#define VALIDE_GLADE_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_GLADE_DOCUMENT, ValideGladeDocumentClass))
#define VALIDE_IS_GLADE_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_GLADE_DOCUMENT))
#define VALIDE_IS_GLADE_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_GLADE_DOCUMENT))
#define VALIDE_GLADE_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_GLADE_DOCUMENT, ValideGladeDocumentClass))

typedef struct _ValideGladeDocument ValideGladeDocument;
typedef struct _ValideGladeDocumentClass ValideGladeDocumentClass;
typedef struct _ValideGladeDocumentPrivate ValideGladeDocumentPrivate;

#define VALIDE_TYPE_UI_DOCUMENT (valide_ui_document_get_type ())
#define VALIDE_UI_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_UI_DOCUMENT, ValideUiDocument))
#define VALIDE_UI_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_UI_DOCUMENT, ValideUiDocumentClass))
#define VALIDE_IS_UI_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_UI_DOCUMENT))
#define VALIDE_IS_UI_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_UI_DOCUMENT))
#define VALIDE_UI_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_UI_DOCUMENT, ValideUiDocumentClass))

typedef struct _ValideUiDocument ValideUiDocument;
typedef struct _ValideUiDocumentClass ValideUiDocumentClass;
typedef struct _ValideUiDocumentPrivate ValideUiDocumentPrivate;

#define VALIDE_TYPE_GOTO_DIALOG (valide_goto_dialog_get_type ())
#define VALIDE_GOTO_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_GOTO_DIALOG, ValideGotoDialog))
#define VALIDE_GOTO_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_GOTO_DIALOG, ValideGotoDialogClass))
#define VALIDE_IS_GOTO_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_GOTO_DIALOG))
#define VALIDE_IS_GOTO_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_GOTO_DIALOG))
#define VALIDE_GOTO_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_GOTO_DIALOG, ValideGotoDialogClass))

typedef struct _ValideGotoDialog ValideGotoDialog;
typedef struct _ValideGotoDialogClass ValideGotoDialogClass;
typedef struct _ValideGotoDialogPrivate ValideGotoDialogPrivate;
typedef struct _ValideUIManagerPrivate ValideUIManagerPrivate;

#define VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE (valide_abstract_project_dialog_remove_get_type ())
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE, ValideAbstractProjectDialogRemove))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE, ValideAbstractProjectDialogRemoveClass))
#define VALIDE_IS_ABSTRACT_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE))
#define VALIDE_IS_ABSTRACT_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE, ValideAbstractProjectDialogRemoveClass))

typedef struct _ValideAbstractProjectDialogRemove ValideAbstractProjectDialogRemove;
typedef struct _ValideAbstractProjectDialogRemoveClass ValideAbstractProjectDialogRemoveClass;
typedef struct _ValideAbstractProjectDialogRemovePrivate ValideAbstractProjectDialogRemovePrivate;

#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS (valide_abstract_project_dialog_remove_window_widgets_get_type ())
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogRemovewindow_widgets))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogRemovewindow_widgetsClass))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_IS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_IS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_WINDOW_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogRemovewindow_widgetsClass))

typedef struct _ValideAbstractProjectDialogRemovewindow_widgets ValideAbstractProjectDialogRemovewindow_widgets;
typedef struct _ValideAbstractProjectDialogRemovewindow_widgetsClass ValideAbstractProjectDialogRemovewindow_widgetsClass;

#define VALIDE_TYPE_PROJECT_DIALOG_REMOVE (valide_project_dialog_remove_get_type ())
#define VALIDE_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemove))
#define VALIDE_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemoveClass))
#define VALIDE_IS_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE))
#define VALIDE_IS_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_DIALOG_REMOVE))
#define VALIDE_PROJECT_DIALOG_REMOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemoveClass))

typedef struct _ValideProjectDialogRemove ValideProjectDialogRemove;
typedef struct _ValideProjectDialogRemoveClass ValideProjectDialogRemoveClass;
typedef struct _ValideProjectDialogRemovePrivate ValideProjectDialogRemovePrivate;

#define VALIDE_TYPE_SOURCE_BUFFER (valide_source_buffer_get_type ())
#define VALIDE_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SOURCE_BUFFER, ValideSourceBuffer))
#define VALIDE_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SOURCE_BUFFER, ValideSourceBufferClass))
#define VALIDE_IS_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SOURCE_BUFFER))
#define VALIDE_IS_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SOURCE_BUFFER))
#define VALIDE_SOURCE_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SOURCE_BUFFER, ValideSourceBufferClass))

typedef struct _ValideSourceBuffer ValideSourceBuffer;
typedef struct _ValideSourceBufferClass ValideSourceBufferClass;
typedef struct _ValideSourceBufferPrivate ValideSourceBufferPrivate;

#define VALIDE_TYPE_ABOUT_DIALOG (valide_about_dialog_get_type ())
#define VALIDE_ABOUT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABOUT_DIALOG, ValideAboutDialog))
#define VALIDE_ABOUT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABOUT_DIALOG, ValideAboutDialogClass))
#define VALIDE_IS_ABOUT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABOUT_DIALOG))
#define VALIDE_IS_ABOUT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABOUT_DIALOG))
#define VALIDE_ABOUT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABOUT_DIALOG, ValideAboutDialogClass))

typedef struct _ValideAboutDialog ValideAboutDialog;
typedef struct _ValideAboutDialogClass ValideAboutDialogClass;
typedef struct _ValideAboutDialogPrivate ValideAboutDialogPrivate;
typedef struct _ValideProjectManagerPrivate ValideProjectManagerPrivate;

#define TYPE_BUILDING_STEP (building_step_get_type ())

#define VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS (valide_abstract_project_dialog_options_get_type ())
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS, ValideAbstractProjectDialogOptions))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS, ValideAbstractProjectDialogOptionsClass))
#define VALIDE_IS_ABSTRACT_PROJECT_DIALOG_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS))
#define VALIDE_IS_ABSTRACT_PROJECT_DIALOG_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS, ValideAbstractProjectDialogOptionsClass))

typedef struct _ValideAbstractProjectDialogOptions ValideAbstractProjectDialogOptions;
typedef struct _ValideAbstractProjectDialogOptionsClass ValideAbstractProjectDialogOptionsClass;
typedef struct _ValideAbstractProjectDialogOptionsPrivate ValideAbstractProjectDialogOptionsPrivate;

#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS (valide_abstract_project_dialog_options_window_widgets_get_type ())
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogOptionswindow_widgets))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogOptionswindow_widgetsClass))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_IS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_IS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_WINDOW_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogOptionswindow_widgetsClass))

typedef struct _ValideAbstractProjectDialogOptionswindow_widgets ValideAbstractProjectDialogOptionswindow_widgets;
typedef struct _ValideAbstractProjectDialogOptionswindow_widgetsClass ValideAbstractProjectDialogOptionswindow_widgetsClass;

#define VALIDE_TYPE_PROJECT_DIALOG_OPTIONS (valide_project_dialog_options_get_type ())
#define VALIDE_PROJECT_DIALOG_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS, ValideProjectDialogOptions))
#define VALIDE_PROJECT_DIALOG_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS, ValideProjectDialogOptionsClass))
#define VALIDE_IS_PROJECT_DIALOG_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS))
#define VALIDE_IS_PROJECT_DIALOG_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS))
#define VALIDE_PROJECT_DIALOG_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS, ValideProjectDialogOptionsClass))

typedef struct _ValideProjectDialogOptions ValideProjectDialogOptions;
typedef struct _ValideProjectDialogOptionsClass ValideProjectDialogOptionsClass;
typedef struct _ValideProjectDialogOptionsPrivate ValideProjectDialogOptionsPrivate;

#define VALIDE_TYPE_PANEL (valide_panel_get_type ())
#define VALIDE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PANEL, ValidePanel))
#define VALIDE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PANEL, ValidePanelClass))
#define VALIDE_IS_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PANEL))
#define VALIDE_IS_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PANEL))
#define VALIDE_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PANEL, ValidePanelClass))

typedef struct _ValidePanel ValidePanel;
typedef struct _ValidePanelClass ValidePanelClass;
typedef struct _ValidePanelPrivate ValidePanelPrivate;
typedef struct _ValideWindowPrivate ValideWindowPrivate;
typedef struct _ValideExecutableManagerPrivate ValideExecutableManagerPrivate;
typedef struct _ValideAbstractPreferencesDialogwindow_widgetsPrivate ValideAbstractPreferencesDialogwindow_widgetsPrivate;

#define VALIDE_ABSTRACT_PREFERENCES_DIALOG_TYPE_WINDOW_WIDGET_NAMES (valide_abstract_preferences_dialog_window_widget_names_get_type ())
typedef struct _ValideAbstractPreferencesDialogwindow_widget_names ValideAbstractPreferencesDialogwindow_widget_names;
typedef struct _ValideAbstractProjectDialogOptionswindow_widgetsPrivate ValideAbstractProjectDialogOptionswindow_widgetsPrivate;

#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGET_NAMES (valide_abstract_project_dialog_options_window_widget_names_get_type ())
typedef struct _ValideAbstractProjectDialogOptionswindow_widget_names ValideAbstractProjectDialogOptionswindow_widget_names;
typedef struct _ValideAbstractProjectDialogRemovewindow_widgetsPrivate ValideAbstractProjectDialogRemovewindow_widgetsPrivate;

#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGET_NAMES (valide_abstract_project_dialog_remove_window_widget_names_get_type ())
typedef struct _ValideAbstractProjectDialogRemovewindow_widget_names ValideAbstractProjectDialogRemovewindow_widget_names;
typedef struct _ValideAbstractProjectDialogwindow_widgetsPrivate ValideAbstractProjectDialogwindow_widgetsPrivate;

#define VALIDE_ABSTRACT_PROJECT_DIALOG_TYPE_WINDOW_WIDGET_NAMES (valide_abstract_project_dialog_window_widget_names_get_type ())
typedef struct _ValideAbstractProjectDialogwindow_widget_names ValideAbstractProjectDialogwindow_widget_names;

#define VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES (valide_abstract_native_builder_preferences_get_type ())
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES, ValideAbstractNativeBuilderPreferences))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES, ValideAbstractNativeBuilderPreferencesClass))
#define VALIDE_IS_ABSTRACT_NATIVE_BUILDER_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES))
#define VALIDE_IS_ABSTRACT_NATIVE_BUILDER_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES, ValideAbstractNativeBuilderPreferencesClass))

typedef struct _ValideAbstractNativeBuilderPreferences ValideAbstractNativeBuilderPreferences;
typedef struct _ValideAbstractNativeBuilderPreferencesClass ValideAbstractNativeBuilderPreferencesClass;
typedef struct _ValideAbstractNativeBuilderPreferencesPrivate ValideAbstractNativeBuilderPreferencesPrivate;

#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS (valide_abstract_native_builder_preferences_window_widgets_get_type ())
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS, ValideAbstractNativeBuilderPreferenceswindow_widgets))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS, ValideAbstractNativeBuilderPreferenceswindow_widgetsClass))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_IS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_IS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_WINDOW_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS, ValideAbstractNativeBuilderPreferenceswindow_widgetsClass))

typedef struct _ValideAbstractNativeBuilderPreferenceswindow_widgets ValideAbstractNativeBuilderPreferenceswindow_widgets;
typedef struct _ValideAbstractNativeBuilderPreferenceswindow_widgetsClass ValideAbstractNativeBuilderPreferenceswindow_widgetsClass;
typedef struct _ValideAbstractNativeBuilderPreferenceswindow_widgetsPrivate ValideAbstractNativeBuilderPreferenceswindow_widgetsPrivate;

#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGET_NAMES (valide_abstract_native_builder_preferences_window_widget_names_get_type ())
typedef struct _ValideAbstractNativeBuilderPreferenceswindow_widget_names ValideAbstractNativeBuilderPreferenceswindow_widget_names;
typedef struct _ValideAbstractCloseDialogwindow_widgetsPrivate ValideAbstractCloseDialogwindow_widgetsPrivate;

#define VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGET_NAMES (valide_abstract_close_dialog_window_widget_names_get_type ())
typedef struct _ValideAbstractCloseDialogwindow_widget_names ValideAbstractCloseDialogwindow_widget_names;

#define VALIDE_TYPE_ABSTRACT_EXECUTABLE_PREFERENCES (valide_abstract_executable_preferences_get_type ())
#define VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_EXECUTABLE_PREFERENCES, ValideAbstractExecutablePreferences))
#define VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_EXECUTABLE_PREFERENCES, ValideAbstractExecutablePreferencesClass))
#define VALIDE_IS_ABSTRACT_EXECUTABLE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_EXECUTABLE_PREFERENCES))
#define VALIDE_IS_ABSTRACT_EXECUTABLE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_EXECUTABLE_PREFERENCES))
#define VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_EXECUTABLE_PREFERENCES, ValideAbstractExecutablePreferencesClass))

typedef struct _ValideAbstractExecutablePreferences ValideAbstractExecutablePreferences;
typedef struct _ValideAbstractExecutablePreferencesClass ValideAbstractExecutablePreferencesClass;
typedef struct _ValideAbstractExecutablePreferencesPrivate ValideAbstractExecutablePreferencesPrivate;

#define VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_TYPE_WINDOW_WIDGETS (valide_abstract_executable_preferences_window_widgets_get_type ())
#define VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_TYPE_WINDOW_WIDGETS, ValideAbstractExecutablePreferenceswindow_widgets))
#define VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_TYPE_WINDOW_WIDGETS, ValideAbstractExecutablePreferenceswindow_widgetsClass))
#define VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_IS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_IS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_WINDOW_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_TYPE_WINDOW_WIDGETS, ValideAbstractExecutablePreferenceswindow_widgetsClass))

typedef struct _ValideAbstractExecutablePreferenceswindow_widgets ValideAbstractExecutablePreferenceswindow_widgets;
typedef struct _ValideAbstractExecutablePreferenceswindow_widgetsClass ValideAbstractExecutablePreferenceswindow_widgetsClass;
typedef struct _ValideAbstractExecutablePreferenceswindow_widgetsPrivate ValideAbstractExecutablePreferenceswindow_widgetsPrivate;

#define VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_TYPE_WINDOW_WIDGET_NAMES (valide_abstract_executable_preferences_window_widget_names_get_type ())
typedef struct _ValideAbstractExecutablePreferenceswindow_widget_names ValideAbstractExecutablePreferenceswindow_widget_names;

#define VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES (valide_native_builder_preferences_get_type ())
#define VALIDE_NATIVE_BUILDER_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES, ValideNativeBuilderPreferences))
#define VALIDE_NATIVE_BUILDER_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES, ValideNativeBuilderPreferencesClass))
#define VALIDE_IS_NATIVE_BUILDER_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES))
#define VALIDE_IS_NATIVE_BUILDER_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES))
#define VALIDE_NATIVE_BUILDER_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES, ValideNativeBuilderPreferencesClass))

typedef struct _ValideNativeBuilderPreferences ValideNativeBuilderPreferences;
typedef struct _ValideNativeBuilderPreferencesClass ValideNativeBuilderPreferencesClass;
typedef struct _ValideNativeBuilderPreferencesPrivate ValideNativeBuilderPreferencesPrivate;

#define VALIDE_TYPE_NATIVE_BUILDER_OPTIONS (valide_native_builder_options_get_type ())
#define VALIDE_NATIVE_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_NATIVE_BUILDER_OPTIONS, ValideNativeBuilderOptions))
#define VALIDE_NATIVE_BUILDER_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_NATIVE_BUILDER_OPTIONS, ValideNativeBuilderOptionsClass))
#define VALIDE_IS_NATIVE_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_NATIVE_BUILDER_OPTIONS))
#define VALIDE_IS_NATIVE_BUILDER_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_NATIVE_BUILDER_OPTIONS))
#define VALIDE_NATIVE_BUILDER_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_NATIVE_BUILDER_OPTIONS, ValideNativeBuilderOptionsClass))

typedef struct _ValideNativeBuilderOptions ValideNativeBuilderOptions;
typedef struct _ValideNativeBuilderOptionsClass ValideNativeBuilderOptionsClass;
typedef struct _ValideNativeBuilderOptionsPrivate ValideNativeBuilderOptionsPrivate;

#define VALIDE_TYPE_NATIVE_BUILDER (valide_native_builder_get_type ())
#define VALIDE_NATIVE_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_NATIVE_BUILDER, ValideNativeBuilder))
#define VALIDE_NATIVE_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_NATIVE_BUILDER, ValideNativeBuilderClass))
#define VALIDE_IS_NATIVE_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_NATIVE_BUILDER))
#define VALIDE_IS_NATIVE_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_NATIVE_BUILDER))
#define VALIDE_NATIVE_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_NATIVE_BUILDER, ValideNativeBuilderClass))

typedef struct _ValideNativeBuilder ValideNativeBuilder;
typedef struct _ValideNativeBuilderClass ValideNativeBuilderClass;
typedef struct _ValideNativeBuilderPrivate ValideNativeBuilderPrivate;
typedef struct _ValideSourceViewPrivate ValideSourceViewPrivate;

#define VALIDE_TYPE_ENVIRONMENT_VARIABLE (valide_environment_variable_get_type ())
#define VALIDE_ENVIRONMENT_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ENVIRONMENT_VARIABLE, ValideEnvironmentVariable))
#define VALIDE_ENVIRONMENT_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ENVIRONMENT_VARIABLE, ValideEnvironmentVariableClass))
#define VALIDE_IS_ENVIRONMENT_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ENVIRONMENT_VARIABLE))
#define VALIDE_IS_ENVIRONMENT_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ENVIRONMENT_VARIABLE))
#define VALIDE_ENVIRONMENT_VARIABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ENVIRONMENT_VARIABLE, ValideEnvironmentVariableClass))

typedef struct _ValideEnvironmentVariable ValideEnvironmentVariable;
typedef struct _ValideEnvironmentVariableClass ValideEnvironmentVariableClass;
typedef struct _ValideEnvironmentVariablePrivate ValideEnvironmentVariablePrivate;
typedef struct _ValideExecutableOptionsPrivate ValideExecutableOptionsPrivate;

#define VALIDE_TYPE_EXECUTABLE_PREFERENCES (valide_executable_preferences_get_type ())
#define VALIDE_EXECUTABLE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_EXECUTABLE_PREFERENCES, ValideExecutablePreferences))
#define VALIDE_EXECUTABLE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_EXECUTABLE_PREFERENCES, ValideExecutablePreferencesClass))
#define VALIDE_IS_EXECUTABLE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_EXECUTABLE_PREFERENCES))
#define VALIDE_IS_EXECUTABLE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_EXECUTABLE_PREFERENCES))
#define VALIDE_EXECUTABLE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_EXECUTABLE_PREFERENCES, ValideExecutablePreferencesClass))

typedef struct _ValideExecutablePreferences ValideExecutablePreferences;
typedef struct _ValideExecutablePreferencesClass ValideExecutablePreferencesClass;
typedef struct _ValideExecutablePreferencesPrivate ValideExecutablePreferencesPrivate;

/**
 * A class for represente a rectangular position
 */
struct _ValidePosition {
	gint start_line;
	gint end_line;
	gint start_row;
	gint end_row;
};

/**
 * Miscellaneous functions
 */
struct _ValideUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideUtilsPrivate * priv;
};

struct _ValideUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideUtils *self);
};

struct _ValideUtilsColor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideUtilsColorPrivate * priv;
};

struct _ValideUtilsColorClass {
	GTypeClass parent_class;
	void (*finalize) (ValideUtilsColor *self);
};

/**
 * A class for manager the file encoding
 */
struct _ValideEncoding {
	GObject parent_instance;
	ValideEncodingPrivate * priv;
};

struct _ValideEncodingClass {
	GObjectClass parent_class;
};

struct _ValideAbstractCloseDialog {
	GtkObject parent_instance;
	ValideAbstractCloseDialogPrivate * priv;
	char* name_space;
	GtkBuilder* xml;
	ValideAbstractCloseDialogwindow_widgets* widgets;
};

struct _ValideAbstractCloseDialogClass {
	GtkObjectClass parent_class;
};

/**
 * DocumentCloseDialog is a dialog box that displays the unsaved document when
 * close all or close the main window
 */
struct _ValideDocumentCloseDialog {
	ValideAbstractCloseDialog parent_instance;
	ValideDocumentCloseDialogPrivate * priv;
};

struct _ValideDocumentCloseDialogClass {
	ValideAbstractCloseDialogClass parent_class;
};

typedef enum  {
	VALIDE_DOCUMENT_STATE_NORMAL,
	VALIDE_DOCUMENT_STATE_EXTERNALLY_MODIFIED,
	VALIDE_DOCUMENT_STATE_BAD_ENCODING,
	VALIDE_DOCUMENT_STATE_INFO
} ValideDocumentState;

/**
 * An interface for document
 */
struct _ValideiDocumentIface {
	GTypeInterface parent_iface;
	void (*open) (ValideiDocument* self, const char* path, GError** error);
	void (*save) (ValideiDocument* self, const char* current_folder);
	void (*save_as) (ValideiDocument* self, const char* current_folder);
	void (*rename) (ValideiDocument* self);
	gboolean (*close) (ValideiDocument* self);
	GdkPixbuf* (*get_icon) (ValideiDocument* self);
	char* (*get_tooltips) (ValideiDocument* self);
	void (*setup_ui) (ValideiDocument* self, ValideUIManager* ui_manager);
	ValideDocumentState (*get_state) (ValideiDocument* self);
	void (*set_state) (ValideiDocument* self, ValideDocumentState value);
	gboolean (*get_is_save) (ValideiDocument* self);
	void (*set_is_save) (ValideiDocument* self, gboolean value);
	const char* (*get_path) (ValideiDocument* self);
	void (*set_path) (ValideiDocument* self, const char* value);
	const char* (*get_title) (ValideiDocument* self);
	const char* (*get_filename) (ValideiDocument* self);
};

typedef enum  {
	VALIDE_ERROR_PARSING_FILE,
	VALIDE_ERROR_PARSING_LINE
} ValideErrorParsing;
#define VALIDE_ERROR_PARSING valide_error_parsing_quark ()
/**
 * A class representing an program can launch by #ExecutableManager.
 */
struct _ValideExecutable {
	GObject parent_instance;
	ValideExecutablePrivate * priv;
};

struct _ValideExecutableClass {
	GObjectClass parent_class;
	char* (*get_start_msg) (ValideExecutable* self);
	char* (*get_end_msg) (ValideExecutable* self);
	GdkColor (*get_color_line) (ValideExecutable* self, char** line);
	void (*line_activated) (ValideExecutable* self, const char* line);
	char* (*get_executable) (ValideExecutable* self);
	void (*set_executable) (ValideExecutable* self, char* value);
};

/**
 * The vala compiler
 */
struct _ValideCompiler {
	ValideExecutable parent_instance;
	ValideCompilerPrivate * priv;
};

struct _ValideCompilerClass {
	ValideExecutableClass parent_class;
	char* (*get_file) (ValideCompiler* self, const char* line, GError** error);
	ValidePosition (*get_line) (ValideCompiler* self, const char* line, GError** error);
};

/**
 * Buildable GObjects, from YAML.
 *
 *
 * Objects that implements GLib.YAML.Buildable is buildable by
 * GLib.YAML.Builder.
 *
 * This interface is almost the same as GtkBuildable.
 *
 **/
struct _GYAMLBuildableIface {
	GTypeInterface parent_iface;
	const char* (*get_name) (GYAMLBuildable* self);
	void (*set_name) (GYAMLBuildable* self, const char* name);
	void (*add_child) (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
	char** (*get_child_tags) (GYAMLBuildable* self, int* result_length1);
	GType* (*get_child_types) (GYAMLBuildable* self, int* result_length1);
	GList* (*get_children) (GYAMLBuildable* self, const char* type);
	GObject* (*get_internal_child) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
	void (*custom_node) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
};

struct _ValideSource {
	GObject parent_instance;
	ValideSourcePrivate * priv;
};

struct _ValideSourceClass {
	GObjectClass parent_class;
};

struct _ValideVapiDir {
	GObject parent_instance;
	ValideVapiDirPrivate * priv;
};

struct _ValideVapiDirClass {
	GObjectClass parent_class;
};

struct _ValidePackage {
	GObject parent_instance;
	ValidePackagePrivate * priv;
};

struct _ValidePackageClass {
	GObjectClass parent_class;
};

/**
 * A class for project
 */
struct _ValideProject {
	GObject parent_instance;
	ValideProjectPrivate * priv;
	char* filename;
	ValideBuilderManager* builders;
	GList* files;
	GList* packages;
	GList* vapi_dir;
};

struct _ValideProjectClass {
	GObjectClass parent_class;
};

typedef enum  {
	VALIDE_DOCUMENT_ERROR_UNKNOW_DOCUMENT,
	VALIDE_DOCUMENT_ERROR_BAD_URI,
	VALIDE_DOCUMENT_ERROR_NO_DOCUMENT,
	VALIDE_DOCUMENT_ERROR_MIME
} ValideDocumentError;
#define VALIDE_DOCUMENT_ERROR valide_document_error_quark ()
struct _ValideBuilderOptionsIface {
	GTypeInterface parent_iface;
};

/**
 * The recent files/projects manager
 */
struct _ValideRecentManagerUI {
	GObject parent_instance;
	ValideRecentManagerUIPrivate * priv;
};

struct _ValideRecentManagerUIClass {
	GObjectClass parent_class;
};

/**
 * Abstract class for manage configation files.
 */
struct _ValideAbstractConfigManager {
	GObject parent_instance;
	ValideAbstractConfigManagerPrivate * priv;
};

struct _ValideAbstractConfigManagerClass {
	GObjectClass parent_class;
	void (*preferences) (ValideAbstractConfigManager* self, ValideWindow* window);
	void (*first_run) (ValideAbstractConfigManager* self);
	char* (*get_config_file) (ValideAbstractConfigManager* self);
};

/**
 * Class for manage the configuration file
 */
struct _ValideConfigManager {
	ValideAbstractConfigManager parent_instance;
	ValideConfigManagerPrivate * priv;
};

struct _ValideConfigManagerClass {
	ValideAbstractConfigManagerClass parent_class;
};

/**
 * The manager for opened documents
 */
struct _ValideDocumentManager {
	GtkNotebook parent_instance;
	ValideDocumentManagerPrivate * priv;
};

struct _ValideDocumentManagerClass {
	GtkNotebookClass parent_class;
	void (*setup_ui) (ValideDocumentManager* self);
	ValideAbstractTextDocument* (*create_document) (ValideDocumentManager* self, const char* filename, GError** error);
};

typedef enum  {
	VALIDE_PROJECT_ERROR_NO_PROJECT,
	VALIDE_PROJECT_ERROR_MAX_OPEN
} ValideProjectError;
#define VALIDE_PROJECT_ERROR valide_project_error_quark ()
typedef enum  {
	VALIDE_BUILDER_ERROR_NOT_FOUND
} ValideBuilderError;
#define VALIDE_BUILDER_ERROR valide_builder_error_quark ()
/**
   * Builder not found
   
*
 * The builder manager
 */
struct _ValideBuilderManager {
	GObject parent_instance;
	ValideBuilderManagerPrivate * priv;
};

struct _ValideBuilderManagerClass {
	GObjectClass parent_class;
};

/**
 * This instance use to create a new builder
 *
 * [[warning:
 *   You should register builder with BuilderManager.register_builder function.
 * ]]
 */
struct _ValideBuilderIface {
	GTypeInterface parent_iface;
	void (*configure) (ValideBuilder* self);
	void (*build) (ValideBuilder* self);
	void (*install) (ValideBuilder* self);
	void (*dist) (ValideBuilder* self);
	void (*clean) (ValideBuilder* self);
	void (*distclean) (ValideBuilder* self);
	void (*uninstall) (ValideBuilder* self);
	GtkWidget* (*preferences) (ValideBuilder* self);
	ValideProject* (*get_project) (ValideBuilder* self);
	void (*set_project) (ValideBuilder* self, ValideProject* value);
	ValideExecutableManager* (*get_executables) (ValideBuilder* self);
	void (*set_executables) (ValideBuilder* self, ValideExecutableManager* value);
};

/**
 * A widget with two Valide.SourceView with the same buffer
 */
struct _ValideSplitSourceView {
	GtkVPaned parent_instance;
	ValideSplitSourceViewPrivate * priv;
};

struct _ValideSplitSourceViewClass {
	GtkVPanedClass parent_class;
};

/**
 * A class representing a template for project
 */
struct _ValideTemplate {
	GObject parent_instance;
	ValideTemplatePrivate * priv;
	char* filename;
	GList* files;
	GList* files_vala;
	GList* files_genie;
	GList* packages;
	GList* vapi_dir;
};

struct _ValideTemplateClass {
	GObjectClass parent_class;
};

/*
 * This code is re-writing in the vala language of GeditStatusbar
 *
 * Copyright (C) 2006-2008  Jürg Billeter, Raffaele Sandrini
 * Copyright (C) 2007  Mathias Hasselmann
 
*
 * The status bar
 */
struct _ValideStatusbar {
	GtkStatusbar parent_instance;
	ValideStatusbarPrivate * priv;
};

struct _ValideStatusbarClass {
	GtkStatusbarClass parent_class;
};

struct _ValideAbstractProjectDialog {
	GtkObject parent_instance;
	ValideAbstractProjectDialogPrivate * priv;
	char* name_space;
	GtkBuilder* xml;
	ValideAbstractProjectDialogwindow_widgets* widgets;
};

struct _ValideAbstractProjectDialogClass {
	GtkObjectClass parent_class;
};

/**
 * A dialog box widget for create a new project
 */
struct _ValideProjectDialog {
	ValideAbstractProjectDialog parent_instance;
	ValideProjectDialogPrivate * priv;
};

struct _ValideProjectDialogClass {
	ValideAbstractProjectDialogClass parent_class;
};

/**
 * Interface for create a plugin
 */
struct _ValidePluginIface {
	GTypeInterface parent_iface;
	const char* (*get_path) (ValidePlugin* self);
	void (*set_path) (ValidePlugin* self, const char* value);
	ValideWindow* (*get_window) (ValidePlugin* self);
	void (*set_window) (ValidePlugin* self, ValideWindow* value);
};

/**
 * Write an Object to a YAML string
 */
struct _GYAMLWriter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GYAMLWriterPrivate * priv;
};

struct _GYAMLWriterClass {
	GTypeClass parent_class;
	void (*finalize) (GYAMLWriter *self);
};

typedef enum  {
	G_YAML_ERROR_SYMBOL_NOT_FOUND,
	G_YAML_ERROR_TYPE_NOT_FOUND,
	G_YAML_ERROR_NOT_A_BUILDABLE,
	G_YAML_ERROR_PROPERTY_NOT_FOUND,
	G_YAML_ERROR_OBJECT_NOT_FOUND,
	G_YAML_ERROR_UNKNOWN_PROPERTY_TYPE,
	G_YAML_ERROR_CUSTOM_NODE_ERROR,
	G_YAML_ERROR_UNEXPECTED_NODE,
	G_YAML_ERROR_NOT_IMPLEMENTED,
	G_YAML_ERROR_FILE_NOT_FOUND,
	G_YAML_ERROR_PARSER_ERROR,
	G_YAML_ERROR_UNRESOLVED_ALIAS
} GYAMLError;
#define G_YAML_ERROR g_yaml_error_quark ()
/**
 * A YAML Node.
 *
 * YAML supports three types of nodes. They are converted to
 * GTypes
 *
 *   [| ++YAML++ || ++GType++ |]
 *   [| Scalar || Node.Scalar |]
 *   [| Sequence || Node.Sequence |]
 *   [| Mapping || Node.Mapping |]
 *   [| Alias || Node.Alias |]
 *
 * Each node type utilizes the fundamental GLib types to store the
 * YAML data.
 *
 * A pointer can be binded to the node with get_pointer and set_pointer.
 * This pointer is used by GLib.YAML.Builder to hold the built object.
 *
 * */
struct _GYAMLNode {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GYAMLNodePrivate * priv;
	yaml_node_type_t type;
	char* tag;
	yaml_mark_t start_mark;
	yaml_mark_t end_mark;
	char* anchor;
};

struct _GYAMLNodeClass {
	GTypeClass parent_class;
	void (*finalize) (GYAMLNode *self);
};

/**
 * An Alias Node
 *
 * Refer to the YAML 1.1 spec for the definitions.
 *
 * Note that the explanation of alias
 * is different from the explanation of alias in standard YAML.
 * The resolution of aliases are deferred, allowing forward-
 * referring aliases; whereas in standard YAML, forward-referring
 * aliases is undefined.
 * */
struct _GYAMLNodeAlias {
	GYAMLNode parent_instance;
	GYAMLNodeAliasPrivate * priv;
	GYAMLNode* node;
};

struct _GYAMLNodeAliasClass {
	GYAMLNodeClass parent_class;
};

/**
 * A Scalar Node
 *
 * Refer to the YAML 1.1 spec for the definitions.
 *
 * The scalar value is internally stored as a string,
 * or `gchar*'.
 */
struct _GYAMLNodeScalar {
	GYAMLNode parent_instance;
	GYAMLNodeScalarPrivate * priv;
	char* value;
	yaml_scalar_style_t style;
};

struct _GYAMLNodeScalarClass {
	GYAMLNodeClass parent_class;
};

/**
 * A Sequence Node
 * 
 * Refer to the YAML 1.1 spec for the definitions.
 *
 * The sequence is internally stored as a GList.
 */
struct _GYAMLNodeSequence {
	GYAMLNode parent_instance;
	GYAMLNodeSequencePrivate * priv;
	GList* items;
	yaml_sequence_style_t style;
};

struct _GYAMLNodeSequenceClass {
	GYAMLNodeClass parent_class;
};

/**
 * A Mapping Node
 * 
 * Refer to the YAML 1.1 spec for the definitions.
 *
 * The mapping is internally stored as a GHashTable.
 *
 * An extra list of keys is stored to ease iterating overall
 * elements. GHashTable.get_keys is not available in GLib 2.12.
 */
struct _GYAMLNodeMapping {
	GYAMLNode parent_instance;
	GYAMLNodeMappingPrivate * priv;
	GHashTable* pairs;
	GList* keys;
	yaml_mapping_style_t style;
};

struct _GYAMLNodeMappingClass {
	GYAMLNodeClass parent_class;
};

/**
 * A YAML Document
 *
 * Refer to the YAML 1.1 spec for the definitions.
 *
 * The document model based on GType classes replaces the original libyaml
 * document model.
 *
 * [warning:
 *  This is not a full implementation of a YAML document.
 *  The document tag directive is missing.
 *  Alias is not immediately resolved and replaced with the referred node.
 * ]
 */
struct _GYAMLDocument {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GYAMLDocumentPrivate * priv;
	GList* nodes;
	yaml_mark_t start_mark;
	yaml_mark_t end_mark;
	GHashTable* anchors;
	GYAMLNode* root;
};

struct _GYAMLDocumentClass {
	GTypeClass parent_class;
	void (*finalize) (GYAMLDocument *self);
};

/**
 * Building GObjects from a YAML stream.
 *
 * Refer to GLib.YAML.Buildable
 *
 * The root of the document is a mapping, which is built to an object. 
 * Other objects are inserted into children of the root object, 
 * supplied as items in sequences.
 *
 * ++ Two Stages of Building ++
 * # An object is created for each mapping with a YAML tag that 
 *   corresponds to a valid GObject type.
 * # Every mapping corresponding to an object is examined. 
 *   Each mapping key in the pairs is scanned to match the 
 *   rules discussed in the following text.
 *   # `internals'
 *     * Internal children are referred by their internal names.
 *       Buildables should implement 
 *       Buildable.get_internel_child which returns the child object.
 *   # `objects', and other custom children key
 *     * Every child is supplied as a sequence item in the 
 *       mapping value. Buildables should implement 
 *       Buildable.get_child_type which returns the GType of 
 *       the custom child for the given key scalar.
 *   # properties
 *     * The key of the mapping matched against a property name 
 *       of the object. If found, the value is parsed to fill 
 *       in the value.
 *     * If the property refers to an Object and the value node is 
 *       a mapping, a new object is created, and the object is 
 *       initialized by the supplied mapping.
 *     * If the property refers to an Object and the value node is 
 *       an alias, the object referred by the alias is 
 *       assigned to the property.
 *     * If the property refers to a Boxed structure, 
 *       a temperory buffer of 65530 bytes is allocated, 
 *       and a parse function, conforming the gdk_color_parse 
 *       calling convention ([CCode (instance_pos = -1)] 
 *       is called to initialize the buffer with the value scalar.
 *   # signals
 *     * Signal connection is not currently supported, but planned.
 *   # custom nodes
 *     * If the key doesn't match to any of the priorly mentioned 
 *       catagories, Buildable.custom_node is invoked. 
 *     * If the buildable doesn't understand the node, 
 *       it should report a PROPERTY_NOT_FOUND error.
 *
 * [warning:
 *   Be aware that if the Boxed struct is larger than the temporary buffer, 
 *   there will be a memory corruption. Currently no good fix is found, 
 *   because GLib doesn't store the size of a Boxed type.
 * ]
 *
 * Here is an example of the YAML file, 
 * which is semantically equivalent to the GtkBuilder example given in 
 * DevHelp, GtkBuildable.
 *
 * {{{
 * --- !GtkDialog
 * internals:
 *   vbox : { border-width : 10 }
 *   action-area : 
 *     border-width : 20
 *     objects:
 *       - !GtkHButtonBox &hbuttonbox1
 *         objects:
 *         - !GtkButton &ok_button
 *           label: gtk-ok
 *           use-stock: true
 * }}}
 *
 * [warning:
 *   Although this example is a valid YAML understood by the Builder, 
 *   it cannot be used to build the widgets, because GtkWidget 
 *   doesn't implement the required GYAMLBuildable interface.
 * ]
 *
 *
 * */
struct _GYAMLBuilder {
	GObject parent_instance;
	GYAMLBuilderPrivate * priv;
};

struct _GYAMLBuilderClass {
	GObjectClass parent_class;
};

/**
 * A widget for search/replace in a Valide.AbstractTextDocument
 */
struct _ValideSearching {
	GtkVBox parent_instance;
	ValideSearchingPrivate * priv;
};

struct _ValideSearchingClass {
	GtkVBoxClass parent_class;
};

struct _ValideAbstractPreferencesDialog {
	GtkObject parent_instance;
	ValideAbstractPreferencesDialogPrivate * priv;
	char* name_space;
	GtkBuilder* xml;
	ValideAbstractPreferencesDialogwindow_widgets* widgets;
};

struct _ValideAbstractPreferencesDialogClass {
	GtkObjectClass parent_class;
};

/* @todo set_smart_home_end 
*
 * The preferences dialog box
 */
struct _ValidePreferencesDialog {
	ValideAbstractPreferencesDialog parent_instance;
	ValidePreferencesDialogPrivate * priv;
};

struct _ValidePreferencesDialogClass {
	ValideAbstractPreferencesDialogClass parent_class;
};

/**
 * The start page widget
 */
struct _ValideStartPage {
	GtkScrolledWindow parent_instance;
	ValideStartPagePrivate * priv;
};

struct _ValideStartPageClass {
	GtkScrolledWindowClass parent_class;
};

/**
 * This class represents a registered plugin
 */
struct _ValidePluginRegistrar {
	GObject parent_instance;
	ValidePluginRegistrarPrivate * priv;
	char** authors;
	gint authors_length1;
};

struct _ValidePluginRegistrarClass {
	GObjectClass parent_class;
};

/**
 * A message widget for Valide.AbstractTextDocument
 */
struct _ValideDocumentMessage {
	GtkHBox parent_instance;
	ValideDocumentMessagePrivate * priv;
};

struct _ValideDocumentMessageClass {
	GtkHBoxClass parent_class;
};

/**
 * The plugin manager
 */
struct _ValidePluginManager {
	GObject parent_instance;
	ValidePluginManagerPrivate * priv;
	GList* plugins;
};

struct _ValidePluginManagerClass {
	GObjectClass parent_class;
};

/**
 * The widget for plugin preferences
 */
struct _ValidePluginPreferences {
	GtkVBox parent_instance;
	ValidePluginPreferencesPrivate * priv;
};

struct _ValidePluginPreferencesClass {
	GtkVBoxClass parent_class;
};

/**
 * The template manager
 */
struct _ValideTemplateManager {
	GObject parent_instance;
	ValideTemplateManagerPrivate * priv;
};

struct _ValideTemplateManagerClass {
	GObjectClass parent_class;
};

/**
 * The base class for text document
 */
struct _ValideAbstractTextDocument {
	GtkVBox parent_instance;
	ValideAbstractTextDocumentPrivate * priv;
	ValideSplitSourceView* split_view;
};

struct _ValideAbstractTextDocumentClass {
	GtkVBoxClass parent_class;
	ValideSplitSourceView* (*create_source_view) (ValideAbstractTextDocument* self);
	char* (*get_contents) (ValideAbstractTextDocument* self, GError** error);
	void (*set_contents) (ValideAbstractTextDocument* self, const char* new_path, GError** error);
	GdkPixbuf* (*get_icon) (ValideAbstractTextDocument* self);
	char* (*get_tooltips) (ValideAbstractTextDocument* self);
};

/**
 * A text document
 */
struct _ValideTxtDocument {
	ValideAbstractTextDocument parent_instance;
	ValideTxtDocumentPrivate * priv;
};

struct _ValideTxtDocumentClass {
	ValideAbstractTextDocumentClass parent_class;
};

/**
 * A genie document
 */
struct _ValideGsDocument {
	ValideTxtDocument parent_instance;
	ValideGsDocumentPrivate * priv;
};

struct _ValideGsDocumentClass {
	ValideTxtDocumentClass parent_class;
};

/**
 * A vala document
 */
struct _ValideValaDocument {
	ValideTxtDocument parent_instance;
	ValideValaDocumentPrivate * priv;
};

struct _ValideValaDocumentClass {
	ValideTxtDocumentClass parent_class;
};

/**
 * A vapi document
 */
struct _ValideVapiDocument {
	ValideValaDocument parent_instance;
	ValideVapiDocumentPrivate * priv;
};

struct _ValideVapiDocumentClass {
	ValideValaDocumentClass parent_class;
};

/**
 * A XML document
 */
struct _ValideXmlDocument {
	ValideTxtDocument parent_instance;
	ValideXmlDocumentPrivate * priv;
};

struct _ValideXmlDocumentClass {
	ValideTxtDocumentClass parent_class;
};

/**
 * A glade document
 */
struct _ValideGladeDocument {
	ValideXmlDocument parent_instance;
	ValideGladeDocumentPrivate * priv;
};

struct _ValideGladeDocumentClass {
	ValideXmlDocumentClass parent_class;
};

/**
 * A GTK UI document
 */
struct _ValideUiDocument {
	ValideXmlDocument parent_instance;
	ValideUiDocumentPrivate * priv;
};

struct _ValideUiDocumentClass {
	ValideXmlDocumentClass parent_class;
};

/**
 * A goto dialog widget for Valide.SourceView
 */
struct _ValideGotoDialog {
	GtkWindow parent_instance;
	ValideGotoDialogPrivate * priv;
};

struct _ValideGotoDialogClass {
	GtkWindowClass parent_class;
};

/**
 * Class for construct the user interface (menu and toolbar)
 */
struct _ValideUIManager {
	GtkUIManager parent_instance;
	ValideUIManagerPrivate * priv;
};

struct _ValideUIManagerClass {
	GtkUIManagerClass parent_class;
};

struct _ValideAbstractProjectDialogRemove {
	GtkObject parent_instance;
	ValideAbstractProjectDialogRemovePrivate * priv;
	char* name_space;
	GtkBuilder* xml;
	ValideAbstractProjectDialogRemovewindow_widgets* widgets;
};

struct _ValideAbstractProjectDialogRemoveClass {
	GtkObjectClass parent_class;
};

/**
 * A dialog box for remove a file from a project
 */
struct _ValideProjectDialogRemove {
	ValideAbstractProjectDialogRemove parent_instance;
	ValideProjectDialogRemovePrivate * priv;
};

struct _ValideProjectDialogRemoveClass {
	ValideAbstractProjectDialogRemoveClass parent_class;
};

struct _ValideSourceBuffer {
	GtkSourceBuffer parent_instance;
	ValideSourceBufferPrivate * priv;
	char* path;
};

struct _ValideSourceBufferClass {
	GtkSourceBufferClass parent_class;
};

/**
 * The about dialog box
 */
struct _ValideAboutDialog {
	GtkAboutDialog parent_instance;
	ValideAboutDialogPrivate * priv;
};

struct _ValideAboutDialogClass {
	GtkAboutDialogClass parent_class;
};

/**
 * The project manager
 */
struct _ValideProjectManager {
	GtkScrolledWindow parent_instance;
	ValideProjectManagerPrivate * priv;
};

struct _ValideProjectManagerClass {
	GtkScrolledWindowClass parent_class;
};

/**
 * The different building step
 */
typedef enum  {
	BUILDING_STEP_CONFIGURE,
	BUILDING_STEP_BUILD,
	BUILDING_STEP_INSTALL,
	BUILDING_STEP_DIST,
	BUILDING_STEP_CLEAN,
	BUILDING_STEP_DISTCLEAN,
	BUILDING_STEP_UNINSTALL
} BuildingStep;

struct _ValideAbstractProjectDialogOptions {
	GtkObject parent_instance;
	ValideAbstractProjectDialogOptionsPrivate * priv;
	char* name_space;
	GtkBuilder* xml;
	ValideAbstractProjectDialogOptionswindow_widgets* widgets;
};

struct _ValideAbstractProjectDialogOptionsClass {
	GtkObjectClass parent_class;
};

/**
 * A dialog box widget for show/edit the option of a project
 */
struct _ValideProjectDialogOptions {
	ValideAbstractProjectDialogOptions parent_instance;
	ValideProjectDialogOptionsPrivate * priv;
};

struct _ValideProjectDialogOptionsClass {
	ValideAbstractProjectDialogOptionsClass parent_class;
};

/**
 * A side or bottom panel widget
 */
struct _ValidePanel {
	GtkVBox parent_instance;
	ValidePanelPrivate * priv;
};

struct _ValidePanelClass {
	GtkVBoxClass parent_class;
	void (*close) (ValidePanel* self);
};

/**
 * The main window of the application
 */
struct _ValideWindow {
	GtkWindow parent_instance;
	ValideWindowPrivate * priv;
	guint workspace;
};

struct _ValideWindowClass {
	GtkWindowClass parent_class;
};

typedef enum  {
	VALIDE_EXECUTABLE_ERROR_NO_EXECUTABLE
} ValideExecutableError;
#define VALIDE_EXECUTABLE_ERROR valide_executable_error_quark ()
/**
 * Manager for launch external programs
 */
struct _ValideExecutableManager {
	GtkHBox parent_instance;
	ValideExecutableManagerPrivate * priv;
};

struct _ValideExecutableManagerClass {
	GtkHBoxClass parent_class;
};

struct _ValideAbstractPreferencesDialogwindow_widgets {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideAbstractPreferencesDialogwindow_widgetsPrivate * priv;
	GtkDialog* dialog;
	GtkVBox* vbox;
	GtkNotebook* notebook;
	GtkVBox* frame_editor;
	GtkFrame* frame1;
	GtkAlignment* alignment1;
	GtkVBox* vbox1;
	GtkCheckButton* auto_indent;
	GtkCheckButton* insert_spaces_instead_of_tabs;
	GtkCheckButton* indent_on_tab;
	GtkHBox* hbox2;
	GtkLabel* label5;
	GtkSpinButton* tab_width;
	GtkLabel* label3;
	GtkFrame* frame2;
	GtkAlignment* alignment2;
	GtkVBox* vbox2;
	GtkCheckButton* show_right_margin;
	GtkHBox* hbox3;
	GtkLabel* label7;
	GtkSpinButton* right_margin_position;
	GtkLabel* label6;
	GtkFrame* frame4;
	GtkAlignment* alignment4;
	GtkCheckButton* show_line_numbers;
	GtkLabel* label11;
	GtkFrame* frame5;
	GtkAlignment* alignment5;
	GtkCheckButton* highlight_current_line;
	GtkLabel* label12;
	GtkLabel* label1;
	GtkVBox* vbox4;
	GtkFrame* frame3;
	GtkAlignment* alignment3;
	GtkHBox* hbox4;
	GtkLabel* label8;
	GtkFontButton* font;
	GtkLabel* label2;
	GtkFrame* frame6;
	GtkAlignment* alignment6;
	GtkScrolledWindow* scrolledwindow1;
	GtkTreeView* style_scheme;
	GtkLabel* label14;
	GtkLabel* label13;
	GtkVBox* vbox3;
	GtkHBox* hbox5;
	GtkLabel* label10;
	GtkFileChooserButton* default_directory;
	GtkLabel* label9;
	GtkHButtonBox* dialog_action_area1;
	GtkButton* button;
};

struct _ValideAbstractPreferencesDialogwindow_widgetsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideAbstractPreferencesDialogwindow_widgets *self);
};

/* GtkButton button */
struct _ValideAbstractPreferencesDialogwindow_widget_names {
	gint index;
	char* class;
	char* name;
};

struct _ValideAbstractProjectDialogOptionswindow_widgets {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideAbstractProjectDialogOptionswindow_widgetsPrivate * priv;
	GtkListStore* liststore1;
	GtkDialog* dialog;
	GtkVBox* dialog_vbox;
	GtkHBox* hbox;
	GtkScrolledWindow* scrolled_window;
	GtkIconView* icon_view;
	GtkNotebook* notebook;
	GtkTable* table1;
	GtkLabel* label7;
	GtkLabel* label8;
	GtkLabel* label9;
	GtkLabel* label10;
	GtkLabel* path;
	GtkEntry* name;
	GtkEntry* author;
	GtkEntry* version;
	GtkLabel* label11;
	GtkLabel* license;
	GtkLabel* label1;
	GtkComboBox* builder;
	GtkHButtonBox* dialog_action_area1;
	GtkButton* button1;
};

struct _ValideAbstractProjectDialogOptionswindow_widgetsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideAbstractProjectDialogOptionswindow_widgets *self);
};

/* GtkButton button1 */
struct _ValideAbstractProjectDialogOptionswindow_widget_names {
	gint index;
	char* class;
	char* name;
};

struct _ValideAbstractProjectDialogRemovewindow_widgets {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideAbstractProjectDialogRemovewindow_widgetsPrivate * priv;
	GtkDialog* dialog;
	GtkVBox* vbox;
	GtkLabel* label;
	GtkScrolledWindow* scrolled_window;
	GtkTreeView* tree_view;
	GtkHButtonBox* dialog_action_area;
	GtkButton* button1;
	GtkButton* button2;
};

struct _ValideAbstractProjectDialogRemovewindow_widgetsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideAbstractProjectDialogRemovewindow_widgets *self);
};

/* GtkButton button2 */
struct _ValideAbstractProjectDialogRemovewindow_widget_names {
	gint index;
	char* class;
	char* name;
};

struct _ValideAbstractProjectDialogwindow_widgets {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideAbstractProjectDialogwindow_widgetsPrivate * priv;
	GtkAssistant* assistant;
	GtkLabel* page1;
	GtkVBox* page2;
	GtkScrolledWindow* scrolledwindow1;
	GtkIconView* icon_view;
	GtkHBox* hbox1;
	GtkLabel* label1;
	GtkComboBox* lang_combo;
	GtkCellRendererText* renderer1;
	GtkFrame* frame1;
	GtkAlignment* alignment1;
	GtkLabel* desc_label;
	GtkLabel* label4;
	GtkScrolledWindow* page3;
	GtkViewport* viewport1;
	GtkTable* table1;
	GtkLabel* label2;
	GtkLabel* label3;
	GtkLabel* label6;
	GtkEntry* name_entry;
	GtkEntry* path_entry;
	GtkLabel* label7;
	GtkLabel* label8;
	GtkLabel* label9;
	GtkEntry* author_entry;
	GtkEntry* version_entry;
	GtkComboBox* licenses_combo;
	GtkFileChooserButton* dir_chooser;
	GtkLabel* label5;
	GtkComboBox* builder;
	GtkListStore* model1;
	GtkListStore* liststore1;
};

struct _ValideAbstractProjectDialogwindow_widgetsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideAbstractProjectDialogwindow_widgets *self);
};

/* GtkListStore liststore1 */
struct _ValideAbstractProjectDialogwindow_widget_names {
	gint index;
	char* class;
	char* name;
};

struct _ValideAbstractNativeBuilderPreferences {
	GtkObject parent_instance;
	ValideAbstractNativeBuilderPreferencesPrivate * priv;
	char* name_space;
	GtkBuilder* xml;
	ValideAbstractNativeBuilderPreferenceswindow_widgets* widgets;
};

struct _ValideAbstractNativeBuilderPreferencesClass {
	GtkObjectClass parent_class;
};

struct _ValideAbstractNativeBuilderPreferenceswindow_widgets {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideAbstractNativeBuilderPreferenceswindow_widgetsPrivate * priv;
	GtkNotebook* notebook;
	GtkVBox* frame_general;
	GtkCheckButton* debug;
	GtkCheckButton* thread;
	GtkCheckButton* disable_assert;
	GtkCheckButton* disable_checking;
	GtkCheckButton* disable_non_null;
	GtkCheckButton* save_temps;
	GtkCheckButton* quiet;
	GtkHBox* hbox1;
	GtkLabel* label6;
	GtkEntry* other;
	GtkButton* info_button;
	GtkImage* image2;
	GtkLabel* label1;
	GtkVBox* vbox1;
	GtkFrame* frame_pkg;
	GtkAlignment* alignment1;
	GtkHBox* hbox2;
	GtkScrolledWindow* scrolledwindow1;
	GtkTreeView* tree_view_src;
	GtkVBox* vbox3;
	GtkButton* button_add;
	GtkImage* image3;
	GtkButton* button_del;
	GtkImage* image4;
	GtkScrolledWindow* scrolledwindow2;
	GtkTreeView* tree_view_dst;
	GtkLabel* label4;
	GtkFrame* frame_vapi;
	GtkAlignment* alignment2;
	GtkVBox* vbox4;
	GtkHBox* hbox3;
	GtkFileChooserButton* file_chooser_button;
	GtkButton* button3;
	GtkButton* button4;
	GtkScrolledWindow* scrolledwindow3;
	GtkTreeView* tree_view_vapi;
	GtkLabel* label5;
	GtkLabel* label2;
};

struct _ValideAbstractNativeBuilderPreferenceswindow_widgetsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideAbstractNativeBuilderPreferenceswindow_widgets *self);
};

/* GtkLabel label2 */
struct _ValideAbstractNativeBuilderPreferenceswindow_widget_names {
	gint index;
	char* class;
	char* name;
};

struct _ValideAbstractCloseDialogwindow_widgets {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideAbstractCloseDialogwindow_widgetsPrivate * priv;
	GtkListStore* list_store;
	GtkDialog* dialog;
	GtkVBox* dialog_vbox1;
	GtkVBox* vbox1;
	GtkHBox* hbox1;
	GtkImage* image1;
	GtkVBox* vbox2;
	GtkLabel* label;
	GtkLabel* label3;
	GtkTreeView* tree_view;
	GtkLabel* label1;
	GtkHButtonBox* dialog_action_area1;
	GtkButton* button1;
	GtkButton* button2;
	GtkButton* button3;
};

struct _ValideAbstractCloseDialogwindow_widgetsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideAbstractCloseDialogwindow_widgets *self);
};

/* GtkButton button3 */
struct _ValideAbstractCloseDialogwindow_widget_names {
	gint index;
	char* class;
	char* name;
};

struct _ValideAbstractExecutablePreferences {
	GtkObject parent_instance;
	ValideAbstractExecutablePreferencesPrivate * priv;
	char* name_space;
	GtkBuilder* xml;
	ValideAbstractExecutablePreferenceswindow_widgets* widgets;
};

struct _ValideAbstractExecutablePreferencesClass {
	GtkObjectClass parent_class;
};

struct _ValideAbstractExecutablePreferenceswindow_widgets {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideAbstractExecutablePreferenceswindow_widgetsPrivate * priv;
	GtkTable* table;
	GtkLabel* label2;
	GtkEntry* executable_arguments;
	GtkLabel* label3;
	GtkEntry* executable_program;
	GtkButton* button2;
	GtkLabel* label4;
	GtkFileChooserButton* executable_working_dir;
	GtkExpander* expander1;
	GtkVBox* vbox1;
	GtkScrolledWindow* scrolledwindow1;
	GtkTreeView* tree_view;
	GtkHButtonBox* hbuttonbox1;
	GtkButton* button1;
	GtkButton* button3;
	GtkButton* button4;
	GtkLabel* label5;
};

struct _ValideAbstractExecutablePreferenceswindow_widgetsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideAbstractExecutablePreferenceswindow_widgets *self);
};

/* GtkLabel label5 */
struct _ValideAbstractExecutablePreferenceswindow_widget_names {
	gint index;
	char* class;
	char* name;
};

struct _ValideNativeBuilderPreferences {
	ValideAbstractNativeBuilderPreferences parent_instance;
	ValideNativeBuilderPreferencesPrivate * priv;
};

struct _ValideNativeBuilderPreferencesClass {
	ValideAbstractNativeBuilderPreferencesClass parent_class;
};

struct _ValideNativeBuilderOptions {
	GObject parent_instance;
	ValideNativeBuilderOptionsPrivate * priv;
};

struct _ValideNativeBuilderOptionsClass {
	GObjectClass parent_class;
};

/**
 * The native builder
 */
struct _ValideNativeBuilder {
	GObject parent_instance;
	ValideNativeBuilderPrivate * priv;
};

struct _ValideNativeBuilderClass {
	GObjectClass parent_class;
};

/**
 * A widget for show highlighting text
 */
struct _ValideSourceView {
	GtkSourceView parent_instance;
	ValideSourceViewPrivate * priv;
};

struct _ValideSourceViewClass {
	GtkSourceViewClass parent_class;
};

struct _ValideEnvironmentVariable {
	GObject parent_instance;
	ValideEnvironmentVariablePrivate * priv;
};

struct _ValideEnvironmentVariableClass {
	GObjectClass parent_class;
};

struct _ValideExecutableOptions {
	GObject parent_instance;
	ValideExecutableOptionsPrivate * priv;
	GList* environment;
};

struct _ValideExecutableOptionsClass {
	GObjectClass parent_class;
};

struct _ValideExecutablePreferences {
	ValideAbstractExecutablePreferences parent_instance;
	ValideExecutablePreferencesPrivate * priv;
};

struct _ValideExecutablePreferencesClass {
	ValideAbstractExecutablePreferencesClass parent_class;
};


GType valide_position_get_type (void);
ValidePosition* valide_position_dup (const ValidePosition* self);
void valide_position_free (ValidePosition* self);
gpointer valide_utils_ref (gpointer instance);
void valide_utils_unref (gpointer instance);
GParamSpec* valide_param_spec_utils (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_value_set_utils (GValue* value, gpointer v_object);
gpointer valide_value_get_utils (const GValue* value);
GType valide_utils_get_type (void);
char* valide_utils_get_relative_path (const char* filename, const char* path);
char* valide_utils_get_extension (const char* filename);
char* valide_utils_skip_extension (const char* filename);
gint valide_utils_cmp_filename (const char* path_a, const char* path_b);
guint64 valide_utils_get_mtime (const char* filename, GError** error);
void valide_utils_set_up_io_channel (gint fd, GIOCondition cond, gboolean nblock, GIOFunc func, void* func_target, GError** error);
void valide_utils_chop (char** s);
gboolean valide_utils_str_is_num (const char* s);
gboolean valide_utils_char_is_separator (gunichar ch);
GtkButton* valide_utils_create_small_button (GtkImage* image);
GtkButton* valide_utils_create_small_button_from_stock (const char* stock_id);
GdkPixbuf* valide_utils_get_pixbuf_for_stock (const char* stock_id, GtkIconSize size);
GdkPixbuf* valide_utils_get_pixbuf_for_file (const char* filename, GtkIconSize size, GError** error);
char* valide_utils_get_mime_type (const char* filename, GError** error);
void valide_utils_process_gtk_events (void);
gboolean valide_utils_remove_last_element (char** s, gchar sep);
char* valide_utils_get_last_element (const char* s, gchar sep);
char* valide_utils_replace_home_dir_with_tilde (const char* uri);
GdkPixbuf* valide_utils_get_symbol_pixbuf (const char* type);
ValideUtils* valide_utils_new (void);
ValideUtils* valide_utils_construct (GType object_type);
gpointer valide_utils_color_ref (gpointer instance);
void valide_utils_color_unref (gpointer instance);
GParamSpec* valide_utils_param_spec_color (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_utils_value_set_color (GValue* value, gpointer v_object);
gpointer valide_utils_value_get_color (const GValue* value);
GType valide_utils_color_get_type (void);
#define VALIDE_UTILS_COLOR_INFO "#0000FF"
#define VALIDE_UTILS_COLOR_SUCCESS "#19A630"
#define VALIDE_UTILS_COLOR_WARNING "#ED7F10"
#define VALIDE_UTILS_COLOR_ERROR "#FF0000"
#define VALIDE_UTILS_COLOR_DEFAULT "#000000"
ValideUtilsColor* valide_utils_color_new (void);
ValideUtilsColor* valide_utils_color_construct (GType object_type);
GType valide_encoding_get_type (void);
char* valide_encoding_to_utf8 (const char* path, char** encoding, GError** error);
char* valide_encoding_from_utf8 (GtkTextBuffer* text_buffer, char** encoding, GError** error);
ValideEncoding* valide_encoding_new (void);
ValideEncoding* valide_encoding_construct (GType object_type);
GType valide_abstract_close_dialog_get_type (void);
gpointer valide_abstract_close_dialog_window_widgets_ref (gpointer instance);
void valide_abstract_close_dialog_window_widgets_unref (gpointer instance);
GParamSpec* valide_abstract_close_dialog_param_spec_window_widgets (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_abstract_close_dialog_value_set_window_widgets (GValue* value, gpointer v_object);
gpointer valide_abstract_close_dialog_value_get_window_widgets (const GValue* value);
GType valide_abstract_close_dialog_window_widgets_get_type (void);
GType valide_document_close_dialog_get_type (void);
GType valide_ui_manager_get_type (void);
GType valide_document_state_get_type (void);
GType valide_idocument_get_type (void);
ValideDocumentCloseDialog* valide_document_close_dialog_new (GList* documents);
ValideDocumentCloseDialog* valide_document_close_dialog_construct (GType object_type, GList* documents);
void valide_document_close_dialog_set_transient_for (ValideDocumentCloseDialog* self, GtkWindow* parent);
void valide_document_close_dialog_set_modal (ValideDocumentCloseDialog* self, gboolean modal);
gint valide_document_close_dialog_run (ValideDocumentCloseDialog* self);
void valide_document_close_dialog_destroy (ValideDocumentCloseDialog* self);
GList* valide_document_close_dialog_get_selected (ValideDocumentCloseDialog* self);
GQuark valide_error_parsing_quark (void);
GType valide_executable_get_type (void);
GType valide_compiler_get_type (void);
char* valide_compiler_get_file (ValideCompiler* self, const char* line, GError** error);
ValidePosition valide_compiler_get_line (ValideCompiler* self, const char* line, GError** error);
GType valide_project_get_type (void);
ValideCompiler* valide_compiler_new (ValideProject* project);
ValideCompiler* valide_compiler_construct (GType object_type, ValideProject* project);
ValideProject* valide_compiler_get_project (ValideCompiler* self);
GType g_yaml_builder_get_type (void);
gpointer g_yaml_node_ref (gpointer instance);
void g_yaml_node_unref (gpointer instance);
GParamSpec* g_yaml_param_spec_node (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void g_yaml_value_set_node (GValue* value, gpointer v_object);
gpointer g_yaml_value_get_node (const GValue* value);
GType g_yaml_node_get_type (void);
GType g_yaml_buildable_get_type (void);
GType valide_source_get_type (void);
ValideSource* valide_source_new (const char* path);
ValideSource* valide_source_construct (GType object_type, const char* path);
const char* valide_source_get_path (ValideSource* self);
void valide_source_set_path (ValideSource* self, const char* value);
GType valide_vapi_dir_get_type (void);
ValideVapiDir* valide_vapi_dir_new (const char* path);
ValideVapiDir* valide_vapi_dir_construct (GType object_type, const char* path);
const char* valide_vapi_dir_get_path (ValideVapiDir* self);
void valide_vapi_dir_set_path (ValideVapiDir* self, const char* value);
GType valide_package_get_type (void);
ValidePackage* valide_package_new (const char* name);
ValidePackage* valide_package_construct (GType object_type, const char* name);
const char* valide_package_get_name (ValidePackage* self);
void valide_package_set_name (ValidePackage* self, const char* value);
GType valide_builder_manager_get_type (void);
GType valide_document_manager_get_type (void);
ValideProject* _valide_project_new_from_filename (const char* filename, ValideDocumentManager* documents, ValideBuilderManager* builders, GError** error);
void valide_project_close (ValideProject* self);
void valide_project_save (ValideProject* self);
GQuark valide_document_error_quark (void);
void valide_project_create_file (ValideProject* self, GError** error);
ValideiDocument* valide_project_open_file (ValideProject* self, const char* filename, GError** error);
void valide_project_add_file (ValideProject* self, GSList* files);
void valide_project_remove_file (ValideProject* self, GList* files);
gboolean valide_project_is_compiled (ValideProject* self);
gboolean valide_project_is_uptodate (ValideProject* self);
void valide_project_option_dialog (ValideProject* self, GtkWindow* parent);
void valide_project_configure (ValideProject* self);
void valide_project_build (ValideProject* self);
void valide_project_install (ValideProject* self);
void valide_project_uninstall (ValideProject* self);
void valide_project_dist (ValideProject* self);
void valide_project_clean (ValideProject* self);
void valide_project_distclean (ValideProject* self);
void valide_project_execute (ValideProject* self);
gboolean valide_project_accept_file (const char* filename);
char* valide_project_get_real_filename (ValideProject* self, const char* filename);
char* valide_project_get_executable_name (ValideProject* self);
ValideProject* valide_project_new (void);
ValideProject* valide_project_construct (GType object_type);
const char* valide_project_get_path (ValideProject* self);
const char* valide_project_get_name (ValideProject* self);
void valide_project_set_name (ValideProject* self, const char* value);
const char* valide_project_get_author (ValideProject* self);
void valide_project_set_author (ValideProject* self, const char* value);
const char* valide_project_get_version (ValideProject* self);
void valide_project_set_version (ValideProject* self, const char* value);
const char* valide_project_get_license (ValideProject* self);
void valide_project_set_license (ValideProject* self, const char* value);
const char* valide_project_get_builder (ValideProject* self);
void valide_project_set_builder (ValideProject* self, const char* value);
GType valide_builder_options_get_type (void);
ValideBuilderOptions* valide_project_get_builder_options (ValideProject* self);
void valide_project_set_builder_options (ValideProject* self, ValideBuilderOptions* value);
GType valide_executable_options_get_type (void);
ValideExecutableOptions* valide_project_get_executable_options (ValideProject* self);
void valide_project_set_executable_options (ValideProject* self, ValideExecutableOptions* value);
GType valide_recent_manager_ui_get_type (void);
GType valide_project_manager_get_type (void);
ValideRecentManagerUI* valide_recent_manager_ui_new (ValideUIManager* ui_manager, ValideDocumentManager* documents, ValideProjectManager* projects);
ValideRecentManagerUI* valide_recent_manager_ui_construct (GType object_type, ValideUIManager* ui_manager, ValideDocumentManager* documents, ValideProjectManager* projects);
void valide_recent_manager_ui_add_file (ValideRecentManagerUI* self, const char* uri);
void valide_recent_manager_ui_add_project (ValideRecentManagerUI* self, const char* uri);
void valide_recent_manager_ui_update_file (ValideRecentManagerUI* self);
void valide_recent_manager_ui_update_project (ValideRecentManagerUI* self);
ValideUIManager* valide_recent_manager_ui_get_ui_manager (ValideRecentManagerUI* self);
ValideDocumentManager* valide_recent_manager_ui_get_documents (ValideRecentManagerUI* self);
ValideProjectManager* valide_recent_manager_ui_get_projects (ValideRecentManagerUI* self);
GList* valide_recent_manager_ui_get_recent_files (ValideRecentManagerUI* self);
GList* valide_recent_manager_ui_get_recent_projects (ValideRecentManagerUI* self);
GType valide_abstract_config_manager_get_type (void);
GType valide_window_get_type (void);
GType valide_config_manager_get_type (void);
ValideConfigManager* valide_config_manager_get_instance (void);
GType valide_abstract_text_document_get_type (void);
void valide_document_manager_setup_ui (ValideDocumentManager* self);
ValideAbstractTextDocument* valide_document_manager_create_document (ValideDocumentManager* self, const char* filename, GError** error);
ValideDocumentManager* valide_document_manager_new (ValideUIManager* ui_manager);
ValideDocumentManager* valide_document_manager_construct (GType object_type, ValideUIManager* ui_manager);
ValideiDocument* valide_document_manager_create (ValideDocumentManager* self, const char* filename, GError** error);
GQuark valide_project_error_quark (void);
void valide_document_manager_open (ValideDocumentManager* self, GError** error);
gboolean valide_document_manager_save_all (ValideDocumentManager* self);
gboolean valide_document_manager_close_all (ValideDocumentManager* self);
gint valide_document_manager_append_page (ValideDocumentManager* self, ValideiDocument* child);
void valide_document_manager_remove_page (ValideDocumentManager* self, ValideiDocument* child);
ValideiDocument* valide_document_manager_get_nth (ValideDocumentManager* self, gint page_num);
gboolean valide_document_manager_is_open (ValideDocumentManager* self, const char* filename, gint* pos);
ValideUIManager* valide_document_manager_get_ui_manager (ValideDocumentManager* self);
ValideiDocument* valide_document_manager_get_current (ValideDocumentManager* self);
void valide_document_manager_set_current (ValideDocumentManager* self, ValideiDocument* value);
GList* valide_document_manager_get_documents (ValideDocumentManager* self);
GQuark valide_builder_error_quark (void);
ValideBuilderManager* valide_builder_manager_get_instance (void);
void valide_builder_manager_register_builder (ValideBuilderManager* self, GType builder, GType builder_options);
GType valide_executable_manager_get_type (void);
GType valide_builder_get_type (void);
ValideBuilder* valide_builder_manager_create_builder (ValideBuilderManager* self, ValideProject* project, GError** error);
GList* valide_builder_manager_get_builders (ValideBuilderManager* self);
ValideExecutableManager* valide_builder_manager_get_executables (ValideBuilderManager* self);
void valide_builder_manager_set_executables (ValideBuilderManager* self, ValideExecutableManager* value);
GType valide_split_source_view_get_type (void);
ValideSplitSourceView* valide_split_source_view_new (const char* language);
ValideSplitSourceView* valide_split_source_view_construct (GType object_type, const char* language);
void valide_split_source_view_set_editable (ValideSplitSourceView* self, gboolean setting);
guint valide_split_source_view_get_right_margin_position (ValideSplitSourceView* self);
void valide_split_source_view_set_right_margin_position (ValideSplitSourceView* self, guint value);
gboolean valide_split_source_view_get_show_right_margin (ValideSplitSourceView* self);
void valide_split_source_view_set_show_right_margin (ValideSplitSourceView* self, gboolean value);
gboolean valide_split_source_view_get_show_line_numbers (ValideSplitSourceView* self);
void valide_split_source_view_set_show_line_numbers (ValideSplitSourceView* self, gboolean value);
gboolean valide_split_source_view_get_auto_indent (ValideSplitSourceView* self);
void valide_split_source_view_set_auto_indent (ValideSplitSourceView* self, gboolean value);
gboolean valide_split_source_view_get_highlight_current_line (ValideSplitSourceView* self);
void valide_split_source_view_set_highlight_current_line (ValideSplitSourceView* self, gboolean value);
gboolean valide_split_source_view_get_indent_on_tab (ValideSplitSourceView* self);
void valide_split_source_view_set_indent_on_tab (ValideSplitSourceView* self, gboolean value);
gboolean valide_split_source_view_get_insert_spaces_instead_of_tabs (ValideSplitSourceView* self);
void valide_split_source_view_set_insert_spaces_instead_of_tabs (ValideSplitSourceView* self, gboolean value);
guint valide_split_source_view_get_tab_width (ValideSplitSourceView* self);
void valide_split_source_view_set_tab_width (ValideSplitSourceView* self, guint value);
const char* valide_split_source_view_get_language (ValideSplitSourceView* self);
GType valide_source_view_get_type (void);
ValideSourceView* valide_split_source_view_get_active_view (ValideSplitSourceView* self);
GType valide_template_get_type (void);
ValideTemplate* _valide_template_new (const char* filename, GError** error);
const char* valide_template_get_name (ValideTemplate* self);
void valide_template_set_name (ValideTemplate* self, const char* value);
const char* valide_template_get_description (ValideTemplate* self);
void valide_template_set_description (ValideTemplate* self, const char* value);
const char* valide_template_get_path (ValideTemplate* self);
const char* valide_template_get_icon (ValideTemplate* self);
void valide_template_set_icon (ValideTemplate* self, const char* value);
const char* valide_template_get_builder (ValideTemplate* self);
void valide_template_set_builder (ValideTemplate* self, const char* value);
ValideBuilderOptions* valide_template_get_builder_options (ValideTemplate* self);
void valide_template_set_builder_options (ValideTemplate* self, ValideBuilderOptions* value);
GType valide_statusbar_get_type (void);
void valide_statusbar_set_has_resize_grip (ValideStatusbar* self, gboolean show);
void valide_statusbar_set_cursor_position (ValideStatusbar* self, gint line, gint col);
void valide_statusbar_flash_message (ValideStatusbar* self, guint context_id, const char* msg);
ValideStatusbar* valide_statusbar_new (void);
ValideStatusbar* valide_statusbar_construct (GType object_type);
GType valide_abstract_project_dialog_get_type (void);
gpointer valide_abstract_project_dialog_window_widgets_ref (gpointer instance);
void valide_abstract_project_dialog_window_widgets_unref (gpointer instance);
GParamSpec* valide_abstract_project_dialog_param_spec_window_widgets (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_abstract_project_dialog_value_set_window_widgets (GValue* value, gpointer v_object);
gpointer valide_abstract_project_dialog_value_get_window_widgets (const GValue* value);
GType valide_abstract_project_dialog_window_widgets_get_type (void);
GType valide_project_dialog_get_type (void);
void valide_project_dialog_selection_changed (GtkIconView* icon_view, ValideProjectDialog* self);
void valide_project_dialog_project_path_change (GtkWidget* sender, ValideProjectDialog* self);
void valide_project_dialog_show (ValideProjectDialog* self);
guint valide_project_dialog_run (ValideProjectDialog* self);
ValideProjectDialog* valide_project_dialog_new (void);
ValideProjectDialog* valide_project_dialog_construct (GType object_type);
const char* valide_project_dialog_get_project_name (ValideProjectDialog* self);
const char* valide_project_dialog_get_project_author (ValideProjectDialog* self);
const char* valide_project_dialog_get_project_version (ValideProjectDialog* self);
const char* valide_project_dialog_get_project_license (ValideProjectDialog* self);
const char* valide_project_dialog_get_project_dir (ValideProjectDialog* self);
void valide_project_dialog_set_project_dir (ValideProjectDialog* self, const char* value);
const char* valide_project_dialog_get_project_path (ValideProjectDialog* self);
const char* valide_project_dialog_get_lang (ValideProjectDialog* self);
const char* valide_project_dialog_get_builder (ValideProjectDialog* self);
const char* valide_project_dialog_get_template (ValideProjectDialog* self);
void valide_project_dialog_set_project_desc (ValideProjectDialog* self, const char* value);
GType valide_plugin_get_type (void);
const char* valide_plugin_get_path (ValidePlugin* self);
void valide_plugin_set_path (ValidePlugin* self, const char* value);
ValideWindow* valide_plugin_get_window (ValidePlugin* self);
void valide_plugin_set_window (ValidePlugin* self, ValideWindow* value);
const char* g_yaml_buildable_get_name (GYAMLBuildable* self);
void g_yaml_buildable_set_name (GYAMLBuildable* self, const char* name);
void g_yaml_buildable_add_child (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
char** g_yaml_buildable_get_child_tags (GYAMLBuildable* self, int* result_length1);
GType* g_yaml_buildable_get_child_types (GYAMLBuildable* self, int* result_length1);
GList* g_yaml_buildable_get_children (GYAMLBuildable* self, const char* type);
GObject* g_yaml_buildable_get_internal_child (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
void g_yaml_buildable_custom_node (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
gpointer g_yaml_writer_ref (gpointer instance);
void g_yaml_writer_unref (gpointer instance);
GParamSpec* g_yaml_param_spec_writer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void g_yaml_value_set_writer (GValue* value, gpointer v_object);
gpointer g_yaml_value_get_writer (const GValue* value);
GType g_yaml_writer_get_type (void);
GYAMLWriter* g_yaml_writer_new (const char* prefix);
GYAMLWriter* g_yaml_writer_construct (GType object_type, const char* prefix);
GQuark g_yaml_error_quark (void);
void g_yaml_writer_stream_object (GYAMLWriter* self, GObject* object, GString* sb, GError** error);
gint g_yaml_writer_handler (GYAMLWriter* self, gchar* buffer, int buffer_length1);
void* g_yaml_node_get_pointer (GYAMLNode* self);
void g_yaml_node_set_pointer (GYAMLNode* self, void* pointer, GDestroyNotify notify);
GYAMLNode* g_yaml_node_get_resolved (GYAMLNode* self);
GYAMLNode* g_yaml_node_new (void);
GYAMLNode* g_yaml_node_construct (GType object_type);
GType g_yaml_node_alias_get_type (void);
GYAMLNodeAlias* g_yaml_node_alias_new (void);
GYAMLNodeAlias* g_yaml_node_alias_construct (GType object_type);
GType g_yaml_node_scalar_get_type (void);
GYAMLNodeScalar* g_yaml_node_scalar_new (void);
GYAMLNodeScalar* g_yaml_node_scalar_construct (GType object_type);
GType g_yaml_node_sequence_get_type (void);
GYAMLNodeSequence* g_yaml_node_sequence_new (void);
GYAMLNodeSequence* g_yaml_node_sequence_construct (GType object_type);
GType g_yaml_node_mapping_get_type (void);
GYAMLNodeMapping* g_yaml_node_mapping_new (void);
GYAMLNodeMapping* g_yaml_node_mapping_construct (GType object_type);
gpointer g_yaml_document_ref (gpointer instance);
void g_yaml_document_unref (gpointer instance);
GParamSpec* g_yaml_param_spec_document (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void g_yaml_value_set_document (GValue* value, gpointer v_object);
gpointer g_yaml_value_get_document (const GValue* value);
GType g_yaml_document_get_type (void);
GYAMLDocument* g_yaml_document_new_from_parser (yaml_parser_t* parser, GError** error);
GYAMLDocument* g_yaml_document_construct_from_parser (GType object_type, yaml_parser_t* parser, GError** error);
GYAMLDocument* g_yaml_document_new_from_string (const char* str, GError** error);
GYAMLDocument* g_yaml_document_construct_from_string (GType object_type, const char* str, GError** error);
GYAMLDocument* g_yaml_document_new_from_file (FILE* file, GError** error);
GYAMLDocument* g_yaml_document_construct_from_file (GType object_type, FILE* file, GError** error);
GYAMLDocument* g_yaml_document_new (void);
GYAMLDocument* g_yaml_document_construct (GType object_type);
GYAMLBuilder* g_yaml_builder_new (const char* prefix);
GYAMLBuilder* g_yaml_builder_construct (GType object_type, const char* prefix);
void g_yaml_builder_add_from_string (GYAMLBuilder* self, const char* str, GError** error);
void g_yaml_builder_add_from_file (GYAMLBuilder* self, FILE* file, GError** error);
GObject* g_yaml_builder_build_from_string (GYAMLBuilder* self, const char* str, GError** error);
GObject* g_yaml_builder_build_from_file (GYAMLBuilder* self, FILE* file, GError** error);
GObject* g_yaml_builder_build_object (GYAMLBuilder* self, GYAMLNode* node, GType type, GError** error);
GObject* g_yaml_builder_get_object (GYAMLBuilder* self, const char* anchor);
GObject* g_yaml_builder_get_root_object (GYAMLBuilder* self);
GList* g_yaml_builder_get_objects (GYAMLBuilder* self);
GType valide_searching_get_type (void);
ValideSearching* valide_searching_new (ValideAbstractTextDocument* document);
ValideSearching* valide_searching_construct (GType object_type, ValideAbstractTextDocument* document);
gboolean valide_searching_find (ValideSearching* self, gboolean show_replace, gboolean show_dialog);
gboolean valide_searching_find_next (ValideSearching* self);
gboolean valide_searching_find_prev (ValideSearching* self);
void valide_searching_replace (ValideSearching* self, gboolean show_dialog);
gboolean valide_searching_replace_next (ValideSearching* self);
gboolean valide_searching_replace_prev (ValideSearching* self);
void valide_searching_replace_all (ValideSearching* self);
void valide_searching_show_search (ValideSearching* self);
void valide_searching_show_replace (ValideSearching* self);
ValideAbstractTextDocument* valide_searching_get_document (ValideSearching* self);
const char* valide_searching_get_search_text (ValideSearching* self);
void valide_searching_set_search_text (ValideSearching* self, const char* value);
const char* valide_searching_get_replace_text (ValideSearching* self);
void valide_searching_set_replace_text (ValideSearching* self, const char* value);
gboolean valide_searching_get_casse (ValideSearching* self);
void valide_searching_set_casse (ValideSearching* self, gboolean value);
gboolean valide_searching_get_word (ValideSearching* self);
void valide_searching_set_word (ValideSearching* self, gboolean value);
GType valide_abstract_preferences_dialog_get_type (void);
gpointer valide_abstract_preferences_dialog_window_widgets_ref (gpointer instance);
void valide_abstract_preferences_dialog_window_widgets_unref (gpointer instance);
GParamSpec* valide_abstract_preferences_dialog_param_spec_window_widgets (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_abstract_preferences_dialog_value_set_window_widgets (GValue* value, gpointer v_object);
gpointer valide_abstract_preferences_dialog_value_get_window_widgets (const GValue* value);
GType valide_abstract_preferences_dialog_window_widgets_get_type (void);
GType valide_preferences_dialog_get_type (void);
void valide_preferences_dialog_update_editor_param (GtkWidget* sender, ValidePreferencesDialog* self);
void valide_preferences_dialog_update_font_param (GtkWidget* sender, ValidePreferencesDialog* self);
void valide_preferences_dialog_update_projects_param (GtkWidget* sender, ValidePreferencesDialog* self);
ValidePreferencesDialog* valide_preferences_dialog_new (ValideWindow* window);
ValidePreferencesDialog* valide_preferences_dialog_construct (GType object_type, ValideWindow* window);
gint valide_preferences_dialog_run (ValidePreferencesDialog* self);
void valide_preferences_dialog_destroy (ValidePreferencesDialog* self);
ValideWindow* valide_preferences_dialog_get_window (ValidePreferencesDialog* self);
GType valide_start_page_get_type (void);
ValideStartPage* valide_start_page_new (ValideDocumentManager* documents, ValideProjectManager* projects, ValideRecentManagerUI* recents);
ValideStartPage* valide_start_page_construct (GType object_type, ValideDocumentManager* documents, ValideProjectManager* projects, ValideRecentManagerUI* recents);
ValideDocumentManager* valide_start_page_get_documents (ValideStartPage* self);
ValideProjectManager* valide_start_page_get_projects (ValideStartPage* self);
ValideRecentManagerUI* valide_start_page_get_recents (ValideStartPage* self);
GType valide_plugin_registrar_get_type (void);
ValidePluginRegistrar* valide_plugin_registrar_new (const char* filename, ValideWindow* window);
ValidePluginRegistrar* valide_plugin_registrar_construct (GType object_type, const char* filename, ValideWindow* window);
void valide_plugin_registrar_load (ValidePluginRegistrar* self, GError** error);
void valide_plugin_registrar_unload (ValidePluginRegistrar* self, GError** error);
void valide_plugin_registrar_preferences (ValidePluginRegistrar* self);
ValideWindow* valide_plugin_registrar_get_window (ValidePluginRegistrar* self);
const char* valide_plugin_registrar_get_path (ValidePluginRegistrar* self);
gboolean valide_plugin_registrar_get_is_active (ValidePluginRegistrar* self);
gboolean valide_plugin_registrar_get_is_available (ValidePluginRegistrar* self);
const char* valide_plugin_registrar_get_name (ValidePluginRegistrar* self);
const char* valide_plugin_registrar_get_description (ValidePluginRegistrar* self);
const char* valide_plugin_registrar_get_icon_name (ValidePluginRegistrar* self);
const char* valide_plugin_registrar_get_website (ValidePluginRegistrar* self);
const char* valide_plugin_registrar_get_copyright (ValidePluginRegistrar* self);
gboolean valide_plugin_registrar_get_is_configurable (ValidePluginRegistrar* self);
ValidePlugin* valide_plugin_registrar_get_plugin (ValidePluginRegistrar* self);
GType valide_document_message_get_type (void);
ValideDocumentMessage* valide_document_message_new (ValideAbstractTextDocument* document);
ValideDocumentMessage* valide_document_message_construct (GType object_type, ValideAbstractTextDocument* document);
ValideAbstractTextDocument* valide_document_message_get_document (ValideDocumentMessage* self);
GType valide_plugin_manager_get_type (void);
ValidePluginManager* valide_plugin_manager_new (ValideWindow* window);
ValidePluginManager* valide_plugin_manager_construct (GType object_type, ValideWindow* window);
GtkWidget* valide_plugin_manager_preferences (ValidePluginManager* self);
ValideWindow* valide_plugin_manager_get_window (ValidePluginManager* self);
GType valide_plugin_preferences_get_type (void);
ValidePluginPreferences* valide_plugin_preferences_new (ValidePluginManager* plugin_manager);
ValidePluginPreferences* valide_plugin_preferences_construct (GType object_type, ValidePluginManager* plugin_manager);
ValidePluginManager* valide_plugin_preferences_get_plugin_manager (ValidePluginPreferences* self);
void valide_abstract_config_manager_preferences (ValideAbstractConfigManager* self, ValideWindow* window);
void valide_abstract_config_manager_first_run (ValideAbstractConfigManager* self);
char* valide_abstract_config_manager_get_config_file (ValideAbstractConfigManager* self);
char* valide_abstract_config_manager_get_home_dir (ValideAbstractConfigManager* self);
char* valide_abstract_config_manager_get_config_dir (ValideAbstractConfigManager* self);
char* valide_abstract_config_manager_get_tmp_dir (ValideAbstractConfigManager* self);
char* valide_abstract_config_manager_create_preferences_file (ValideAbstractConfigManager* self, const char* filename, const char* contents);
gint valide_abstract_config_manager_get_integer (ValideAbstractConfigManager* self, const char* group, const char* key);
char* valide_abstract_config_manager_get_string (ValideAbstractConfigManager* self, const char* group, const char* key);
gboolean valide_abstract_config_manager_get_boolean (ValideAbstractConfigManager* self, const char* group, const char* key);
void valide_abstract_config_manager_set_integer (ValideAbstractConfigManager* self, const char* group, const char* key, gint val);
void valide_abstract_config_manager_set_string (ValideAbstractConfigManager* self, const char* group, const char* key, const char* val);
void valide_abstract_config_manager_set_boolean (ValideAbstractConfigManager* self, const char* group, const char* key, gboolean val);
GType valide_template_manager_get_type (void);
ValideTemplateManager* valide_template_manager_get_instance (void);
GList* valide_template_manager_get_list (ValideTemplateManager* self);
GType valide_txt_document_get_type (void);
ValideTxtDocument* valide_txt_document_new (void);
ValideTxtDocument* valide_txt_document_construct (GType object_type);
GType valide_gs_document_get_type (void);
ValideGsDocument* valide_gs_document_new (void);
ValideGsDocument* valide_gs_document_construct (GType object_type);
GType valide_vala_document_get_type (void);
ValideValaDocument* valide_vala_document_new (void);
ValideValaDocument* valide_vala_document_construct (GType object_type);
GType valide_vapi_document_get_type (void);
ValideVapiDocument* valide_vapi_document_new (void);
ValideVapiDocument* valide_vapi_document_construct (GType object_type);
GType valide_xml_document_get_type (void);
ValideXmlDocument* valide_xml_document_new (void);
ValideXmlDocument* valide_xml_document_construct (GType object_type);
GType valide_glade_document_get_type (void);
ValideGladeDocument* valide_glade_document_new (void);
ValideGladeDocument* valide_glade_document_construct (GType object_type);
GType valide_ui_document_get_type (void);
ValideUiDocument* valide_ui_document_new (void);
ValideUiDocument* valide_ui_document_construct (GType object_type);
GType valide_goto_dialog_get_type (void);
ValideGotoDialog* valide_goto_dialog_new (ValideSourceView* source_view);
ValideGotoDialog* valide_goto_dialog_construct (GType object_type, ValideSourceView* source_view);
void valide_goto_dialog_show (ValideGotoDialog* self);
ValideSourceView* valide_goto_dialog_get_source_view (ValideGotoDialog* self);
void valide_ui_manager_populate (ValideUIManager* self);
GtkAction* valide_ui_manager_get_action (ValideUIManager* self, const char* name);
void valide_ui_manager_action_set_toggled (ValideUIManager* self, const char* name, gboolean active);
ValideUIManager* valide_ui_manager_new (void);
ValideUIManager* valide_ui_manager_construct (GType object_type);
GType valide_abstract_project_dialog_remove_get_type (void);
gpointer valide_abstract_project_dialog_remove_window_widgets_ref (gpointer instance);
void valide_abstract_project_dialog_remove_window_widgets_unref (gpointer instance);
GParamSpec* valide_abstract_project_dialog_remove_param_spec_window_widgets (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_abstract_project_dialog_remove_value_set_window_widgets (GValue* value, gpointer v_object);
gpointer valide_abstract_project_dialog_remove_value_get_window_widgets (const GValue* value);
GType valide_abstract_project_dialog_remove_window_widgets_get_type (void);
GType valide_project_dialog_remove_get_type (void);
ValideProjectDialogRemove* valide_project_dialog_remove_new (ValideProject* project);
ValideProjectDialogRemove* valide_project_dialog_remove_construct (GType object_type, ValideProject* project);
gint valide_project_dialog_remove_run (ValideProjectDialogRemove* self);
void valide_project_dialog_remove_destroy (ValideProjectDialogRemove* self);
void valide_project_dialog_remove_hide (ValideProjectDialogRemove* self);
ValideProject* valide_project_dialog_remove_get_project (ValideProjectDialogRemove* self);
GList* valide_project_dialog_remove_get_selected_files (ValideProjectDialogRemove* self);
GType valide_source_buffer_get_type (void);
char* valide_source_buffer_get_buffer_contents (ValideSourceBuffer* self);
char* valide_source_buffer_get_contents (ValideSourceBuffer* self, GError** error);
void valide_source_buffer_set_contents (ValideSourceBuffer* self, const char* new_path, GError** error);
char* valide_source_buffer_get_last_word_and_iter (ValideSourceBuffer* self, GtkTextIter* start_word, GtkTextIter* end_word);
char* valide_source_buffer_get_last_word (ValideSourceBuffer* self);
void valide_source_buffer_replace_actual_word (ValideSourceBuffer* self, const char* text);
ValideSourceBuffer* valide_source_buffer_new (void);
ValideSourceBuffer* valide_source_buffer_construct (GType object_type);
const char* valide_source_buffer_get_encoding (ValideSourceBuffer* self);
void valide_source_buffer_set_encoding (ValideSourceBuffer* self, const char* value);
ValideSplitSourceView* valide_abstract_text_document_create_source_view (ValideAbstractTextDocument* self);
char* valide_abstract_text_document_get_contents (ValideAbstractTextDocument* self, GError** error);
void valide_abstract_text_document_set_contents (ValideAbstractTextDocument* self, const char* new_path, GError** error);
void valide_abstract_text_document_grab_focus (ValideAbstractTextDocument* self);
void valide_abstract_text_document_show (ValideAbstractTextDocument* self);
void valide_abstract_text_document_reload (ValideAbstractTextDocument* self);
void valide_abstract_text_document_select_offsets (ValideAbstractTextDocument* self, gint start, gint end);
GdkPixbuf* valide_abstract_text_document_get_icon (ValideAbstractTextDocument* self);
char* valide_abstract_text_document_get_tooltips (ValideAbstractTextDocument* self);
void valide_abstract_text_document_select_range (ValideAbstractTextDocument* self, const ValidePosition* pos);
ValideSourceBuffer* valide_abstract_text_document_get_buffer (ValideAbstractTextDocument* self);
ValideSourceView* valide_abstract_text_document_get_text_view (ValideAbstractTextDocument* self);
gboolean valide_abstract_text_document_get_editable (ValideAbstractTextDocument* self);
void valide_abstract_text_document_set_editable (ValideAbstractTextDocument* self, gboolean value);
const char* valide_abstract_text_document_get_selected_text (ValideAbstractTextDocument* self);
GType valide_about_dialog_get_type (void);
ValideAboutDialog* valide_about_dialog_new (void);
ValideAboutDialog* valide_about_dialog_construct (GType object_type);
ValideProjectManager* valide_project_manager_new (ValideUIManager* ui_manager, ValideDocumentManager* documents, ValideBuilderManager* builders);
ValideProjectManager* valide_project_manager_construct (GType object_type, ValideUIManager* ui_manager, ValideDocumentManager* documents, ValideBuilderManager* builders);
gboolean valide_project_manager_create (ValideProjectManager* self);
gboolean valide_project_manager_open (ValideProjectManager* self, const char* filename, GError** error);
void valide_project_manager_close (ValideProjectManager* self, ValideProject* project);
void valide_project_manager_open_selected_file (ValideProjectManager* self);
void valide_project_manager_remove_selected_file (ValideProjectManager* self);
gboolean valide_project_manager_accept_file (ValideProjectManager* self, const char* filename);
ValideUIManager* valide_project_manager_get_ui_manager (ValideProjectManager* self);
ValideDocumentManager* valide_project_manager_get_documents (ValideProjectManager* self);
ValideBuilderManager* valide_project_manager_get_builders (ValideProjectManager* self);
ValideProject* valide_project_manager_get_current (ValideProjectManager* self);
void valide_project_manager_set_current (ValideProjectManager* self, ValideProject* value);
GType building_step_get_type (void);
void valide_builder_configure (ValideBuilder* self);
void valide_builder_build (ValideBuilder* self);
void valide_builder_install (ValideBuilder* self);
void valide_builder_dist (ValideBuilder* self);
void valide_builder_clean (ValideBuilder* self);
void valide_builder_distclean (ValideBuilder* self);
void valide_builder_uninstall (ValideBuilder* self);
GtkWidget* valide_builder_preferences (ValideBuilder* self);
ValideProject* valide_builder_get_project (ValideBuilder* self);
void valide_builder_set_project (ValideBuilder* self, ValideProject* value);
ValideExecutableManager* valide_builder_get_executables (ValideBuilder* self);
void valide_builder_set_executables (ValideBuilder* self, ValideExecutableManager* value);
GType valide_abstract_project_dialog_options_get_type (void);
gpointer valide_abstract_project_dialog_options_window_widgets_ref (gpointer instance);
void valide_abstract_project_dialog_options_window_widgets_unref (gpointer instance);
GParamSpec* valide_abstract_project_dialog_options_param_spec_window_widgets (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_abstract_project_dialog_options_value_set_window_widgets (GValue* value, gpointer v_object);
gpointer valide_abstract_project_dialog_options_value_get_window_widgets (const GValue* value);
GType valide_abstract_project_dialog_options_window_widgets_get_type (void);
GType valide_project_dialog_options_get_type (void);
ValideProjectDialogOptions* valide_project_dialog_options_new (ValideProject* project, GtkWindow* parent);
ValideProjectDialogOptions* valide_project_dialog_options_construct (GType object_type, ValideProject* project, GtkWindow* parent);
gint valide_project_dialog_options_run (ValideProjectDialogOptions* self);
void valide_project_dialog_options_destroy (ValideProjectDialogOptions* self);
ValideProject* valide_project_dialog_options_get_project (ValideProjectDialogOptions* self);
void valide_idocument_open (ValideiDocument* self, const char* path, GError** error);
void valide_idocument_save (ValideiDocument* self, const char* current_folder);
void valide_idocument_save_as (ValideiDocument* self, const char* current_folder);
void valide_idocument_rename (ValideiDocument* self);
gboolean valide_idocument_close (ValideiDocument* self);
GdkPixbuf* valide_idocument_get_icon (ValideiDocument* self);
char* valide_idocument_get_tooltips (ValideiDocument* self);
void valide_idocument_setup_ui (ValideiDocument* self, ValideUIManager* ui_manager);
ValideDocumentState valide_idocument_get_state (ValideiDocument* self);
void valide_idocument_set_state (ValideiDocument* self, ValideDocumentState value);
gboolean valide_idocument_get_is_save (ValideiDocument* self);
void valide_idocument_set_is_save (ValideiDocument* self, gboolean value);
const char* valide_idocument_get_path (ValideiDocument* self);
void valide_idocument_set_path (ValideiDocument* self, const char* value);
const char* valide_idocument_get_title (ValideiDocument* self);
const char* valide_idocument_get_filename (ValideiDocument* self);
GType valide_panel_get_type (void);
ValidePanel* valide_panel_new (GtkOrientation orientation);
ValidePanel* valide_panel_construct (GType object_type, GtkOrientation orientation);
void valide_panel_add_item (ValidePanel* self, GtkWidget* item, const char* name, GtkImage* image);
void valide_panel_add_item_with_stock_icon (ValidePanel* self, GtkWidget* item, const char* name, const char* stock_id);
void valide_panel_close (ValidePanel* self);
gboolean valide_panel_remove_item (ValidePanel* self, GtkWidget* item);
void valide_panel_set_current_page (ValidePanel* self, GtkWidget* widget);
GtkOrientation valide_panel_get_orientation (ValidePanel* self);
void valide_window_run (ValideWindow* self);
void valide_window_side_panel_show (ValideWindow* self, GtkWidget* widget);
void valide_window_side_panel_hide (ValideWindow* self);
void valide_window_bottom_panel_show (ValideWindow* self, GtkWidget* widget);
void valide_window_bottom_panel_hide (ValideWindow* self);
void valide_window_fullscreen (ValideWindow* self);
void valide_window_unfullscreen (ValideWindow* self);
void valide_window_show_start_page (ValideWindow* self);
void valide_window_hide_start_page (ValideWindow* self);
ValideWindow* valide_window_new (void);
ValideWindow* valide_window_construct (GType object_type);
ValideUIManager* valide_window_get_ui_manager (ValideWindow* self);
ValideRecentManagerUI* valide_window_get_recent_manager (ValideWindow* self);
ValideConfigManager* valide_window_get_config_manager (ValideWindow* self);
ValideDocumentManager* valide_window_get_documents (ValideWindow* self);
ValideProjectManager* valide_window_get_projects (ValideWindow* self);
ValideBuilderManager* valide_window_get_builders (ValideWindow* self);
ValideExecutableManager* valide_window_get_executables (ValideWindow* self);
ValidePluginManager* valide_window_get_plugins (ValideWindow* self);
GtkMenuBar* valide_window_get_menu (ValideWindow* self);
GtkToolbar* valide_window_get_toolbar (ValideWindow* self);
ValidePanel* valide_window_get_side_panel (ValideWindow* self);
ValidePanel* valide_window_get_bottom_panel (ValideWindow* self);
ValideStatusbar* valide_window_get_statusbar (ValideWindow* self);
GQuark valide_executable_error_quark (void);
ValideExecutableManager* valide_executable_manager_new (ValideUIManager* ui_manager);
ValideExecutableManager* valide_executable_manager_construct (GType object_type, ValideUIManager* ui_manager);
void valide_executable_manager_run (ValideExecutableManager* self, ValideExecutable* executable, ValideExecutableOptions* options);
void valide_executable_manager_stop (ValideExecutableManager* self, GError** error);
ValideUIManager* valide_executable_manager_get_ui_manager (ValideExecutableManager* self);
void valide_abstract_preferences_dialog_connect_signal (ValideAbstractPreferencesDialog* self, GtkBuilder* builder, GObject* object, const char* signal_name, const char* handler_name, GObject* connect_objectt, GConnectFlags flags);
void valide_abstract_preferences_dialog_connect_signals (ValideAbstractPreferencesDialog* self, const char* name_space);
ValideAbstractPreferencesDialogwindow_widgets* valide_abstract_preferences_dialog_window_widgets_new (void);
ValideAbstractPreferencesDialogwindow_widgets* valide_abstract_preferences_dialog_window_widgets_construct (GType object_type);
GType valide_abstract_preferences_dialog_window_widget_names_get_type (void);
ValideAbstractPreferencesDialogwindow_widget_names* valide_abstract_preferences_dialog_window_widget_names_dup (const ValideAbstractPreferencesDialogwindow_widget_names* self);
void valide_abstract_preferences_dialog_window_widget_names_free (ValideAbstractPreferencesDialogwindow_widget_names* self);
void valide_abstract_preferences_dialog_window_widget_names_copy (const ValideAbstractPreferencesDialogwindow_widget_names* self, ValideAbstractPreferencesDialogwindow_widget_names* dest);
void valide_abstract_preferences_dialog_window_widget_names_destroy (ValideAbstractPreferencesDialogwindow_widget_names* self);
void valide_abstract_project_dialog_options_connect_signal (ValideAbstractProjectDialogOptions* self, GtkBuilder* builder, GObject* object, const char* signal_name, const char* handler_name, GObject* connect_objectt, GConnectFlags flags);
void valide_abstract_project_dialog_options_connect_signals (ValideAbstractProjectDialogOptions* self, const char* name_space);
ValideAbstractProjectDialogOptionswindow_widgets* valide_abstract_project_dialog_options_window_widgets_new (void);
ValideAbstractProjectDialogOptionswindow_widgets* valide_abstract_project_dialog_options_window_widgets_construct (GType object_type);
GType valide_abstract_project_dialog_options_window_widget_names_get_type (void);
ValideAbstractProjectDialogOptionswindow_widget_names* valide_abstract_project_dialog_options_window_widget_names_dup (const ValideAbstractProjectDialogOptionswindow_widget_names* self);
void valide_abstract_project_dialog_options_window_widget_names_free (ValideAbstractProjectDialogOptionswindow_widget_names* self);
void valide_abstract_project_dialog_options_window_widget_names_copy (const ValideAbstractProjectDialogOptionswindow_widget_names* self, ValideAbstractProjectDialogOptionswindow_widget_names* dest);
void valide_abstract_project_dialog_options_window_widget_names_destroy (ValideAbstractProjectDialogOptionswindow_widget_names* self);
void valide_abstract_project_dialog_remove_connect_signal (ValideAbstractProjectDialogRemove* self, GtkBuilder* builder, GObject* object, const char* signal_name, const char* handler_name, GObject* connect_objectt, GConnectFlags flags);
void valide_abstract_project_dialog_remove_connect_signals (ValideAbstractProjectDialogRemove* self, const char* name_space);
ValideAbstractProjectDialogRemovewindow_widgets* valide_abstract_project_dialog_remove_window_widgets_new (void);
ValideAbstractProjectDialogRemovewindow_widgets* valide_abstract_project_dialog_remove_window_widgets_construct (GType object_type);
GType valide_abstract_project_dialog_remove_window_widget_names_get_type (void);
ValideAbstractProjectDialogRemovewindow_widget_names* valide_abstract_project_dialog_remove_window_widget_names_dup (const ValideAbstractProjectDialogRemovewindow_widget_names* self);
void valide_abstract_project_dialog_remove_window_widget_names_free (ValideAbstractProjectDialogRemovewindow_widget_names* self);
void valide_abstract_project_dialog_remove_window_widget_names_copy (const ValideAbstractProjectDialogRemovewindow_widget_names* self, ValideAbstractProjectDialogRemovewindow_widget_names* dest);
void valide_abstract_project_dialog_remove_window_widget_names_destroy (ValideAbstractProjectDialogRemovewindow_widget_names* self);
void valide_abstract_project_dialog_connect_signal (ValideAbstractProjectDialog* self, GtkBuilder* builder, GObject* object, const char* signal_name, const char* handler_name, GObject* connect_objectt, GConnectFlags flags);
void valide_abstract_project_dialog_connect_signals (ValideAbstractProjectDialog* self, const char* name_space);
ValideAbstractProjectDialogwindow_widgets* valide_abstract_project_dialog_window_widgets_new (void);
ValideAbstractProjectDialogwindow_widgets* valide_abstract_project_dialog_window_widgets_construct (GType object_type);
GType valide_abstract_project_dialog_window_widget_names_get_type (void);
ValideAbstractProjectDialogwindow_widget_names* valide_abstract_project_dialog_window_widget_names_dup (const ValideAbstractProjectDialogwindow_widget_names* self);
void valide_abstract_project_dialog_window_widget_names_free (ValideAbstractProjectDialogwindow_widget_names* self);
void valide_abstract_project_dialog_window_widget_names_copy (const ValideAbstractProjectDialogwindow_widget_names* self, ValideAbstractProjectDialogwindow_widget_names* dest);
void valide_abstract_project_dialog_window_widget_names_destroy (ValideAbstractProjectDialogwindow_widget_names* self);
GType valide_abstract_native_builder_preferences_get_type (void);
gpointer valide_abstract_native_builder_preferences_window_widgets_ref (gpointer instance);
void valide_abstract_native_builder_preferences_window_widgets_unref (gpointer instance);
GParamSpec* valide_abstract_native_builder_preferences_param_spec_window_widgets (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_abstract_native_builder_preferences_value_set_window_widgets (GValue* value, gpointer v_object);
gpointer valide_abstract_native_builder_preferences_value_get_window_widgets (const GValue* value);
GType valide_abstract_native_builder_preferences_window_widgets_get_type (void);
void valide_abstract_native_builder_preferences_connect_signal (ValideAbstractNativeBuilderPreferences* self, GtkBuilder* builder, GObject* object, const char* signal_name, const char* handler_name, GObject* connect_objectt, GConnectFlags flags);
void valide_abstract_native_builder_preferences_connect_signals (ValideAbstractNativeBuilderPreferences* self, const char* name_space);
ValideAbstractNativeBuilderPreferenceswindow_widgets* valide_abstract_native_builder_preferences_window_widgets_new (void);
ValideAbstractNativeBuilderPreferenceswindow_widgets* valide_abstract_native_builder_preferences_window_widgets_construct (GType object_type);
GType valide_abstract_native_builder_preferences_window_widget_names_get_type (void);
ValideAbstractNativeBuilderPreferenceswindow_widget_names* valide_abstract_native_builder_preferences_window_widget_names_dup (const ValideAbstractNativeBuilderPreferenceswindow_widget_names* self);
void valide_abstract_native_builder_preferences_window_widget_names_free (ValideAbstractNativeBuilderPreferenceswindow_widget_names* self);
void valide_abstract_native_builder_preferences_window_widget_names_copy (const ValideAbstractNativeBuilderPreferenceswindow_widget_names* self, ValideAbstractNativeBuilderPreferenceswindow_widget_names* dest);
void valide_abstract_native_builder_preferences_window_widget_names_destroy (ValideAbstractNativeBuilderPreferenceswindow_widget_names* self);
void valide_abstract_close_dialog_connect_signal (ValideAbstractCloseDialog* self, GtkBuilder* builder, GObject* object, const char* signal_name, const char* handler_name, GObject* connect_objectt, GConnectFlags flags);
void valide_abstract_close_dialog_connect_signals (ValideAbstractCloseDialog* self, const char* name_space);
ValideAbstractCloseDialogwindow_widgets* valide_abstract_close_dialog_window_widgets_new (void);
ValideAbstractCloseDialogwindow_widgets* valide_abstract_close_dialog_window_widgets_construct (GType object_type);
GType valide_abstract_close_dialog_window_widget_names_get_type (void);
ValideAbstractCloseDialogwindow_widget_names* valide_abstract_close_dialog_window_widget_names_dup (const ValideAbstractCloseDialogwindow_widget_names* self);
void valide_abstract_close_dialog_window_widget_names_free (ValideAbstractCloseDialogwindow_widget_names* self);
void valide_abstract_close_dialog_window_widget_names_copy (const ValideAbstractCloseDialogwindow_widget_names* self, ValideAbstractCloseDialogwindow_widget_names* dest);
void valide_abstract_close_dialog_window_widget_names_destroy (ValideAbstractCloseDialogwindow_widget_names* self);
GType valide_abstract_executable_preferences_get_type (void);
gpointer valide_abstract_executable_preferences_window_widgets_ref (gpointer instance);
void valide_abstract_executable_preferences_window_widgets_unref (gpointer instance);
GParamSpec* valide_abstract_executable_preferences_param_spec_window_widgets (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_abstract_executable_preferences_value_set_window_widgets (GValue* value, gpointer v_object);
gpointer valide_abstract_executable_preferences_value_get_window_widgets (const GValue* value);
GType valide_abstract_executable_preferences_window_widgets_get_type (void);
void valide_abstract_executable_preferences_connect_signal (ValideAbstractExecutablePreferences* self, GtkBuilder* builder, GObject* object, const char* signal_name, const char* handler_name, GObject* connect_objectt, GConnectFlags flags);
void valide_abstract_executable_preferences_connect_signals (ValideAbstractExecutablePreferences* self, const char* name_space);
ValideAbstractExecutablePreferenceswindow_widgets* valide_abstract_executable_preferences_window_widgets_new (void);
ValideAbstractExecutablePreferenceswindow_widgets* valide_abstract_executable_preferences_window_widgets_construct (GType object_type);
GType valide_abstract_executable_preferences_window_widget_names_get_type (void);
ValideAbstractExecutablePreferenceswindow_widget_names* valide_abstract_executable_preferences_window_widget_names_dup (const ValideAbstractExecutablePreferenceswindow_widget_names* self);
void valide_abstract_executable_preferences_window_widget_names_free (ValideAbstractExecutablePreferenceswindow_widget_names* self);
void valide_abstract_executable_preferences_window_widget_names_copy (const ValideAbstractExecutablePreferenceswindow_widget_names* self, ValideAbstractExecutablePreferenceswindow_widget_names* dest);
void valide_abstract_executable_preferences_window_widget_names_destroy (ValideAbstractExecutablePreferenceswindow_widget_names* self);
GType valide_native_builder_preferences_get_type (void);
void valide_native_builder_preferences_add_vapi_dir (GtkWidget* sender, ValideNativeBuilderPreferences* self);
void valide_native_builder_preferences_del_vapi_dir (GtkWidget* sender, ValideNativeBuilderPreferences* self);
void valide_native_builder_preferences_row_add_pkg (GtkTreeView* sender, const GtkTreePath* path, GtkTreeViewColumn* column, ValideNativeBuilderPreferences* self);
void valide_native_builder_preferences_row_del_pkg (GtkTreeView* sender, const GtkTreePath* path, GtkTreeViewColumn* column, ValideNativeBuilderPreferences* self);
void valide_native_builder_preferences_add_pkg (GtkWidget* sender, ValideNativeBuilderPreferences* self);
void valide_native_builder_preferences_del_pkg (GtkWidget* sender, ValideNativeBuilderPreferences* self);
void valide_native_builder_preferences_show_help (GtkButton* sender, ValideNativeBuilderPreferences* self);
ValideNativeBuilderPreferences* valide_native_builder_preferences_new (ValideProject* project);
ValideNativeBuilderPreferences* valide_native_builder_preferences_construct (GType object_type, ValideProject* project);
ValideProject* valide_native_builder_preferences_get_project (ValideNativeBuilderPreferences* self);
GList* valide_native_builder_preferences_get_pkg (ValideNativeBuilderPreferences* self);
GList* valide_native_builder_preferences_get_vapi_dir (ValideNativeBuilderPreferences* self);
GType valide_native_builder_options_get_type (void);
ValideNativeBuilderOptions* valide_native_builder_options_new (void);
ValideNativeBuilderOptions* valide_native_builder_options_construct (GType object_type);
gboolean valide_native_builder_options_get_debug (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_debug (ValideNativeBuilderOptions* self, gboolean value);
gboolean valide_native_builder_options_get_thread (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_thread (ValideNativeBuilderOptions* self, gboolean value);
gboolean valide_native_builder_options_get_disable_assert (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_disable_assert (ValideNativeBuilderOptions* self, gboolean value);
gboolean valide_native_builder_options_get_disable_checking (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_disable_checking (ValideNativeBuilderOptions* self, gboolean value);
gboolean valide_native_builder_options_get_disable_non_null (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_disable_non_null (ValideNativeBuilderOptions* self, gboolean value);
gboolean valide_native_builder_options_get_save_temps (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_save_temps (ValideNativeBuilderOptions* self, gboolean value);
gboolean valide_native_builder_options_get_quiet (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_quiet (ValideNativeBuilderOptions* self, gboolean value);
const char* valide_native_builder_options_get_other (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_other (ValideNativeBuilderOptions* self, const char* value);
GType valide_native_builder_get_type (void);
ValideNativeBuilder* valide_native_builder_new (ValideProject* project);
ValideNativeBuilder* valide_native_builder_construct (GType object_type, ValideProject* project);
ValideSourceView* valide_source_view_new (const char* language);
ValideSourceView* valide_source_view_construct (GType object_type, const char* language);
void valide_source_view_scroll_to_cursor (ValideSourceView* self);
gboolean valide_source_view_goto_line (ValideSourceView* self, gint line);
const char* valide_source_view_get_language (ValideSourceView* self);
ValideSourceBuffer* valide_source_view_get_buffer (ValideSourceView* self);
void valide_source_view_set_buffer (ValideSourceView* self, ValideSourceBuffer* value);
void valide_source_view_set_font (ValideSourceView* self, const char* value);
void valide_source_view_set_style_scheme (ValideSourceView* self, const char* value);
GType valide_environment_variable_get_type (void);
ValideEnvironmentVariable* valide_environment_variable_new (const char* name, const char* value);
ValideEnvironmentVariable* valide_environment_variable_construct (GType object_type, const char* name, const char* value);
char* valide_environment_variable_to_string (ValideEnvironmentVariable* self);
const char* valide_environment_variable_get_name (ValideEnvironmentVariable* self);
void valide_environment_variable_set_name (ValideEnvironmentVariable* self, const char* value);
const char* valide_environment_variable_get_value (ValideEnvironmentVariable* self);
void valide_environment_variable_set_value (ValideEnvironmentVariable* self, const char* value);
char** valide_executable_options_get_environment_variables (ValideExecutableOptions* self, int* result_length1);
ValideExecutableOptions* valide_executable_options_new (void);
ValideExecutableOptions* valide_executable_options_construct (GType object_type);
const char* valide_executable_options_get_program (ValideExecutableOptions* self);
void valide_executable_options_set_program (ValideExecutableOptions* self, const char* value);
const char* valide_executable_options_get_arguments (ValideExecutableOptions* self);
void valide_executable_options_set_arguments (ValideExecutableOptions* self, const char* value);
const char* valide_executable_options_get_working_dir (ValideExecutableOptions* self);
void valide_executable_options_set_working_dir (ValideExecutableOptions* self, const char* value);
GType valide_executable_preferences_get_type (void);
void valide_executable_preferences_add_variable (GtkButton* sender, ValideExecutablePreferences* self);
void valide_executable_preferences_modify_variable (GtkButton* sender, ValideExecutablePreferences* self);
void valide_executable_preferences_delete_variable (GtkButton* sender, ValideExecutablePreferences* self);
void valide_executable_preferences_on_program_changed (GtkButton* sender, ValideExecutablePreferences* self);
ValideExecutablePreferences* valide_executable_preferences_new (ValideProject* project);
ValideExecutablePreferences* valide_executable_preferences_construct (GType object_type, ValideProject* project);
ValideProject* valide_executable_preferences_get_project (ValideExecutablePreferences* self);
char* valide_executable_get_start_msg (ValideExecutable* self);
char* valide_executable_get_end_msg (ValideExecutable* self);
GdkColor valide_executable_get_color_line (ValideExecutable* self, char** line);
void valide_executable_line_activated (ValideExecutable* self, const char* line);
char* valide_executable_cmd_start (ValideExecutable* self, const char* cmd);
char* valide_executable_cmd_end (ValideExecutable* self, gint status, double time);
GtkWidget* valide_executable_preferences (ValideProject* project);
ValideExecutable* valide_executable_new (void);
ValideExecutable* valide_executable_construct (GType object_type);
const char* valide_executable_get_executable (ValideExecutable* self);
void valide_executable_set_executable (ValideExecutable* self, const char* value);

static const char* VALIDE_PROJECT_FILE_EXT[] = {"vide"};
static const char* VALIDE_PLUGIN_REGISTRAR_FILE_EXT[] = {"valide-plugin"};
static const ValideAbstractPreferencesDialogwindow_widget_names VALIDE_ABSTRACT_PREFERENCES_DIALOG_widget_info[] = {{0, "GtkDialog", "dialog"}, {1, "GtkVBox", "vbox"}, {2, "GtkNotebook", "notebook"}, {3, "GtkVBox", "frame_editor"}, {4, "GtkFrame", "frame1"}, {5, "GtkAlignment", "alignment1"}, {6, "GtkVBox", "vbox1"}, {7, "GtkCheckButton", "auto_indent"}, {8, "GtkCheckButton", "insert_spaces_instead_of_tabs"}, {9, "GtkCheckButton", "indent_on_tab"}, {10, "GtkHBox", "hbox2"}, {11, "GtkLabel", "label5"}, {12, "GtkSpinButton", "tab_width"}, {13, "GtkLabel", "label3"}, {14, "GtkFrame", "frame2"}, {15, "GtkAlignment", "alignment2"}, {16, "GtkVBox", "vbox2"}, {17, "GtkCheckButton", "show_right_margin"}, {18, "GtkHBox", "hbox3"}, {19, "GtkLabel", "label7"}, {20, "GtkSpinButton", "right_margin_position"}, {21, "GtkLabel", "label6"}, {22, "GtkFrame", "frame4"}, {23, "GtkAlignment", "alignment4"}, {24, "GtkCheckButton", "show_line_numbers"}, {25, "GtkLabel", "label11"}, {26, "GtkFrame", "frame5"}, {27, "GtkAlignment", "alignment5"}, {28, "GtkCheckButton", "highlight_current_line"}, {29, "GtkLabel", "label12"}, {30, "GtkLabel", "label1"}, {31, "GtkVBox", "vbox4"}, {32, "GtkFrame", "frame3"}, {33, "GtkAlignment", "alignment3"}, {34, "GtkHBox", "hbox4"}, {35, "GtkLabel", "label8"}, {36, "GtkFontButton", "font"}, {37, "GtkLabel", "label2"}, {38, "GtkFrame", "frame6"}, {39, "GtkAlignment", "alignment6"}, {40, "GtkScrolledWindow", "scrolledwindow1"}, {41, "GtkTreeView", "style_scheme"}, {42, "GtkLabel", "label14"}, {43, "GtkLabel", "label13"}, {44, "GtkVBox", "vbox3"}, {45, "GtkHBox", "hbox5"}, {46, "GtkLabel", "label10"}, {47, "GtkFileChooserButton", "default_directory"}, {48, "GtkLabel", "label9"}, {49, "GtkHButtonBox", "dialog-action_area1"}, {49, "GtkHButtonBox", "dialog_action_area1"}, {50, "GtkButton", "button"}, {0, NULL, NULL}};
static const ValideAbstractProjectDialogOptionswindow_widget_names VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_widget_info[] = {{0, "GtkListStore", "liststore1"}, {1, "GtkDialog", "dialog"}, {2, "GtkVBox", "dialog-vbox"}, {2, "GtkVBox", "dialog_vbox"}, {3, "GtkHBox", "hbox"}, {4, "GtkScrolledWindow", "scrolled_window"}, {5, "GtkIconView", "icon_view"}, {6, "GtkNotebook", "notebook"}, {7, "GtkTable", "table1"}, {8, "GtkLabel", "label7"}, {9, "GtkLabel", "label8"}, {10, "GtkLabel", "label9"}, {11, "GtkLabel", "label10"}, {12, "GtkLabel", "path"}, {13, "GtkEntry", "name"}, {14, "GtkEntry", "author"}, {15, "GtkEntry", "version"}, {16, "GtkLabel", "label11"}, {17, "GtkLabel", "license"}, {18, "GtkLabel", "label1"}, {19, "GtkComboBox", "builder"}, {20, "GtkHButtonBox", "dialog-action_area1"}, {20, "GtkHButtonBox", "dialog_action_area1"}, {21, "GtkButton", "button1"}, {0, NULL, NULL}};
static const ValideAbstractProjectDialogRemovewindow_widget_names VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_widget_info[] = {{0, "GtkDialog", "dialog"}, {1, "GtkVBox", "vbox"}, {2, "GtkLabel", "label"}, {3, "GtkScrolledWindow", "scrolled_window"}, {4, "GtkTreeView", "tree_view"}, {5, "GtkHButtonBox", "dialog_action_area"}, {6, "GtkButton", "button1"}, {7, "GtkButton", "button2"}, {0, NULL, NULL}};
static const ValideAbstractProjectDialogwindow_widget_names VALIDE_ABSTRACT_PROJECT_DIALOG_widget_info[] = {{0, "GtkAssistant", "assistant"}, {1, "GtkLabel", "page1"}, {2, "GtkVBox", "page2"}, {3, "GtkScrolledWindow", "scrolledwindow1"}, {4, "GtkIconView", "icon_view"}, {5, "GtkHBox", "hbox1"}, {6, "GtkLabel", "label1"}, {7, "GtkComboBox", "lang_combo"}, {8, "GtkCellRendererText", "renderer1"}, {9, "GtkFrame", "frame1"}, {10, "GtkAlignment", "alignment1"}, {11, "GtkLabel", "desc_label"}, {12, "GtkLabel", "label4"}, {13, "GtkScrolledWindow", "page3"}, {14, "GtkViewport", "viewport1"}, {15, "GtkTable", "table1"}, {16, "GtkLabel", "label2"}, {17, "GtkLabel", "label3"}, {18, "GtkLabel", "label6"}, {19, "GtkEntry", "name_entry"}, {20, "GtkEntry", "path_entry"}, {21, "GtkLabel", "label7"}, {22, "GtkLabel", "label8"}, {23, "GtkLabel", "label9"}, {24, "GtkEntry", "author_entry"}, {25, "GtkEntry", "version_entry"}, {26, "GtkComboBox", "licenses_combo"}, {27, "GtkFileChooserButton", "dir_chooser"}, {28, "GtkLabel", "label5"}, {29, "GtkComboBox", "builder"}, {30, "GtkListStore", "model1"}, {31, "GtkListStore", "liststore1"}, {0, NULL, NULL}};
static const ValideAbstractNativeBuilderPreferenceswindow_widget_names VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_widget_info[] = {{0, "GtkNotebook", "notebook"}, {1, "GtkVBox", "frame_general"}, {2, "GtkCheckButton", "debug"}, {3, "GtkCheckButton", "thread"}, {4, "GtkCheckButton", "disable_assert"}, {5, "GtkCheckButton", "disable_checking"}, {6, "GtkCheckButton", "disable_non_null"}, {7, "GtkCheckButton", "save_temps"}, {8, "GtkCheckButton", "quiet"}, {9, "GtkHBox", "hbox1"}, {10, "GtkLabel", "label6"}, {11, "GtkEntry", "other"}, {12, "GtkButton", "info_button"}, {13, "GtkImage", "image2"}, {14, "GtkLabel", "label1"}, {15, "GtkVBox", "vbox1"}, {16, "GtkFrame", "frame_pkg"}, {17, "GtkAlignment", "alignment1"}, {18, "GtkHBox", "hbox2"}, {19, "GtkScrolledWindow", "scrolledwindow1"}, {20, "GtkTreeView", "tree_view_src"}, {21, "GtkVBox", "vbox3"}, {22, "GtkButton", "button_add"}, {23, "GtkImage", "image3"}, {24, "GtkButton", "button_del"}, {25, "GtkImage", "image4"}, {26, "GtkScrolledWindow", "scrolledwindow2"}, {27, "GtkTreeView", "tree_view_dst"}, {28, "GtkLabel", "label4"}, {29, "GtkFrame", "frame_vapi"}, {30, "GtkAlignment", "alignment2"}, {31, "GtkVBox", "vbox4"}, {32, "GtkHBox", "hbox3"}, {33, "GtkFileChooserButton", "file_chooser_button"}, {34, "GtkButton", "button3"}, {35, "GtkButton", "button4"}, {36, "GtkScrolledWindow", "scrolledwindow3"}, {37, "GtkTreeView", "tree_view_vapi"}, {38, "GtkLabel", "label5"}, {39, "GtkLabel", "label2"}, {0, NULL, NULL}};
static const ValideAbstractCloseDialogwindow_widget_names VALIDE_ABSTRACT_CLOSE_DIALOG_widget_info[] = {{0, "GtkListStore", "list_store"}, {1, "GtkDialog", "dialog"}, {2, "GtkVBox", "dialog-vbox1"}, {2, "GtkVBox", "dialog_vbox1"}, {3, "GtkVBox", "vbox1"}, {4, "GtkHBox", "hbox1"}, {5, "GtkImage", "image1"}, {6, "GtkVBox", "vbox2"}, {7, "GtkLabel", "label"}, {8, "GtkLabel", "label3"}, {9, "GtkTreeView", "tree_view"}, {10, "GtkLabel", "label1"}, {11, "GtkHButtonBox", "dialog-action_area1"}, {11, "GtkHButtonBox", "dialog_action_area1"}, {12, "GtkButton", "button1"}, {13, "GtkButton", "button2"}, {14, "GtkButton", "button3"}, {0, NULL, NULL}};
static const ValideAbstractExecutablePreferenceswindow_widget_names VALIDE_ABSTRACT_EXECUTABLE_PREFERENCES_widget_info[] = {{0, "GtkTable", "table"}, {1, "GtkLabel", "label2"}, {2, "GtkEntry", "executable_arguments"}, {3, "GtkLabel", "label3"}, {4, "GtkEntry", "executable_program"}, {5, "GtkButton", "button2"}, {6, "GtkLabel", "label4"}, {7, "GtkFileChooserButton", "executable_working_dir"}, {8, "GtkExpander", "expander1"}, {9, "GtkVBox", "vbox1"}, {10, "GtkScrolledWindow", "scrolledwindow1"}, {11, "GtkTreeView", "tree_view"}, {12, "GtkHButtonBox", "hbuttonbox1"}, {13, "GtkButton", "button1"}, {14, "GtkButton", "button3"}, {15, "GtkButton", "button4"}, {16, "GtkLabel", "label5"}, {0, NULL, NULL}};

G_END_DECLS

#endif
