
#ifndef __DEBUG_PLUGINS_TODO_TODO_H__
#define __DEBUG_PLUGINS_TODO_TODO_H__

#include <glib.h>
#include <glib-object.h>
#include <valide-0.0.h>

G_BEGIN_DECLS


#define TYPE_TODO (todo_get_type ())
#define TODO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TODO, Todo))
#define TODO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TODO, TodoClass))
#define IS_TODO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TODO))
#define IS_TODO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TODO))
#define TODO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TODO, TodoClass))

typedef struct _Todo Todo;
typedef struct _TodoClass TodoClass;
typedef struct _TodoPrivate TodoPrivate;

/**
 * @todo Add support for author, like C::B
 */
struct _Todo {
	GObject parent_instance;
	TodoPrivate * priv;
};

struct _TodoClass {
	GObjectClass parent_class;
};


GType todo_get_type (void);
Todo* todo_new (void);
Todo* todo_construct (GType object_type);
GType register_plugin (void);


G_END_DECLS

#endif
